##################
#
# klasa addCapdPreamble

package addCapdPreamble;

use strict;
use suffices;
use dirTree;
use utilities;
use vars qw(@ISA);


@ISA = ("dirTree");


################################
#
# Konstruktor
#
sub new{
  my $class=shift;
  my ($dir,$suff_list,$autor,$copyright) = @_;
  my $self=$class->SUPER::new(@_);
  $self->{param}->{suffices}=new suffices($suff_list);
  $self->{param}->{author}=$autor;
  $self->{param}->{copyright}=$copyright;
  return $self;
}


#############################################
#
# processFile
#
sub processFile{
  my ($self,$fullFileName)=@_;
  my $processed=0;
  if($self->{param}->{suffices}->contains($fullFileName)){
    open(IN,"<$fullFileName") || die("generate_slides: Failed to open file $fullFileName\n");
    $fullFileName =~ /^(.*[\/])([-a-zA-Z_]+\.[a-zA-Z]+)$/;
    my ($dir,$file)=($1,$2);
    print "Processing $file($fullFileName)\n";
    my $text;
    my $skip=0;
    while(<IN>){
      $skip = 1 if($_ =~ /^\/\/\/ \@addtogroup/);
      $skip = 1 if($_ =~ /^\/\/\/ \@}/);
      $text.=$_ if(!$skip);
      $skip = 0 if($_ =~ /^\/\/ MA 02111-1307/);
    }
    close(IN);
#    my $group="homologicalAlgebra";
    my $group="";
    if($dir =~ /(\w+)[\\\/]?$/){
      $group=$1;
    };
#print "Matching $dir Got group =$group=\n";

    open(OUT,">$fullFileName") || die("generate_slides: Failed to open file $fullFileName\n");
    my $outtext=<<END
/// \@addtogroup $group
/// \@{

/////////////////////////////////////////////////////////////////////////////
/// \@file $file
///
/// \@author $self->{param}->{author}
/////////////////////////////////////////////////////////////////////////////

// $self->{param}->{copyright}
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

END
    ;
    $outtext.=$text;
    $outtext.=<<END
/// @}

END
    ;
    print OUT $outtext;
    close(OUT);
    $processed=1;
  }
  return $processed;
}

#############################################
#
# processFile
#
sub processFileOld{
  my ($self,$fullFileName)=@_;
  my $processed=0;
  if($self->{param}->{suffices}->contains($fullFileName)){
    open(IN,"<$fullFileName") || die("generate_slides: Failed to open file $fullFileName\n");
    $fullFileName =~ /^(.*[\/])([-a-zA-Z_]+\.[a-zA-Z]+)$/;
    my ($dir,$file)=($1,$2);
    print "Processing $file\n";
    my $size = -s $fullFileName;
    my $text;
    read(IN,$text,$size);
    close(IN);
    open(OUT,">$fullFileName") || die("generate_slides: Failed to open file $fullFileName\n");
    my $outtext=<<END
/// \@addtogroup matrixAlgorithms
/// \@{

/////////////////////////////////////////////////////////////////////////////
/// \@file $file
///
/// \@author Marian Mrozek
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2006 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

END
    ;
    $outtext.=$text;
    $outtext.=<<END
/// @}

END
    ;
    print OUT $outtext;
    close(OUT);
    $processed=1;
  }
  return $processed;
}

1;