##################
#
# klasa addMmPreamble

package addMmPreamble;

use strict;
use suffices;
use dirTree;
use utilities;
use vars qw(@ISA);


@ISA = ("dirTree");


################################
#
# Konstruktor
#
sub new{
  my $class=shift;
  my ($dir,$suff_list,$copyright,$year,$headerLineLength) = @_;
  my $self=$class->SUPER::new(@_);
  $self->{param}->{suffices}=new suffices($suff_list);
  $self->{param}->{copyright}=$copyright;
  $self->{param}->{year}=$year;
  $self->{param}->{headerLineLength}=$headerLineLength;
  return $self;
}

################################
#
# Format
#
sub format{
  my ($self,$text,$char,$length) = @_;
  my $textlength=length($text);
  if($textlength>=$length){
    return $text;
  }else{
    my $leftn=int(($length-$textlength)/2);
    my $rightn=$length-$leftn-$textlength;
    my $outtext='';
    for(my $i=0;$i<$leftn;++$i){
      $outtext.=$char;
    }
    $outtext.=$text;
    for(my $i=0;$i<$rightn;++$i){
      $outtext.=$char;
    }
    return $outtext;
  }
}


#############################################
#
# processFile
#
sub processFile{
  my ($self,$fullFileName)=@_;
  my $processed=0;
  if($self->{param}->{suffices}->contains($fullFileName)){
    open(IN,"<$fullFileName") || die("generate_slides: Failed to open file $fullFileName\n");
    if($fullFileName !~ /^(.*[\/])([-a-zA-Z0-9_]+)\.([a-zA-Z0-9]+)$/){
      print "Matching failed for $fullFileName\n";
    }
    my ($dir,$baseName,$ext)=($1,$2,$3);
    my $file="$baseName.$ext";
    print "Processing $file\n";
    my $text;
    my $skip=0;
    my $behindPreamble=0;
    my $title=$file;
    my $year=$self->{param}->{year};
    my $gotTitle=0;
    while(<IN>){
      chomp;
      if(!$behindPreamble && $_ =~ /^\s*\/\*+\s*([^*]*)\s*\*+\/\s*$/){
        my $c=$1;
        if($c =~ /Marian\s+Mrozek\s*.\s*Krak.w\s*(\d+)/){
          $year=$1;
    print "   Got year $year\n";
        }elsif(!$gotTitle){
          $gotTitle=1;
          $title=$c;
    print "   Got title $title\n";
        }
      }elsif($_ =~ /\S/){
        $behindPreamble=1;
      }
      if($behindPreamble){
        $text.="$_\n";
      }
    }
    close(IN);

    my $copyright=" $self->{param}->{copyright} $self->{param}->{year} ";
    $title=" $title ";
    my $headerLineLength=length($copyright);
    $headerLineLength=length($title) if(length($title)>$headerLineLength);
    $headerLineLength+=6;
    $title=$self->format($title,'*',$headerLineLength);
    $copyright=$self->format($copyright,'*',$headerLineLength);
    open(OUT,">$fullFileName") || die("generate_slides: Failed to open file $fullFileName\n");
    my $outtext='';
    $outtext.="/$title/\n";
    $outtext.="/$copyright/\n";
    $outtext.="\n";
    $outtext.=$text;
    print OUT $outtext;
    close(OUT);
    $processed=1;
  }
  return $processed;
}

1;