##################
#
# klasa archivizeDirTree
#
# klasa suy do rekursywnego usuwania zbytecznych plikw z katalogw
#

package archivizeDirTree;

use strict;
use suffices;
use dirTree;
use utilities;
use vars qw(@ISA);


@ISA = ("dirTree");


################################
#
# Konstruktor
#
sub new{
  my $class=shift;
  my ($dir,$marker) = @_;
  my $self=$class->SUPER::new(@_);
  $marker="@" if(!$marker);
  $self->{param}->{marker}=$marker; # Notice: marker must be @ - not finished for general marker
  mkdir('archive',0770) unless (-d 'archive');
  return $self;
}


#############################################
#
# preProcessDir
#
sub preProcessDir{
  my ($self,$fullFileName)=@_;
  if($self->{currentFile} eq 'archive'){
    $self->{currentFile}='';
    return;
  }
#  my $archDir=$self->{currentFileWithPathFromBaseDir}.'/archive';
  my $archDir=$fullFileName.'/archive';
# print "Making $archDir\n";
  mkdir($archDir,0770) if(!(-d $archDir));
}

#############################################
#
# processFile
#
sub processFile{
  my ($self,$fullFileName)=@_;
  my $processed=0;
  my $markedFile=$self->{currentFile} =~ /^(.*)(\@+)$/; # Notice: marker must be @ - not finished for general marker
  my $modifiedName=$1;
  my $marker=$2;
#print "??? $self->{currentFile}, $modifiedName, $marker, $self->{param}->{marker}\n";
  if($markedFile){
    my $newFileName=$self->{param}->{baseDir}.$self->{dir}."archive/$modifiedName";
#print " ---> $fullFileName, $newFileName\n";
    rename $fullFileName,$newFileName;
    $processed=1;
  }
  return $processed;
}

1;