##################
#
# klasa buildCppIncludeDigraph
# (c) Marian Mrozek 2006
#
#
# klasa suy do budowania digrafu zalenoci
# pomidzy plikami *.cpp *.hpp *.h *.c *.cc
# indukowanego poprzez dyrektywy #include
#
# Under construction!!!!!

package buildCppIncludeDigraph;

use strict;
use dirTree;
use utilities;
use suffices;
use vars qw(@ISA);


@ISA = ("dirTree");


################################
#
# Konstruktor
#
sub new{
  my $class=shift;
  my $self=$class->SUPER::new(@_);
  my $dir=shift;
  my $includeHashRef=shift;   # Reference to hash { fileName -> ref to hash of included files }
  $self->{suffices}=new suffices("cpp,hpp,h,c,cc");
  $self->{includeHashRef}=$includeHashRef;
  return $self;
}




################################
#
# LookFile: opens the file and
# determines the way it should
# be processed from the first line
#
# Also checks if the file uses krak library
#
sub lookFile{
  my ($self,$file) = @_;

  my $includedFiles={}; # Reference to hash { fileName -> 1 } (only keys matter)
  open(INP,"<$file");
  while(1){
    my $line=<INP>;
    last if(!$line);
    chop($line);
    if($line =~ /\s*\#\s*include\s+\"([^\"]+)\"/){
      my $key=$1;
      if($key =~ /\.\.\/(src.*)$/){
        $key=$1;
      }else{
        $key="include/$key";
      }
      $includedFiles->{$key}=1;
      print "    $key\n" if($main::opt_v);
    }
  };
# print "   lookFile returning includeFilesHashRef for $file is $includedFiles\n";
  return $includedFiles;
}


#############################################
#
# preProcessDir
#
sub preProcessDir{
  my ($self)=@_;
   if($self->{currentFile} =~ /^(bin|obj|lib|CVS|doc|make|perl)$/){
     $self->{currentFile} = '';
   }
}

#############################################
#
# processFile
#
sub processFile{
  my ($self,$fullFileName)=@_;
  my $file=$self->{currentFileWithPathFromBaseDir};
  my $processed=0;
  if($self->{suffices}->contains($self->{currentFile})){
    print "File $file includes\n" if($main::opt_v);
    $self->{includeHashRef}->{$file} = $self->lookFile($fullFileName);
#print "   Inserting to  $self->{includeHashRef}\n";
#print "   Record for $file is $self->{includeHashRef}->{$file}\n";
    $processed=1;
  }
  return $processed;
}


#############################################

1;