##################
#
# klasa checkCompilation
# (c) Marian Mrozek 2007
#
#
# klasa suy do wyszukiwania w biecym
# katalogu i podkatalogach plikw, ktre si nie kompiluj
#

package checkCompilation;

use strict;
use dirTree;
use utilities;
use suffices;
use vars qw(@ISA);
use Executor;



@ISA = ("dirTree");


################################
#
# Konstruktor
#
sub new{
  my $class=shift;
  my $self=$class->SUPER::new(@_);
  my $dir=shift;
  my $includeHashRef=shift;   # Reference to hash { fileName -> ref to hash of included files }
  $self->{suffices}=new suffices("cpp,cs,java,pas,f,f90,scm");
  $self->{includeHashRef}=$includeHashRef;
  return $self;
}




#############################################
#
# preProcessDir
#
sub preProcessDir{
  my ($self) = @_;
  if($self->{currentFile} eq 'archive'){
    $self->{skip}=1;
  }
  chdir($self->{currentFile});
  my $dir=pwd();
#  print "................. $dir\n";
}

#############################################
#
# postProcessDir
#
sub postProcessDir{
  my ($self) = @_;
  $self->{skip}=0;
  chdir('..');
}

################################
#
# LookFile: Determine if the file contains main executable entry
#
sub isMain{
  my ($self,$file) = @_;

  my $ismain=0;
  open(INP,"<$file");
  LOOP:
  while(1){
    my $line=<INP>;
    last if(!$line);
    chop($line);
    if( $line =~ /main\(/i ){
      $ismain=1;
      last LOOP;
    }
  };
  return $ismain;
}


#############################################
#
# processFile
#
sub processFile{
  my ($self,$fullFileName)=@_;
  my $file=$self->{currentFileWithPathFromBaseDir};
  my $processed=0;
  if($self->{suffices}->contains($self->{currentFile})){
    # print "Testing $file\n" if($main::opt_v);
    my $baseName=$self->{currentFile};
    if($self->{currentFile} =~ /^(.*)\.\w+/){
      $baseName=$1;
    }
    if(!$self->{skip}){
      if(!($self->{currentFileWithPathFromBaseDir} =~ /archive/ ) ){
        my $executor=new Executor;
        my $processMainOnly=1;
        print "-- Checking $self->{currentFile}\n";
        my $error=$executor->process($fullFileName,$processMainOnly);
        if($error){
          print " *=*=*=> $fullFileName has problems\n";
          $main::nonCompilingFiles.=<<END
          <li> <a href=$self->{currentFileWithPathFromBaseDir}>$self->{currentFile}</a>
END
          ;
        }
      }
      unlink "$baseName.obj" if(-r "$baseName.obj");
      unlink "$baseName.exe" if(-r "$baseName.exe");

      $processed=1;
    }
  }
  return $processed;
}


#############################################

1;