##################
#
# klasa cleanDirTree
#
# klasa suy do rekursywnego usuwania zbytecznych plikw z katalogw
#

package cleanDirTree;

use strict;
use suffices;
use dirTree;
use utilities;
use vars qw(@ISA);


@ISA = ("dirTree");


################################
#
# Konstruktor
#
sub new{
  my $class=shift;
  my ($dir,$suff_list,$wastebinDir) = @_;
  my $self=$class->SUPER::new(@_);
  $self->{param}->{suffices}=new suffices($suff_list);
  if($wastebinDir){
    if($self->{param}->{baseDir} =~ /^(.*)\/$/){
      $wastebinDir="$1.wastebin";
    }else{
      die("cleanDirTree::new: no ending \"/\" in baseDir found\n")
    }
    $self->{param}->{wastebinDir}=dirSlash($wastebinDir);
    mkdir($wastebinDir,0770) unless (-d $wastebinDir);
  }
  return $self;
}


#############################################
#
# preProcessDir
#
sub preProcessDir{
  my ($self,$fullFileName)=@_;
  if($fullFileName =~ /\.wastebin$/){
    $self->{currentFile}='';
    return;
  }
  my $newDirName=$self->{param}->{wastebinDir}.$self->{currentFileWithPathFromBaseDir};
  mkdir($newDirName,0770) if(!(-d $newDirName));
}

#############################################
#
# processFile
#
sub processFile{
  my ($self,$fullFileName)=@_;
  my $processed=0;
  if($self->{param}->{suffices}->contains($fullFileName)){
    if($self->{param}->{wastebinDir}){
      my $newName=$self->{param}->{wastebinDir}.$self->{currentFileWithPathFromBaseDir};
      rename($fullFileName,$newName) if(!$main::opt_t);
      print "Renamed $fullFileName to $newName\n" if($main::opt_v);
    }else{
      unlink($fullFileName) if(!$main::opt_t);
      print "Removing $fullFileName\n" if($main::opt_v);
    }
    $processed=1;
  }
  return $processed;
}

1;