##################
#
# klasa clearMarkedFilesInDirTree
#
# klasa suy do rekursywnego odznaczania wszystkich
# plikw oznaczonych  znakiem @
#

package clearMarkedFilesInDirTree;

use strict;
use dirTree;
use utilities;
use vars qw(@ISA);


@ISA = ("dirTree");


################################
#
# Konstruktor
#
sub new{
  my $class=shift;
  my ($dir,$marker) = @_;
  my $self=$class->SUPER::new(@_);
  my $self = {};
  if($dir eq '.' || $dir eq ''){
    $dir=pwd();
  }
  $dir =~ s/\\/\//g;
  if(-d $dir){
    $self->{param}->{baseDir}=dirSlash($dir);
  }else{
    die("dirTree->new: $dir is not a valid directory name" );
  }
  $marker="@" if(!$marker);
  $self->{marker}=$marker; # Notice: marker must be @ - not finished for general marker
  $self->{dir}='';
  bless($self,$class);
  return $self;
}


#############################################
#
# processFile
#
sub processFile{
  my ($self,$fullFileName)=@_;

#print "ClearTrying $fullFileName\n";
  # Unmark files marked earlier and remaining with mark for some bad reason
  if($fullFileName =~ /^([^@]*)(\@+)$/){  # Notice: marker must be @ - not finished for general marker
    my $originalName=$1;
    if(-r $originalName){
      unlink $fullFileName;
#print " --- removed overmarked =$fullFileName= because original exists=\n";
    }else{
      rename $fullFileName,$originalName;
#print " --- renamed overmarked =$fullFileName= to original name =$originalName=\n";
    }
    return 1;
  }
  return 0;
}

1;