##################
#
# klasa convertDirTree
#

package convertDirTree;

use strict;
use dirTree;
use utilities;
use suffices;
use vars qw(@ISA);


@ISA = ("dirTree");


################################
#
# Konstruktor
#
sub new{
  my $class=shift;
  my ($dir,$inSuf,$outSuf,$command) = @_;
  print "convertDirTree $dir,$inSuf,$outSuf,$command}\n" if($main::opt_v);
  my $self=$class->SUPER::new(@_);
  $self->{param}->{suf}=new suffices($inSuf);
  $self->{param}->{inext}=$inSuf;
  $self->{param}->{outext}=$outSuf;
  $self->{param}->{command}=$command;
  return $self;
}

#############################################
#
# processFile
#
sub processFile{
  my ($self,$fullFileName)=@_;
  print "Processing $self->{currentFile}\n" if($main::opt_v);
  if($self->{param}->{suf}->contains($self->{currentFile})){
    open(IN,"<$fullFileName") || die("convertDirTree: Failed to open file $fullFileName\n");
    my $basename;
    my $command;
    if($self->{currentFile} =~ /^(.*)\.(\w+)$/){
      $basename=$1;
    }else{
      die("Failed to determine basename\n");
    }
    my $command="$self->{param}->{command} $self->{currentFile} $basename.$self->{param}->{outext}";
#    $command="$self->{param}->{command}=$command $self->{currentFile} $basename.$self->{param}->{outext}";
    print "Doing $command\n";
    my $out=`$command`;
    print "$out\n";
  }
  return 1;
}

1;