##################
#
# klasa copyDirTree
#
# klasa suy do rekursywnego kopiowania wybranych zawartoci
# katalogu
#

package copyDirTree;

use strict;
use dirTree;
use utilities;
use fileClasses;
use vars qw(@ISA);


@ISA = ("dirTree");


################################
#
# Konstruktor
#
sub new{
  my $class=shift;
  my ($dir,$newBaseDir,$filePattern,$dirPattern) = @_;
  my $self=$class->SUPER::new(@_);
  $filePattern='.*' if(!$filePattern);
  $dirPattern='#' if(!$dirPattern);
  $self->{param}->{fileClasses}=new fileClasses($filePattern);
  $self->{param}->{dirClasses}=new fileClasses($dirPattern);

  mkdir($newBaseDir,0770) if(!(-d $newBaseDir));

  if(-d $newBaseDir){
    $self->{param}->{newBaseDir}=dirSlash($newBaseDir);
  }else{
    die("dirTree->new: $newBaseDir is not a valid directory name" );
  }
  return $self;
}


#############################################
#
# preProcessDir
#
sub preProcessDir{
  my ($self,$fullFileName)=@_;
  my $newDirName=$self->{param}->{newBaseDir}.$self->{currentFileWithPathFromBaseDir};
  if($self->{param}->{dirClasses}->contains($fullFileName)){
    $self->{currentFile}='';
    return;
  }else{
    mkdir($newDirName,0770) if(!(-d $newDirName) && !$main::opt_t);
    print "newDir:  $newDirName\n" if($main::opt_v);
  }
}

#############################################
#
# processFile
#
sub processFile{
  my ($self,$fullFileName)=@_;
  my $processed=0;
  if($self->{param}->{fileClasses}->contains($fullFileName)){
    my $newName=$self->{param}->{newBaseDir}.$self->{currentFileWithPathFromBaseDir};
    copy($fullFileName,$newName) if(!$main::opt_t);
    print "copying  $fullFileName,$newName\n" if($main::opt_v);
    $processed=1;
  }
  return $processed;
}

#############################################

1;