###############################
#
# Klasa copyExamTreeDirSelector
#
# (c) Marian Mrozek 1996-2003
#
# Klasa uywana do wyboru katalogw
# przy klonowaniu gazi plikw egzaminw
#

package copyExamTreeDirSelector;

use Tk;
use FileDialog;
use Tk::DirSelect;
use utilities;
use strict;
require Tk::ROText;

################################
#
# Konstruktor
#

sub new{
  my $class = shift;
  my $self = {};
  bless($self,$class);
#  $self->{Bin} = shift;

  $self->{starterEgzaminatora} = shift;
  $self->{par} = $self->{starterEgzaminatora}->{par};

  return $self;
}


###########################################################################
#
# Tworzy gwne okno i wypenia je pocztkow treci
#

sub wyswietlOkno{
  my ($self)=@_;
  $self->{mainWindow} = $self->{starterEgzaminatora}->{starterWindow}->Toplevel();
#  $self->{mainWindow} = MainWindow->new;
  $self->{mainWindow}->minsize(700,200);
  $self->{mainWindow}->title("copyExamTreeDirSelector");

#  $self->{font}=$self->{mainWindow}->fontCreate('headingX', -size => 14, -weight => 'bold');

print "Exiting1\n";

  my $title=$self->{mainWindow}->Text(-width => 40, -height => 1, -relief => 'ridge', -background => 'gray', -font => 'heading')->
    pack(-side => 'top', -anchor => 'c', -fill => 'x', -expand => 1);

  my $copyright=$self->{mainWindow}->Text(-width => 40, -height => 1, -relief => 'ridge', -background => 'gray')->
    pack(-side => 'bottom', -anchor => 'e', -fill => 'x', -expand => 1);

  $self->{fromButton}=$self->{mainWindow}->Button(-text => "Wybierz katalog rdowy", -command => ['selectSource' => $self] )->
    pack(-side => 'top', -anchor => 'c');

  $self->{fromDir}=$self->{mainWindow}->Text(-width => 40, -height => 1, -relief => 'ridge', -background => 'gray')->
    pack(-side => 'top', -anchor => 'c', -fill => 'x', -expand => 1);

  $self->{toButton}=$self->{mainWindow}->Button(-text => "Wybierz katalog docelowy", -command => ['selectDestination' => $self] )->
    pack(-side => 'top', -anchor => 'c');

  $self->{toDir}=$self->{mainWindow}->Text(-width => 40, -height => 1, -relief => 'ridge', -background => 'gray')->
    pack(-side => 'top', -anchor => 'c', -fill => 'x', -expand => 1);

  $self->{zakonczButton}=$self->{mainWindow}->Button(-text => "Wykonaj", -command => ['finish' => $self] )->
    pack(-side => 'top', -anchor => 'c');

print "Exiting2\n";


  $title->insert('0.0',"CopyExamDirTree 0.9");
  $copyright->insert('0.0',"Marian Mrozek, Krakw - Nowy Scz, 1996-2003");
}

###########################################################################
#
# Dokonuje wyboru katalogu, w ktrym bdzie pracowa egzaminator
#

sub selectSource{
  my ($self)=@_;


  my $start_dir='d:/_wyklady';

  # Wybieramy katalog przy uyciu DirSelect

#  $self->{DSRef} = $self->{mainWindow}->DirSelect(-width => 60,-dir => $start_dir);
#  my $dir = $self->{DSRef}->Show(-width => 70,-dir => $start_dir);
  $self->{DSRef} = $self->{mainWindow}->DirSelect(-title => "Wybierz katalog rdowy");
  my $dir = $self->{DSRef}->Show($start_dir);
  $self->{'sourceDir'}=$dir;
  $self->{fromDir}->insert('0.0',"Katalog rdowy: $dir");
}

###########################################################################
#
# Dokonuje wyboru katalogu, w ktrym bdzie pracowa egzaminator
#

sub selectDestination{
  my ($self)=@_;


  my $start_dir='d:/_wyklady';

  # Wybieramy katalog przy uyciu DirSelect

#  $self->{DSRef} = $self->{mainWindow}->DirSelect(-width => 60,-dir => $start_dir);
#  my $dir = $self->{DSRef}->Show(-width => 70,-dir => $start_dir);
  $self->{DSRef} = $self->{mainWindow}->DirSelect(-title => "Wybierz lokalizacj katalogu docelowego");
  my $dir = $self->{DSRef}->Show($start_dir);
  $self->{'destDir'}=$dir;
  $self->{toDir}->insert('0.0',"Katalog docelowy: $dir");
}

###########################################################################
#
# Koczy prac
#

sub finish{

  my ($self,$par)=@_;
    my $answer=$self->{mainWindow}->Dialog(
         -title => 'Kopiowanie egzaminw',
         -text => 'Czy przenie powtarzalne pliki zgodnie z dokonanym wyborem katalogw?',
         -default_button => 'Tak',
         -buttons => ['Tak','Nie'],
       )->Show();
    if($answer eq 'Tak'){
      $self->{doIt}=1;
    }

  $self->{mainWindow}->destroy();
}


###########################################################################

1;