##################
#
# klasa copyMarkedFilesInDirTree
#
# klasa suy do rekursywnego kopiowania oznaczonych zawartoci
# katalogu
#

package copyMarkedFilesInDirTree;

use strict;
use dirTree;
use utilities;
use vars qw(@ISA);


@ISA = ("dirTree");


################################
#
# Konstruktor
#
sub new{
  my $class=shift;
  my ($dir,$newBaseDir,$selectedFilesRef,$excludedDirs) = @_;
  my $self=$class->SUPER::new(@_);
  $self->{selectedFiles}=$selectedFilesRef;
  my @exclDirs=split(',',$excludedDirs);
  $self->{excludedDirs}={};
  foreach my $dir (@exclDirs){
    $self->{excludedDirs}->{$dir}=1;
  }

  mkdir($newBaseDir,0770) if(!(-d $newBaseDir));

  if(-d $newBaseDir){
    $self->{newBaseDir}=dirSlash($newBaseDir);
  }else{
    die("dirTree->new: $newBaseDir is not a valid directory name" );
  }
  return $self;
}


#############################################
#
# preProcessDir
#
sub preProcessDir{
  my ($self,$fullFileName)=@_;
  my $file=$self->{currentFileWithPathFromBaseDir};
  my $newDirName=$self->{newBaseDir}.$self->{currentFileWithPathFromBaseDir};
  if(!$self->{excludedDirs}->{$file}){
    mkdir($newDirName,0770) if(!(-d $newDirName) && !$main::opt_t);
#    print "dir $file, newDir:  $newDirName\n" if($main::opt_v);
  }
}

#############################################
#
# processFile
#
sub processFile{
  my ($self,$fullFileName)=@_;
  my $processed=0;
  my $file=$self->{currentFileWithPathFromBaseDir};
# print "Trying  $file\n" if($main::opt_v);
# my $hashRef=$self->{selectedFiles};
# print "Trying $hashRef with key $file\n";
  if($self->{selectedFiles}->{$file}){
    my $newName=$self->{newBaseDir}.$file;
    copy($fullFileName,$newName) if(!$main::opt_t);
    print "copying  $file,$newName\n" if($main::opt_v);
    $processed=1;
  }
  return $processed;
}

#############################################

1;