##################
#
# klasa markFilesInDirTree
#
# klasa suy do rekursywnego oznaczania wszystkich
# plikw poprzez dodanie znaku(w) do rozszerzenia
#

package markFilesInDirTree;

use strict;
use dirTree;
use utilities;
use vars qw(@ISA);


@ISA = ("dirTree");


################################
#
# Konstruktor
#
sub new{
  my $class=shift;
  my ($dir,$minDepth,$marker) = @_;
  my $self=$class->SUPER::new(@_);
  my $self = {};
  if($dir eq '.' || $dir eq ''){
    $dir=pwd();
  }
  $dir =~ s/\\/\//g;
  if(-d $dir){
    $self->{param}->{baseDir}=dirSlash($dir);
  }else{
    die("dirTree->new: $dir is not a valid directory name" );
  }
  $minDepth=0 if(!$minDepth);
  $marker="@" if(!$marker);
  $self->{minDepth}=$minDepth;
  $self->{marker}=$marker; # Notice: marker must be @ - not finished for general marker
  $self->{dir}='';
  bless($self,$class);
  return $self;
}


#############################################
#
# preProcessDir
#
sub preProcessDir{
  my ($self,$fullFileName)=@_;
  if($self->{currentFile} eq 'archive'){
    $self->{currentFile}='';
  }
}

#############################################
#
# processFile
#
sub processFile{
  my ($self,$fullFileName)=@_;

#print "MarkTrying $fullFileName with depth =$self->{depth}= and minDepth=$self->{minDepth}=\n";
  if($fullFileName =~ /^([^@]*)(\@+)$/ || $fullFileName =~ /\.pdf$/){
#print "  --- skippeda $fullFileName\n" if($main::opt_v);
    return 0;
  }
  my $newName = $fullFileName.$self->{marker};
  # Now mark the file unless depth is not deep enough
  if($self->{depth} >= $self->{minDepth}){
    rename $fullFileName,$newName;
#print "  --- marked $fullFileName to $newName\n" if($main::opt_v);
    return 1;
  }else{
#print "  --- skippedb $fullFileName\n" if($main::opt_v);
    return 0;
  }
}

1;