##################
#
# klasa verifyGccCompilation
#
# klasa suy do generownia plikw *.exe wykonujcych odpowiednie
# pliki *.pl pod DOSem
#
# Under construction!!!!!

package verifyGccCompilation;

use strict;
use dirTree;
use utilities;
use vars qw(@ISA);


@ISA = ("dirTree");


################################
#
# Konstruktor
#
sub new{
  my $class=shift;
  my ($dir) = @_;
  my $self=$class->SUPER::new(@_);
  return $self;
}




################################
#
# LookFile: opens the file and
# determines the way it should
# be processed from the first line
#
# Also checks if the file uses krak library
#
sub lookFile{
  my ($self,$file) = @_;

  my $found=0;
  my $line;
  my $win=0;
  my $firstLine;

  open(INP,"<$file");
  while(1){
    $line=<INP>;
    last if(!$line);
    chop($line);
    if($line =~ /^(\/\/!|%!|\#!)(.*)$/){
      $firstLine=$2;
      $found=1;
      # testing for krak lib
    }elsif($line =~ /openGraphics/){
      $win=1;
      last;
    }elsif($line =~ /^#include "(krak-lib|krak-edu)/){
      $win=1;
      last;
    }
  };

  if(!$found){
    $self->{executor}='';
    $self->{options}= $win ? 'win' : '';
  }elsif($firstLine =~ /^\s*(\w+)\s+(.*)$/){
    $self->{executor}=$1;
    $self->{options}=$2;
  }elsif($firstLine =~ /^\s*(\w+)\s*$/){
    $self->{executor}=$1;
    $self->{options}='';
  }else{
    print "Incorrect syntax of the executor line\n";
  }
  $self->{options}='win '.$self->{options} if($win && $self->{options} !~ /win/);
  # print "Found executor=$self->{executor} options=$self->{options}\n";
}

################################
#
# Compile
#
sub compile{
  my ($self,$fullFileName)=@_;
  if($self->{'options'} =~ /^\s*win\s+(.*)$/ || $self->{'options'} =~ /^\s*win\s*$/){
     $self->{'options'}="-s -mwindows $1";
     $self->{'libraries'}.=" -lkrak " unless $self->{'libraries'} =~ /capd/;
  }
  my $compilerDir='Dev-Cpp';
  my $systemIncludeDirs=
       "-Ic:\\$compilerDir\\include\\ -Ic:\\$compilerDir\\include\\c++\\backward\\ -Id:\\so_c\\capd\\include\\";
  my $command=
       "C:\\$compilerDir\\Bin\\g++.exe -ansi $self->{options} $self->{fileName} -o $self->{baseName}.exe  $self->{libraries} -I.\\ $self->{par}->{includeDirs} $systemIncludeDirs -LC:\\$compilerDir\\Lib\\ -L.\\ -BC:\\$compilerDir\\Bin\\ ";

print "Doing: $command\n";
  my $error=system($command);
  if($error){
    print "\n===========******** Errors found *********=============\n";
    return 1;
  }else{
    return 0;
  }
}


#############################################
#
# processFile
#
sub processFile{
  my ($self,$fullFileName)=@_;
  my $processed=0;
  if($self->{currentFile} =~ /^(.*)\.cpp$/){
    $self->look_file($fullFileName);
    $self->compile()
    $processed=1;
  }
  return $processed;
}

#############################################

1;