##################
#
# klasa abstrakcyjna answerForm
#
# klasa generuje i przetwarza formularze odpowiedzi testu
# formularze generowane s imiennie dla studentw z podanej grupy
#

package answerForm;

use utilities;
use binary;
use FindBin qw($Bin);
use raport;

################################
#
# Konstruktor
#
sub new{
  my ($class, $par, $iloscProblemow, $iloscOpcji, $pierwszyWolnyNr, $raport) = @_;
  my $self = {};
  bless($self,$class);

  $self->{raport} = $raport;
  $self->{par}=$par;

  $self->{iloscProblemow}=0 + $iloscProblemow;
print "Ilosc Problemow = $self->{iloscProblemow}\n";
  $self->{iloscOpcji}=0 + $iloscOpcji;
  $self->{pierwszyWolnyNr}=0 + $pierwszyWolnyNr;

  # Obliczam jak ma wygladac formularz
  my $iloscPytanWKolumnie;
  my $iloscPytanFormularza;
  my $iloscKolumn;

  if ($self->{iloscProblemow} <= 25){
     $iloscPytanFormularza = 25;
     $iloscPytanWKolumnie = 25;
     $iloscKolumn = 1;
  }
# W aktualnej wersji z kolumnami nie mieci si na stronie 30 pyta
#  elsif ($self->{iloscProblemow} <= 30){
#     $iloscPytanFormularza = 30;
#     $iloscPytanWKolumnie = 30;
#     $iloscKolumn = 1;
#  }
  elsif  ($self->{iloscProblemow} <= 50){
     $iloscPytanFormularza = 50;
     $iloscPytanWKolumnie = 25;
     $iloscKolumn = 2;
  }
# Jeli jest wicej ni 50 pyta, nie ma wzorca do aktualnej wersji
  else{
$self->{raport}->zakoncz( "Potrzebujesz formularza na $self->{iloscProblemow} problemw\n".
                          "Do aktualnej wersji egzaminatora brak jeszcze wzorca FineReadera\n".
                          " przy liczbie problemw przekraczajcej 50 pyta.\n".
                          "Skontaktuj si z autorem programu\n");
     $iloscPytanFormularza = 120;
     $iloscPytanWKolumnie = 40;
     $iloscKolumn = 3;
  }

  $self->{iloscPytanFormularza} = $iloscPytanFormularza;
  $self->{iloscPytanWKolumnie} = $iloscPytanWKolumnie;
  $self->{iloscKolumn} = $iloscKolumn;

  $self->{rozstawMarkerow}="90mm";
  $self->{typ}="MTB-A4-$iloscPytanFormularza-$iloscOpcji";
  my $iloscPytanWzorcaFineReadera=($iloscPytanFormularza<=50?50:$iloscPytanFormularza);
  my $iloscOpcjiWzorcaFineReadera=
     $self->{iloscOpcjiWzorcaFineReadera}=($iloscOpcji<=5?5:$iloscOpcji);
  $self->{typWzorcaFineReadera}="MTB-A4-$iloscPytanWzorcaFineReadera-$iloscOpcjiWzorcaFineReadera";

  my $rozdzielczosc =  ($iloscProblemow > 50) ? "10pt" : "12pt";
    $self->{formHead}=<<END
  \\documentclass[$rozdzielczosc]{article}
  \\pagestyle{empty}
  \\usepackage{polski}
  \\usepackage[cp1250]{inputenc}
END
    ;

#wpisuje tu wprost wszystkie definicje ktre potrzebuje w pliku texowym

  open(TEXDEF,"<$Bin/egzaminator/definicjeGeneratoraTestow.tex");
  my $znacznik = $/;
  undef $/;   #przeczytam caly plik na raz
  my $texDefinicje = <TEXDEF>;
  close(TEXDEF);
  $/ = $znacznik; #przywracam stara warto separatora
#Wpisuje wprost definicje do naglwka
  $self->{formHead}.=<<END
\\setlength{\\textheight}{275mm}
\\setlength{\\textwidth}{190mm}
END
  ;
  $self->{formHead} .= $texDefinicje;

  $self->{formHead} .= "\\begin{document}\n";
  $self->{formHead} .= "\\let\\showanswers y\n";

  $self->{formTail}=<<END
  \\end{document}
END
    ;

return $self;
}




################################
#
# Generuje zapasowe kody i numery studentw, jako plik w Tex'u
# Moga byc wykorzystane gdy zglosi sie student,
# ktrego nie bylo na liscie
#
sub generujWolneNumeryStudentow{
  my ($self, $test, $extra) = @_;
  my $output='';

  $output.= "\n\\begin{center}\\bf\\Large Zapasowe Numery Studentw\\end{center}\n\n";


  my $info= <<END

\\begin{tabular}{l}
      {\\bf Kurs: $test->{kurs}}\\\\
      {\\bf Test: $test->{test}}\\\\
      {\\bf Data: $test->{data}}\\\\
      {\\bf Sala: $test->{sala}}\\\\
      \\hfill
-----------------------------------------------------------\\\\
\\end{tabular}

{\\bf Informacja:}\\\\
Na t list mona wpisa studentw, dla ktrych nie ma przygotowanych
formularzy odpowiedzi. Pozycje Nazwisko, Imi, Indeks, ExamId
dopisanych studentw naley dopisa do pliku w katalogu studenci
o nazwie koczcej si na\\\\
   studenci-suplement.csv\\\\
Mona te w tym pliku poda dodatkowe dane: numerOsoby i numerProtokolu.
Natomiast w katalogu studenci w pliku korekta.csv
mona poda bezporednio ocen lub punktacj testu. Wtedy ocena wyliczona zostanie
anulowana i zastpiona podan w pliku korekta.csv. To si przydaje
przy ocenach przepisanych z innego indeksu, by znalazy si w protokole.\\
Pola naley rozdziela rednikami.\\\\
\\par
{\\bf Uwaga}: dopisywanie studentw do pliku o nazwie\\\\
   nazwaBazowaTestu.sei\\\\
w katalogu gwnym jest zaszoci i moe le dziaa!!!\\\\
\\par
Ostatnia kolumna pozwala odszuka
odpowiedni formularz odpowiedzi, na ktrym student te powinien
wpisa swoje nazwisko, imi i numer indeksu.

\\noindent
\\begin{tabular}{||l|l|l|c|l||}
\\hline
\\hline
{\\bf Nazwisko} & {\\bf Imi} &{\\bf Indeks} &{\\bf ExamId} & {\\bf Kod} \\\\
\\hline
\\hline
END
  ;
  $output.= $info;
  for(my $i = $test->{pierwszyZapasowyExamId}; $i <= $test->{ostatniZapasowyExamId}; $i++){
    my $nrStud = $i;
    my $kod_studenta=toBinForm($nrStud,$test->{ilosc_okienek_kodu},'--','crc');
    $output.= "\\hspace*{4cm}&";
    $output.= "\\hspace*{4cm}&";
    $output.= "\\hspace*{2cm}&";
    $output.= "$nrStud &";
    $output.= "$kod_studenta\\\\\n";
    $output.= "\\hline\n";
  };
  $output.= <<END
\\hline
\\hline
\\end{tabular}
\\newpage
END
  ;


#  print ZAPASOWE $self->{formTail};
#  close(ZAPASOWE);
  return $output;
}




################################
#
# Generator pustego klucza odpowiedzi
# (potrzebny, bo z wyjtkiem formularza
# kontrolnego odpowiedzi nie drukujemy!!!)
#
sub generateEmptyCopyAnswerKey{
  my ($self)=@_;
  my ($copyAnswerKey,$i,$j);
  for($i=0;$i<$self->{iloscProblemow};$i++){  #POPRAWILEM 8.01.2001 bylo =1 .... <=
    for($j=0;$j<$self->{iloscOpcji};$j++){
      $copyAnswerKey->[$i]->[$j] = 0;
    }
  }
  return $copyAnswerKey;
}

################################
#
# Generator formy formularza w TeXu
#
sub generateCopy{
  my ($self,$test,$student,$nrStudenta,$copyAnswerKey)=@_;
  my ($numerEdycjiTerminu,$numerGrupySal)=($self->{par}->{numerEdycjiTerminu},$self->{par}->{numerGrupySal});

  my $form;

  my $iloscPytanFormularza = $self->{iloscPytanFormularza};
  my $iloscPytanWKolumnie = $self->{iloscPytanWKolumnie};
  my $iloscKolumn = $self->{iloscKolumn};

  $nrStudenta=eject_blanks($nrStudenta);
  my $numerStudentaSformatowany=fill_with_zeros($nrStudenta,3);
  my $wydrukId="$numerEdycjiTerminu:$numerGrupySal:$numerStudentaSformatowany";
  my $wydrukNrTestu="$numerEdycjiTerminu$numerGrupySal-";

  # Zmienna do \begin{tabular} przy wypisywaniu kwadracikw na odpowiedzi
# Poprawka z 12.07.2003 majca na celu drukowanie 5 opcji w formularzu
# odpowiedzi nawet jeli de facto uywanych jest mniej opcji odpowiedzi
#  my $string_do_tabular = "l" x ($self->{iloscOpcji} + 1);
  my $string_do_tabular = "l" x ($self->{iloscOpcjiWzorcaFineReadera} + 1);

  # Ujemny numer studenta oznacza, e drukujemy formularz wzorcowy
  # Trzeba wtedy wyspacjowa rne dane
  if($nrStudenta < 0){
    $wydrukId=$numerGrupySal=$numerEdycjiTerminu=$wydrukNrTestu="";
    $nrStudenta=0;
  }

  my $kodTerminu=toBinForm($numerEdycjiTerminu,3,'','crc');
  my $kodSali=toBinForm($numerGrupySal,3,'','crc');
  my $kod_studenta=toBinForm($nrStudenta,$test->{ilosc_okienek_kodu},'--','crc');
  my $kod_testu=toBinForm(0,$test->{ilosc_okienek_kodu});
  my $czyZalega=($student->{czyZalega} eq 'T' ? '(!?!)' : '');
  $self->{liczbaZaleglosci}++ if($czyZalega);
  # Nazwisko lub imi zaczynajce si od polskiej litery powoduje zmian
  # ukadu linii, co moe powodowa problemy z odszyfrowaniem
  # formularza przez FineReadera. Dlatego dokonujemy modyfikacji
  my $nazwisko=$student->{nazwisko};
  if($nazwisko =~ /^\s*([ƌӯ])(.*)$/){
    $nazwisko="{\\small $1}$2";
  }
  my $imie=$student->{imie};
  if($imie =~ /^\s*([ƌӯ])(.*)$/){
    $imie="{\\small $1}$2";
  }


  $form= <<END
\\begin{center}\\bf\\Large
    Formularz odpowiedzi\\\\
    {\\scriptsize (typ $self->{typ})}
\\end{center}
\\noindent\\blackbox\\hspace{$self->{rozstawMarkerow}}\\blackbox\\\\[5mm]
\\begin{tabular}{|c|}
  \\hline
  \\multicolumn{1}{|c|}{\\hspace*{10mm}}\\\\
    Kod studenta:\\\\
    $kodTerminu--$kodSali\\\\
    $kod_studenta\\\\
    \\multicolumn{1}{|l|}{\\makebox[5mm]{} id: {\\bf $wydrukId}}\\\\
  \\multicolumn{1}{|c|}{\\it W tym prostokcie } \\\\
  \\multicolumn{1}{|c|}{\\it nic nie zaznacza!!!} \\\\
  \\hline
\\end{tabular}
\\begin{tabular}{c}
    {\\bf Nr testu:} \\framebox[25mm][l]{\\rule{0mm}{3.2mm}$wydrukNrTestu}   \\\\
    {\\bf Kod testu:}\\\\
    $kod_testu\\\\
  \\multicolumn{1}{c}{\\bf\\em Powyej przekopiuj  } \\\\
  \\multicolumn{1}{c}{\\bf\\em numer i kod testu } \\\\
\\end{tabular}
\\begin{tabular}{l}
  {\\it\\small Pola \\boxo wypeniaj wstawiajc wyrany znak {\\bf x}.}\\\\
  {\\it\\small Pisz ciemnym dugopisem lub mikkim, czarnym, }\\\\
  {\\it\\small tpym owkiem. Poprawiaj biaym korektorem }\\\\
  {\\it\\small zamalowujc znak {\\bf x} (moe by wraz z ramk). }\\\\
  {\\it\\small Nie zapomnij o przekopiowaniu nr i kodu testu!!! }\\\\
  {\\it\\small Jeli dwie pierwsze ju wydrukowane cyfry nr testu }\\\\
  {\\it\\small nie s takie same jak na formularzu testu, zgo to!!!}\\\\
\\end{tabular}\\\\[5mm]
\\begin{tabular}{ll}
    \\begin{tabular}{l}
      {\\bf Nazwisko: $nazwisko} $czyZalega\\\\
      {\\bf Imi: $imie}\\\\
      {\\bf Indeks: $student->{indeks}}\\\\
      {\\bf Seria: $test->{seria}}\\\\
      \\hspace*{80mm}
    \\end{tabular}
  &
    \\begin{tabular}{l}
      {\\bf Kurs: $test->{kurs}}\\\\
      {\\bf Test: $test->{test}}\\\\
      {\\bf Data: $test->{data}}\\\\
      {\\bf Sala: $test->{sala}}\\\\
      \\hfill
    \\end{tabular}
\\end{tabular}\\\\
END
  ;

  # sprawdzamy czy formularz drukowany w dwch kolumnach
  my $strPom = "l" x $iloscKolumn;
  $form.=<<END
\\begin{tabular}{$strPom}
END
  ;

  my $i;
  my $j;
  my $k;
  for ($k = 0; $k < $iloscKolumn; $k++){
    $form .= "\\begin{tabular}{$string_do_tabular}\n";
    for($i=$k * $iloscPytanWKolumnie; $i < ($k + 1) * $iloscPytanWKolumnie ;$i++){
      my $np=$i+1;
      $form.="$np) ";

# Poprawka z 12.07.2003 majca na celu drukowanie 5 opcji w formularzu
# odpowiedzi nawet jeli de facto uywanych jest mniej opcji odpowiedzi
#      for($j=0;$j<$self->{iloscOpcji};$j++){
      for($j=0;$j<$self->{iloscOpcjiWzorcaFineReadera};$j++){
        my $ch=chr(65+$j);
        my $ans=($copyAnswerKey->[$i]->[$j] ? "\\boxx":"\\boxo" );
        $form.="& $ch$ans";
      }
     $form.="\\\\\n";
    }
    $form.= ($k == ($iloscKolumn - 1)) ?  "\\end{tabular}\n" : "\\end{tabular}\n&\n";
  }

  $form.= <<END
\\end{tabular}\\\\[15mm]
\\noindent\\blackbox\\hspace{$self->{rozstawMarkerow}}\\blackbox\\\\
\\hspace*{120mm}
\\begin{tabular}{c}
\\hline
{\\it Wasnorczny podpis}
\\end{tabular}\\\\
\\begin{tabular}{c}
\\hline
{\\it Uwagi: \\hspace*{180mm}}
\\end{tabular}
\\newpage
END
  ;
  return $form;
}

################################
#
# Funkcja generuje formularze na odpowiedzi,
# po jednym na kadego studenta,
# formularz - szablon
# formularz kontrolny
# kilka formularzy zapasowych
# Dodatkowo - liste zapasowych numerow studentow

sub writeCopiesOld{
  my ($self,$test,$studentsByExamId,$answers)=@_;

  my $emptyCopyAnswerKey=$self->generateEmptyCopyAnswerKey();
  my $kontrolny=new student('test','kontrolny',0);
  my $zapasowy=new student('','','');
  open(FORMS,">$test->{forms_output}") || die("Failed to open $test->{forms_output}\n");

  print FORMS $self->{formHead};

  # Generujemy zapasowe kody dla studentow ktorzy pojawia sie na egzaminie
  # a nie byli wpisani na liste
  print FORMS $self->generujWolneNumeryStudentow($test, $extra) if($self->{par}->{iloscZapasowychExamId});

  # Test kontrolny ma numer zero. Wyjtkowo dla niego drukujemy formularz z zaznaczonymi odpowiedziami
  # wstawiajc argument $answers->[0]
  print FORMS $self->generateCopy($test,$kontrolny,0,$answers->[0]);

  # Drukujemy formularze dla studentw
  my @list=sort(keys(%$studentsByExamId));
  $self->{liczbaZaleglosci}=0;
  foreach $nrStudenta (@list){
    print FORMS $self->generateCopy($test,$studentsByExamId->{$nrStudenta},$nrStudenta,$emptyCopyAnswerKey);
  }

  print "Znaleziono $self->{liczbaZaleglosci} studentow z zaleglosciami\n";
  # Generuje formularze dodatkowe, ktre mog by uyte do poprawiania pomyek

  # Nowy sposb liczenia zapasowych pustych formularzy testu wydaje si by lepszy
  my $iloscStudentow= $#list+1;
  my $extra=($self->{par}->{iloscFormularzyOdpowiedziDoKorekt} =~ /\d/ ?
             $self->{par}->{iloscFormularzyOdpowiedziDoKorekt}:
             int(0.03*$iloscStudentow+0.5) );

  for(my $i=0;$i<$extra;$i++){
    print FORMS $self->generateCopy($test,$zapasowy,-1,$emptyCopyAnswerKey);
  }

  #Generuje formularze dodatkowe z numerami, ktre mog by uyte dla studentow,
  # ktorych nie ma na liscie

  for(my $i=$test->{pierwszyZapasowyExamId};$i<=$test->{ostatniZapasowyExamId};$i++){
    print FORMS $self->generateCopy($test,$zapasowy,$i,$emptyCopyAnswerKey);
  }

  print FORMS $self->{formTail};
  close(FORMS);

  $self->{raport}->wypisz("\n=========================================================\n\n");
  $self->{raport}->wypisz("Przy skanowaniu uzyj formatu $self->{typWzorcaFineReadera}.frm");
  $self->{raport}->wypisz("\n\n=========================================================\n");


}

################################
#
# Funkcja generuje formularze na odpowiedzi,
# po jednym na kadego studenta,
#

sub writeCopiesOld{
  my ($self,$test,$studentsByExamId,$answers)=@_;

  my $emptyCopyAnswerKey=$self->generateEmptyCopyAnswerKey();
  my $kontrolny=new student('test','kontrolny',0);
  my $zapasowy=new student('','','');
  open(FORMS,">$test->{forms_output}") || die("Failed to open $test->{forms_output}\n");

  print FORMS $self->{formHead};


  # Drukujemy formularze dla studentw
  my @list=sort(keys(%$studentsByExamId));
  $self->{liczbaZaleglosci}=0;
  foreach $nrStudenta (@list){
    print FORMS $self->generateCopy($test,$studentsByExamId->{$nrStudenta},$nrStudenta,$emptyCopyAnswerKey);
  }

  print "Znaleziono $self->{liczbaZaleglosci} studentow z zaleglosciami\n";
  print FORMS $self->{formTail};
  close(FORMS);

  $self->{raport}->wypisz("\n=========================================================\n\n");
  $self->{raport}->wypisz("Przy skanowaniu uzyj formatu $self->{typWzorcaFineReadera}.frm");
  $self->{raport}->wypisz("\n\n=========================================================\n");


}

################################
#
# Wydruk dla wykadowcy,
# Wydruk testu numer zero z zaznaczonymi odpowiedziami
# formularz - szablon
# formularz kontrolny
# kilka formularzy zapasowych
# Dodatkowo - liste zapasowych numerow studentow

sub writeCopies{
  my ($self,$test,$studentsByExamId,$answers)=@_;

  my $emptyCopyAnswerKey=$self->generateEmptyCopyAnswerKey();
  my $kontrolny=new student('test','kontrolny',0);
  my $zapasowy=new student('','','');
  open(FORMS,">$test->{forms_output}") || die("Failed to open $test->{forms_output}\n");

  print FORMS $self->{formHead};

  # Drukujemy formularze dla studentw
  my @list=sort(keys(%$studentsByExamId));
  $self->{liczbaZaleglosci}=0;
  foreach $nrStudenta (@list){
    print FORMS $self->generateCopy($test,$studentsByExamId->{$nrStudenta},$nrStudenta,$emptyCopyAnswerKey);
  }

  print "Znaleziono $self->{liczbaZaleglosci} studentow z zaleglosciami\n";

  # Generujemy zapasowe kody dla studentow ktorzy pojawia sie na egzaminie
  # a nie byli wpisani na liste
  print FORMS $self->generujWolneNumeryStudentow($test, $extra) if($self->{par}->{iloscZapasowychExamId});

  # Test kontrolny ma numer zero. Wyjtkowo dla niego drukujemy formularz z zaznaczonymi odpowiedziami
  # wstawiajc argument $answers->[0]
  print FORMS $self->generateCopy($test,$kontrolny,0,$answers->[0]);

  print "Znaleziono $self->{liczbaZaleglosci} studentow z zaleglosciami\n";
  # Generuje formularze dodatkowe, ktre mog by uyte do poprawiania pomyek

  # Nowy sposb liczenia zapasowych pustych formularzy testu wydaje si by lepszy
  my $iloscStudentow= $#list+1;
  my $extra=($self->{par}->{iloscFormularzyOdpowiedziDoKorekt} =~ /\d/ ?
             $self->{par}->{iloscFormularzyOdpowiedziDoKorekt}:
             int(0.03*$iloscStudentow+0.5) );

  for(my $i=0;$i<$extra;$i++){
    print FORMS $self->generateCopy($test,$zapasowy,-1,$emptyCopyAnswerKey);
  }

  #Generuje formularze dodatkowe z numerami, ktre mog by uyte dla studentow,
  # ktorych nie ma na liscie

  for(my $i=$test->{pierwszyZapasowyExamId};$i<=$test->{ostatniZapasowyExamId};$i++){
    print FORMS $self->generateCopy($test,$zapasowy,$i,$emptyCopyAnswerKey);
  }

  print FORMS $self->{formTail};
  close(FORMS);

  $self->{raport}->wypisz("\n=========================================================\n\n");
  $self->{raport}->wypisz("Przy skanowaniu uzyj formatu $self->{typWzorcaFineReadera}.frm");
  $self->{raport}->wypisz("\n\n=========================================================\n");

}

################################
#
# Funkcja generuje szablon formularza
#
sub writeTemplate{
  my ($self,$test)=@_;
  my $empty_form=new answerForm();
  $empty_form->{kurs}='';
  $empty_form->{test}='';
  $empty_form->{data}='';
  $empty_form->{sala}='';
  $empty_form->{seria}='';
  $empty_form->{ilosc_okienek_kodu}=$test->{ilosc_okienek_kodu};
  $empty_form->{iloscProblemow}=$self->{iloscProblemow};


  my $emptyCopyAnswerKey=$self->generateEmptyCopyAnswerKey();
  my $no_student=new student('','','');
  open(FORMS,">$test->{template_output}") || die("Failed to open $test->{template_output}\n");

  print FORMS $self->{formHead};
  print FORMS $self->generateCopy($empty_form,$kontrolny,-1,$answers->[0]);

  print FORMS $self->{formTail};
  close(FORMS);
}

1;
