################################
#
# Pakiet binary
#
# Zawiera pomocnicze funkcje konwertujace
# z/do postaci dwjkowej oraz generujce zapis
# kraktkowy liczb dwjkowych w TeXu
#
package binary;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(toBin toBinForm fromBin);

################################
#
# Funkcja konwertujaca liczbe naturalna do postaci dwojkowej
#
sub toBin{
  my ($n,$k)=@_;  # (argument,zadana ilosc cyfr dwojkowych)
  my @bin;
  my $i=0;
  for($i=0;$i<$k;$i++){
    $bin[$i]=$n % 2;
    $n=$n/2;
  }
  return @bin;   #  wynikowe cyfry dwojkowe
}

################################
#
# Funkcja generujca kratki do kodu dwjkowego w Latex'u
#
sub toBinForm{
  my ($n,$k,$sep,$form)=@_;
  $sep="\\\\" if($sep =~ /^\s*$/);
  $form="\\box" if($form =~ /^\s*$/);
  $form="\\crc" if($form eq 'crc');
  my @kod_binarny=toBin($n,$k);
  my $i;
  my $kod="";
  for($i=0;$i<$k;$i++){
    $kod=$kod.$form.($kod_binarny[$i] ? 'x':'o');
    $kod=$kod.$sep if( ($i<$k-1) && (($i+1)%3 == 0) );
  }
  return $kod;
}

################################
#
# Funkcja konwertujaca liczbe naturalna z postaci dwojkowej
#
sub fromBin{
  my (@bin)=@_;  # (cyfry dwojkowe)
  my $res=0;
  my $i=0;
  my $k=$#bin;
  for($i=0;$i<=$k;$i++){
    $res*=2;$res+=$bin[$k-$i];
  }
  return $res; # odpowiednik dziesitny
}

