###############################
#
# Klasa egzaminator
#
# (c) Marian Mrozek 1996-2002
#
# Obsuguje interfejs graficzny w Perl/Tk dla programw robtest.pl,
# ocentest.pl i wystawoceny.pl
#

package egzaminator;

use Tk;
use strict;
use vars qw($biezacyRaport);
require Tk::ROText;

use egzekutorEgzaminatora;
use egzekutorWystawiaczaOcen;
use egzekutorWyswietlaczaWynikow;
use egzekutorOceniaczaTestow;
use egzekutorSkanowania;



# Zmienne lokalne

my $numerZadania=0;
my $pierwszeZadanie=0;
my $ostatnieZadanie=1;
my @oknaZadan=();

$biezacyRaport="";


################################
#
# Konstruktor
#

sub new{
  my $class = shift;
  my $self = {};
  bless($self,$class);
  $self->{starterEgzaminatora} = shift;
  $self->{par} = $self->{starterEgzaminatora}->{par};

  return $self;
}


###########################################################################
#
# Tworzy gwne okno egzaminatora i wypenia je pocztkow treci
#

sub wyswietlOkno{
  my ($self)=@_;
  my $par=$self->{par};
  $self->{mainWindow} = $self->{starterEgzaminatora}->{starterWindow}->Toplevel();
  $self->{mainWindow}->minsize(500,600);
  $self->{mainWindow}->title("Egzaminator");
  my $font=$par->{font};


  # Tworzymy potrzebne ramy
  # ramaZadania to 90% grnej czci okna, ktr na mniejsze czci dzieli si w klasie zadanieEgzaminatora
  # ramaPrzewija to pasek na dole okna z przyciskami do zmianny kolejnych zada i przyciskiem koca
  my $r1=$self->{ramaZadania}=$self->{mainWindow}->Frame->pack(-side => 'top', -fill => 'both', -expand => 1);
  my $r3=$self->{ramaPrzewijania}=$self->{mainWindow}->Frame->pack(-side => 'top', -fill => 'x');

  $self->{buttonPoprzednie}=$r3->Button(-text => "<< Poprzednie zadanie", -command => ['poprzednieZadanie' => $self] )->
    pack(-side => 'left', -anchor => 'e', -fill => 'x', -expand => 1);

  $self->{buttonNastepne}=$r3->Button(-text => "Nastpne zadanie >>", -command => ['nastepneZadanie' => $self] )->
    pack(-side => 'left', -anchor => 'e', -fill => 'x', -expand => 1);

  $self->{buttonKonfiguruj}=$r3->Button(-text => "Konfiguruj", -command => ['wywolajKonfiguratora' => $self] )->
    pack(-side => 'left', -anchor => 'e', -fill => 'x', -expand => 1);

  $r3->Button(-text => "Zakocz", -command => ['done' => $self] )->
    pack(-side => 'left', -fill => 'x', -expand => 1);

  # Podstawowa konfiguracja zada to:
  my %hwz=(
    'konfiguruj'=>1,
    'edytujFormularzTestu'=>1,
    'robFormularzeTestu'=>1,
    'drukujTesty'=>1,
    'edytujListeStudentow'=>1,
    'robListeCwiczeniowa'=>1,
    'robFormularzeOdpowiedzi'=>1,
    'drukujFormularzeOdpowiedzi'=>1,
    'skanujTesty'=>1,
    'edytujListeZaliczen'=>1,
    'ocenTest'=>1,
    'wyswietlWynikiTestu'=>1,
    'wystawiaczOcen'=>1,
    'wyswietlWyniki'=>1
  );
  # Dodatkowo przy wasnym czytniku zamiast FineReadera
  $hwz{'Koryguj'}=1 if($self->{par}->{wlasnyCzytnik});

  # Dla moich testw na WSB i w II UJ:
  if($self->{par}->{wariant} eq 'WSB' || $self->{par}->{wariant} eq 'UJ'){
    $hwz{'robWstepnaListeEgzaminacyjna'}=1;
  }
  if($self->{par}->{wariant} eq 'WSB'){
    $hwz{'drukujProtokoly'}=1;
  }


  $numerZadania=0;
  $pierwszeZadanie=0;

  $oknaZadan[$numerZadania++]=new egzekutorEgzaminatora($self,'konfiguruj') if($hwz{'konfiguruj'});
  $oknaZadan[$numerZadania++]=new egzekutorEgzaminatora($self,'edytujFormularzTestu') if($hwz{'edytujFormularzTestu'});
  $oknaZadan[$numerZadania++]=new egzekutorEgzaminatora($self,'edytujListeStudentow') if($hwz{'edytujListeStudentow'});
  $oknaZadan[$numerZadania++]=new egzekutorEgzaminatora($self,'robWstepnaListeEgzaminacyjna') if($hwz{'robWstepnaListeEgzaminacyjna'});
  $oknaZadan[$numerZadania++]=new egzekutorEgzaminatora($self,'robListeCwiczeniowa') if($hwz{'robListeCwiczeniowa'});
  $oknaZadan[$numerZadania++]=new egzekutorEgzaminatora($self,'robFormularzeTestu') if($hwz{'robFormularzeTestu'});
  $oknaZadan[$numerZadania++]=new egzekutorEgzaminatora($self,'drukujTesty') if($hwz{'drukujTesty'});
  $oknaZadan[$numerZadania++]=new egzekutorEgzaminatora($self,'robFormularzeOdpowiedzi') if($hwz{'robFormularzeOdpowiedzi'});
  $oknaZadan[$numerZadania++]=new egzekutorEgzaminatora($self,'drukujFormularzeOdpowiedzi') if($hwz{'drukujFormularzeOdpowiedzi'});
#  $oknaZadan[$numerZadania++]=new egzekutorEgzaminatora($self,'skanujTesty') if($hwz{'skanujTesty'});
  $oknaZadan[$numerZadania++]=new egzekutorSkanowania($self,'skanujTesty') if($hwz{'skanujTesty'});
  $oknaZadan[$numerZadania++]=new egzekutorEgzaminatora($self,'Koryguj') if($hwz{'Koryguj'});
  $oknaZadan[$numerZadania++]=new egzekutorOceniaczaTestow($self,'ocenTest') if($hwz{'ocenTest'});
  $oknaZadan[$numerZadania++]=new egzekutorWyswietlaczaWynikow($self,'wyswietlWynikiTestu') if($hwz{'wyswietlWynikiTestu'});
  $oknaZadan[$numerZadania++]=new egzekutorEgzaminatora($self,'edytujListeZaliczen') if($hwz{'edytujListeZaliczen'});
  $oknaZadan[$numerZadania++]=new egzekutorWystawiaczaOcen($self,'wystawiaczOcen') if($hwz{'wystawiaczOcen'});
  $oknaZadan[$numerZadania++]=new egzekutorWyswietlaczaWynikow($self,'wyswietlWyniki') if($hwz{'wyswietlWyniki'});
  $oknaZadan[$numerZadania++]=new egzekutorEgzaminatora($self,'drukujProtokoly')  if($hwz{'drukujProtokoly'});
  $ostatnieZadanie=$numerZadania-1;
  # Numer ostatniego zadania oraz domylny numer edycji wczytujemy z pliku status
  if(-r 'status'){
    open(IN,"<status");
    if(<IN> =~ /^\s*(\d+)\s*$/){
      $numerZadania=$1;
    }else{
      $numerZadania=0;
    }
    if(<IN> =~ /^\s*(\d+)\s*$/){
      $self->{par}->{numerDomyslnyEdycji}=$1;
    }
    close(IN);
  }else{
    $numerZadania=0;
  }
  $numerZadania=0 if($numerZadania>$ostatnieZadanie || $numerZadania<$pierwszeZadanie);
#print "numerZadania=$numerZadania pierwszeZadanie=$pierwszeZadanie ostatnieZadanie=$ostatnieZadanie\n";

  $self->{buttonPoprzednie}->configure(-state => 'disabled') if($numerZadania <= $pierwszeZadanie);
  $self->{buttonNastepne}->configure(-state => 'disabled') if($numerZadania >= $ostatnieZadanie);
  $oknaZadan[$numerZadania]->pokaz();
}

###########################################################################
#
# Zakocz
#

sub done{
  my $self = shift;
  $oknaZadan[$numerZadania]->schowaj();
  $self->{mainWindow}->destroy();
  open(OUT,">status");
  print OUT "$numerZadania\n";
  print OUT "$self->{par}->{numerDomyslnyEdycji}\n";
  close(OUT);

#  open(OUT,">$self->{par}->{Bin}/egzaminator/statusEgzaminatora");
#  print OUT $self->{starterEgzaminatora}->{'katalogBiezacy'};
#  close(OUT);
  $self->{starterEgzaminatora}->writeStatus();

#  $self->{starterEgzaminatora}->{ostatniButton}->configure(-state => 'normal');
#  $self->{starterEgzaminatora}->{wybierzButton}->configure(-state => 'normal');
#  $self->{starterEgzaminatora}->{utworzButton}->configure(-state => 'normal');
#  $self->{starterEgzaminatora}->{kopiujButton}->configure(-state => 'normal');
#  $self->{starterEgzaminatora}->{zakonczButton}->configure(-state => 'normal');
  $self->{starterEgzaminatora}->{egzMenu}->configure(-state => 'normal');

};

###########################################################################
#
# poprzednie zadanie
#

sub poprzednieZadanie{
  my $self = shift;
  if($numerZadania>$pierwszeZadanie){
    $oknaZadan[$numerZadania]->schowaj();
    $numerZadania--;
    $self->{buttonPoprzednie}->configure(-state => 'disabled') if($numerZadania == $pierwszeZadanie);
    $self->{buttonNastepne}->configure(-state => 'active');
    $oknaZadan[$numerZadania]->pokaz();
  }
};

###########################################################################
#
# nastpne zadanie
#

sub nastepneZadanie{
  my $self = shift;
  if($numerZadania<$ostatnieZadanie){
    $oknaZadan[$numerZadania]->schowaj();
    $numerZadania++;
    $self->{buttonNastepne}->configure(-state => 'disabled') if($numerZadania == $ostatnieZadanie);
    $self->{buttonPoprzednie}->configure(-state => 'active');
    $oknaZadan[$numerZadania]->pokaz();
# print "$oknaZadan[$numerZadania]->{zadanie}\n";
# print "$oknaZadan[$numerZadania]->{task}\n";
  }
};

###########################################################################
#
# poprzednie zadanie
#

sub wywolajKonfiguratora{
  my $self = shift;
  $oknaZadan[0]->{task}->wykonaj();
};

###########################################################################

1;