###############################
#
# Klasa copyExamTreeDirSelector
#
# (c) Marian Mrozek 1996-2003
#
# Klasa uywana do wyboru katalogw
# przy klonowaniu gazi plikw egzaminw
#

package nowyEgzamin;

use Tk;
use FileDialog;
use DirSelect;
use utilities;
use strict;
require Tk::ROText;

use konfigurator;

################################
#
# Konstruktor
#

sub new{
  my $class = shift;
  my $self = {};
  bless($self,$class);

  $self->{starterEgzaminatora} = shift;
  $self->{'sourceDir'} = shift;
  $self->{'nowy'} = shift;

  $self->{par} = $self->{starterEgzaminatora}->{par};

  return $self;
}


###########################################################################
#
# Tworzy gwne okno i wypenia je pocztkow treci
#

sub wyswietlOkno{
  my ($self)=@_;
  $self->{mainWindow} = $self->{starterEgzaminatora}->{starterWindow}->Toplevel();
  $self->{mainWindow}->minsize(700,200);
  $self->{mainWindow}->title("Nowy Egzamin");

  $self->{ramaPrzezn}=$self->{mainWindow}->Frame->pack(-side => 'top', -fill => 'both');
  if($self->{par}->{hasloAutomatyczne} ne 'tak'){
    $self->{ramaHasla}=$self->{mainWindow}->Frame->pack(-side => 'top', -fill => 'both');
  }

  $self->{ramaNazwy}=$self->{mainWindow}->Frame->pack(-side => 'top', -fill => 'both');
  $self->{ramaDaty}=$self->{mainWindow}->Frame->pack(-side => 'top', -fill => 'both');
  $self->{ramaGodziny}=$self->{mainWindow}->Frame->pack(-side => 'top', -fill => 'both');
  $self->{ramaSali}=$self->{mainWindow}->Frame->pack(-side => 'top', -fill => 'both');
  $self->{ramaTestu}=$self->{mainWindow}->Frame->pack(-side => 'top', -fill => 'both');
  if($self->{par}->{nazwaBazowaTestuAutomatyczna} ne 'tak'){
    $self->{ramaNazwyBazowejTestu}=$self->{mainWindow}->Frame->pack(-side => 'top', -fill => 'both');
  }

  $self->{ramaPrzyciskow}=$self->{mainWindow}->Frame->pack(-side => 'top');
  my $copyright=$self->{mainWindow}->Text(-width => 40, -height => 1, -relief => 'ridge', -background => 'gray')->
    pack(-side => 'bottom', -anchor => 'e', -fill => 'x', -expand => 1);


  $self->{ramaPrzezn}->Label(-text => 'Katalog docelowy:  ', -anchor => 'c')->
      pack(-side => 'left', -anchor => 'e');
  $self->{ramaPrzezn}->Entry(-textvariable => \$self->{'destDir'}, -width => 60)->
    pack(-side => 'left', -anchor => 'e');
  $self->{ramaPrzezn}->Label(-text => '     ', -anchor => 'c')->
    pack(-side => 'left',-anchor => 'w');
  $self->{toButton}=$self->{ramaPrzezn}->Button(-text => "Wybierz katalog docelowy", -command => ['selectDestination' => $self] )->
    pack(-side => 'left', -anchor => 'e');

  if($self->{par}->{hasloAutomatyczne} ne 'tak'){
    $self->{ramaNazwy}->Label(-text => 'Haso:  ', -anchor => 'c')->
        pack(-side => 'left', -anchor => 'e');
    $self->{ramaNazwy}->Entry(-textvariable => \$self->{konfigurator}->{keysValsHashRef}->{pwd}, -width => 60)->
      pack(-side => 'left', -anchor => 'e');
  }

  $self->{ramaNazwy}->Label(-text => 'Nazwa przedmiotu:  ', -anchor => 'c')->
      pack(-side => 'left', -anchor => 'e');
  $self->{ramaNazwy}->Entry(-textvariable => \$self->{konfigurator}->{keysValsHashRef}->{kurs}, -width => 60)->
    pack(-side => 'left', -anchor => 'e');

  $self->{ramaDaty}->Label(-text => 'Data:  ', -anchor => 'c')->
      pack(-side => 'left', -anchor => 'e');
  $self->{ramaDaty}->Entry(-textvariable => \$self->{konfigurator}->{keysValsHashRef}->{data}, -width => 60)->
    pack(-side => 'left', -anchor => 'e');

  $self->{ramaGodziny}->Label(-text => 'Godzina:  ', -anchor => 'c')->
      pack(-side => 'left', -anchor => 'e');
  $self->{ramaGodziny}->Entry(-textvariable => \$self->{konfigurator}->{keysValsHashRef}->{godzina}, -width => 60)->
    pack(-side => 'left', -anchor => 'e');

  $self->{ramaSali}->Label(-text => 'Sala:  ', -anchor => 'c')->
      pack(-side => 'left', -anchor => 'e');
  $self->{ramaSali}->Entry(-textvariable => \$self->{konfigurator}->{keysValsHashRef}->{sala}, -width => 60)->
    pack(-side => 'left', -anchor => 'e');

  $self->{ramaTestu}->Label(-text => 'Typ testu:  ', -anchor => 'c')->
      pack(-side => 'left', -anchor => 'e');
  $self->{ramaTestu}->Entry(-textvariable => \$self->{konfigurator}->{keysValsHashRef}->{test}, -width => 60)->
    pack(-side => 'left', -anchor => 'e');

  if($self->{par}->{nazwaBazowaTestuAutomatyczna} ne 'tak'){
    $self->{ramaNazwyBazowejTestu}->Label(-text => 'Nazwa bazowa plikw testu:  ', -anchor => 'c')->
        pack(-side => 'left', -anchor => 'e');
    $self->{ramaNazwyBazowejTestu}->Entry(-textvariable => \$self->{konfigurator}->{keysValsHashRef}->{nazwaBazowaTestu}, -width => 60)->
      pack(-side => 'left', -anchor => 'e');
  }

  $self->{zakonczButton}=$self->{ramaPrzyciskow}->Button(-text => "Wykonaj", -command => ['finish' => $self] )->
    pack(-side => 'left',-anchor => 'w');
  $self->{ramaPrzyciskow}->Label(-text => '     ', -anchor => 'c')->
    pack(-side => 'left',-anchor => 'w');
  $self->{rezygnujButton}=$self->{ramaPrzyciskow}->Button(-text => "Rezygnuj", -command => ['giveup' => $self] )->
    pack(-side => 'right',-anchor => 'e');


#  $title->insert('0.0',"Import");
  $copyright->insert('0.0',"Marian Mrozek, Krakw 1996-2008");
}

###########################################################################
#
# Dokonuje wyboru katalogu, w ktrym bdzie pracowa egzaminator
#

sub selectDestination{
  my ($self)=@_;

  # Wybieramy katalog przy uyciu DirSelect

  $self->{DSRef} = $self->{mainWindow}->DirSelect(-title => "Wybierz lokalizacj katalogu egzaminu");
  my $dir = $self->{DSRef}->Show($self->{par}->{katalogPoczatkowy});
  $self->{'destDir'}=$dir;
}



###########################################################################
#
# Wczytuje dane konfiguracyjne i wywietla okno
#

sub process{
  my $self=shift;

  my $confFile="$self->{'sourceDir'}/conf";
  my $iniConfFile="$self->{par}->{Bin}/egzaminator/pustyEgzamin/conf";
  # Konstruktor konfiguratora w szczeglnoci czya plik konfiuracyjny
  $self->{konfigurator} = new konfigurator(undef,$confFile,$iniConfFile,$self->{par});
  $self->{konfigurator}->load();
  $self->wyswietlOkno();
}

###########################################################################
#
# Koczy prac
#

sub finish{

  my ($self,$par)=@_;
  if(-d $self->{destDir}){
    $self->{mainWindow}->Dialog(
             -title => 'Zy katalog',
             -text => 'Taki katalog istnieje.\nPodaj ciek do nieistniejcego katalogu',
             -default_button => 'OK',
             -buttons => ['OK'],
     )->Show();
     return;
  }
  my $answer=$self->{mainWindow}->Dialog(
       -title => ($self->{'nowy'} ? 'Tworzenie egzaminu' : 'Kopiowanie egzaminw'),
       -text => ($self->{'nowy'} ? 'Czy utworzy nowy egzamin?' : 'Czy przenie powtarzalne pliki zgodnie z dokonanym wyborem katalogw?'),
       -default_button => 'Tak',
       -buttons => ['Tak','Nie'],
     )->Show();
  if($answer eq 'Tak'){
    # Wzorce plikw kopiowanych
    #my $filePattern='.*/conf$|.*\\.conf$|.*\\.html$|.*\\.gif$|.*\\.jpg$|.*\\.css$|.*\\.pdf$';
    my $filePattern='.*/conf$|.*\\.conf$|.*\\.gif$|.*\\.jpg$|.*\\.css$|.*\\.pdf|.*\\.xml$|.*studenci\\.csv$';
    # Wzorce katalogw NIE kopiowanych
    my $dirPattern='auxil|lists|oceny|pdf|protokoly|raporty|skaner|tex';
    my $dt=new copyDirTree($self->{sourceDir},$self->{destDir},$filePattern,$dirPattern);

    my $processedFiles=$dt->recurse();
    print "Processed $processedFiles files\n";
  }
  # Jeli tak zlecono, obliczamy wartoci automatyczne
  if($self->{par}->{nazwaBazowaTestuAutomatyczna} eq 'tak'){
    print "Matching $self->{'destDir'}\n";
    if($self->{'destDir'} =~ /^.*[\/\\]([^\/\\]+)[\/\\]testy[\/\\]([^\/\\]+)[\/\\]?$/){
      $self->{konfigurator}->{keysValsHashRef}->{nazwaBazowaTestu}="$1.$2";
    }elsif($self->{'destDir'} =~ /^.*[\/\\]([^\/\\]+)[\/\\]([^\/\\]+)[\/\\]?$/){
      $self->{konfigurator}->{keysValsHashRef}->{nazwaBazowaTestu}="$1.$2";
    }else{
      print "Nie udao si ustali nazwy bazowej\n";
    }
  }
  if($self->{par}->{hasloAutomatyczne} eq 'tak'){
    $self->{konfigurator}->{keysValsHashRef}->{pwd}="$self->{konfigurator}->{keysValsHashRef}->{nazwaBazowaTestu}-$self->{konfigurator}->{keysValsHashRef}->{data}";
  }
  # Zapisujemy plik conf w nowym katalogu
  $self->{konfigurator}->{file}="$self->{'destDir'}/conf";
  $self->{konfigurator}->save();
  $self->{mainWindow}->destroy();

  # Uruchamiamy obsug nowego egzaminu
#  $self->{starterEgzaminatora}->{start_dir}=$self->{'destDir'};
#  $self->{starterEgzaminatora}->select(0);
  $self->{starterEgzaminatora}->select($self->{'destDir'});
}


###########################################################################
#
# Pomija prac
#

sub giveup{

  my ($self,$par)=@_;
  $self->{mainWindow}->destroy();
}


###########################################################################

1;