###############################
#
# Klasa Korektor
#
# (c) Marian Mrozek 2008
#
#  Klasa umoliwia interaktywn korekt
#  efektw skanowania


package Korektor;

use Tk;
use strict;
use utilities;
use binary;
use ExamUtil;

require Tk::ROText;

################################
#
# Konstruktor
#

sub new{
  my $class = shift;
  my $self = {};
  bless($self,$class);
  $self->{selektorKorektora} = shift;
  $self->{nrSelekcji} = shift;
  $self->{referencjaZadania} = shift;
  $self->{nazwaRekordu} = shift;
  ($self->{mainWindow},$self->{rekordy},$self->{par}) =
      ($self->{selektorKorektora}->{mainWindow},
       $self->{selektorKorektora}->{rekordy},
       $self->{selektorKorektora}->{par}
      );
  $self->{baseName}=$self->{selektorKorektora}->{nazwyBazowe}->[$self->{nrSelekcji}];

  $self->{kodStud}=[];
  $self->{kodTestu}=[];
  $self->{kodTerminu}=[];
  $self->{kodSal}=[];

  $self->unpack();
#print "new Korektor called with: $class, $self->{selektorKorektora}, $self->{nrSelekcji}=\n";
#print "     self->{rekordy}=$self->{rekordy}=\n";


  return $self;
}


###########################################################################
#
# Tworzy gwne okno korektora i wypenia je pocztkow treci
#

sub configWindow{
  my $self = shift;

  # Tworzymy gwne okno
  $self->{ramka} = $self->{mainWindow}->Toplevel();
  $self->{ramka}->minsize(512,768);
  $self->{ramka}->title("Korektor");

  # Tworzymy potrzebne widgety
  my $topPanel = $self->{ramka}->Frame->place(-relx => 0.0, -rely => 0.0, -relwidth => 1.0, -relheight => 0.05);
  my $rightPanel = $self->{ramka}->Frame->place(-relx => 0.0, -rely => 0.05, -relwidth => 1.0, -relheight => 0.9);
  my $buttonsFrame=$self->{ramka}->Frame()->place(-relx => 0.0, -rely => 0.95, -relwidth => 1.0, -relheight => 0.05);

  my $kodStudentaFrame = $rightPanel->Frame->place(-relx => 0.0, -rely => 0.0, -relwidth => 0.5, -relheight => 0.2);
  my $kodTestuFrame = $rightPanel->Frame->place(-relx => 0.5, -rely => 0.0, -relwidth => 0.5, -relheight => 0.2);
  my $lewePola = $rightPanel->Frame->place(-relx => 0.03, -rely => 0.2, -relwidth => 0.47, -relheight => 0.78);
  my $prawePola = $rightPanel->Frame->place(-relx => 0.53, -rely => 0.2, -relwidth => 0.47, -relheight => 0.78);

  $topPanel->Label(-text => "Rekord: $self->{baseName}")->
    pack(-side => 'top', -anchor => 'n', -fill => 'x', -expand => 1);

  for(my $i=0;$i<@{$self->{kodTerminu}};++$i){
    $kodStudentaFrame->Checkbutton(-text => '',-variable => \$self->{kodTerminu}->[$i], -anchor => 'c')->
    place(-relx => 0.2+0.1*$i, -rely => 0.3);
  }
  for(my $i=0;$i<@{$self->{kodSal}};++$i){
    $kodStudentaFrame->Checkbutton(-text => '',-variable => \$self->{kodSal}->[$i], -anchor => 'c')->
    place(-relx => 0.55+0.1*$i, -rely => 0.3);
  }
  $kodStudentaFrame->Label(-text => 'Kod studenta', -anchor => 'center')->place(-relx => 0.4, -rely => 0.7);

  for(my $i=0;$i<@{$self->{kodStud}};++$i){
    $kodStudentaFrame->Checkbutton(-text => '',-variable => \$self->{kodStud}->[$i], -anchor => 'center')->
    place(-relx => 0.0+$i*0.09+($i>=3)*0.09+($i>=6)*0.09, -rely => 0.5);
  }

  for(my $i=0;$i<@{$self->{kodTestu}};++$i){
    $kodTestuFrame->Checkbutton(-text => '',-variable => \$self->{kodTestu}->[$i], -anchor => 'center')->
    place(-relx => 0.4+($i % 3)*0.1, -rely => 0.1+int($i/3)*0.2);
  }
  $kodTestuFrame->Label(-text => 'Kod testu', -anchor => 'center')->place(-relx => 0.45, -rely => 0.7);

  for(my $i=0;$i<@{$self->{polaOdpowiedzi}}/2;++$i){
    for(my $j=0;$j<@{$self->{polaOdpowiedzi}->[$i]};++$j){
      my $nr=($i+1).')';
      my $c=chr(ord('A')+($j));

      my $y=$i*0.04;
      my $x=$j*0.17;
      $lewePola->Label(-text => $nr, -anchor => 'c')->place(-relx => 0.0, -rely => $y);

      $lewePola->Label(-text => $c, -anchor => 'c')->place(-relx => $x+0.13, -rely => $y);

      $lewePola->Checkbutton(-text => '',-variable => \$self->{polaOdpowiedzi}->[$i]->[$j], -anchor => 'c')->
             place(-relx => $x+0.17, -rely => $y);
    }
  }

  for(my $i=0;$i<@{$self->{polaOdpowiedzi}}/2;++$i){
    for(my $j=0;$j<@{$self->{polaOdpowiedzi}->[$i]};++$j){
      my $nr=($i+26).')';
      my $c=chr(ord('A')+($j));

      my $y=$i*0.04;
      my $x=$j*0.17;
      $prawePola->Label(-text => $nr, -anchor => 'c')->place(-relx => 0.0, -rely => $y);

      $prawePola->Label(-text => $c, -anchor => 'c')->place(-relx => $x+0.13, -rely => $y);

      $prawePola->Checkbutton(-text => '',-variable => \$self->{polaOdpowiedzi}->[25+$i]->[$j], -anchor => 'c')->
             place(-relx => $x+0.17, -rely => $y);
    }
  }

  $buttonsFrame->Button(-text => "Podgld", -command => ['podglad' , $self] )->
    pack(-side => 'left', -anchor => 'e', -fill => 'x', -expand => 1);
  $buttonsFrame->Button(-text => "Zapisz i zakocz", -command => ['zakoncz', $self] )->
    pack(-side => 'left', -anchor => 'e', -fill => 'x', -expand => 1);
  $buttonsFrame->Button(-text => "Anuluj", -command => ['anuluj' , $self] )->
    pack(-side => 'left', -fill => 'x', -expand => 1);


}

###########################################################################
#
# obsuga przycisku 'Podgld'
#

sub podglad{
  my $self = shift;
  my $dir=pwd();
  my $command="\"$self->{referencjaZadania}->{par}->{CzytnikHTML}\" $dir\\$self->{nazwaRekordu}";
  my $out=`$command`;
}

###########################################################################
#
# obsuga przycisku 'Zakocz'
#

sub zakoncz{
  my $self = shift;
  $self->pack();
  ${$self->{par}->{referencjaDoKorektora}}=undef;
  $self->{ramka}->destroy();
}

###########################################################################
#
# obsuga przycisku 'Anuluj'
#

sub anuluj{
  my $self = shift;
  ${$self->{par}->{referencjaDoKorektora}}=undef;
  $self->{ramka}->destroy();
}

###########################################################################
#
# Dane dostarczane s w postaci napisu, ktry tu rozpakowujemy do
# hasza. Zawarto napisu wynika z konstrukcji formularza MTB-A4 projektowanego
# jeszcze dla FineReadera.
#

sub unpack{
  my $self = shift;

  my $record=$self->{rekordy}->[$self->{nrSelekcji}];
#print"self->{rekordy}=$self->{rekordy}=\n";
#print "Got record[$self->{nrSelekcji}]=$record=\n";
  my ($imageFile,$pozycjaWWiazce,$nrStud,$nrTestu,$nrTerminu,$nrSal);
  ($imageFile,$pozycjaWWiazce,$nrStud,$nrTestu,$nrTerminu,$nrSal,$self->{polaOdpowiedzi})=rozpakujWyniki($record);
  $self->{imageFile}=$imageFile;
  $self->{pozycjaWWiazce}=$pozycjaWWiazce;
  @{$self->{kodStud}}=toBin($nrStud,9);
  @{$self->{kodTestu}}=toBin($nrTestu,9);
  @{$self->{kodTerminu}}=toBin($nrTerminu,3);
  @{$self->{kodSal}}=toBin($nrSal,3);

}

###########################################################################
#
# Procedura odwrotna: hasz pakowany jest do napisu.
# Zawarto napisu wynika z konstrukcji formularza MTB-A4 projektowanego
# jeszcze dla FineReadera.
#

sub pack{
  my $self = shift;
  my $packed;

  my $imageFile=$self->{imageFile};
  my $pozycjaWWiazce=$self->{pozycjaWWiazce};
  my $nrStud=fromBin(@{$self->{kodStud}});
  my $nrTestu=fromBin(@{$self->{kodTestu}});
  my $nrTerminu=fromBin(@{$self->{kodTerminu}});
  my $nrSal=fromBin(@{$self->{kodSal}});
  my $packed=zapakujWyniki($imageFile,$pozycjaWWiazce,$nrStud,$nrTestu,$nrTerminu,$nrSal,$self->{polaOdpowiedzi});
  $self->{rekordy}->[$self->{nrSelekcji}]=$packed;
}

###########################################################################

1;