##################
#
# Klasa drukujFormularzeOdpowiedzi
#
# wspiera drukowanie formularzy odpowiedzi przez AcrobatReadera
#
#

package drukujFormularzeOdpowiedzi;

use utilities;
use zadanieZewnetrzneEgzaminatora;
use Win32::Process;

@ISA = ("zadanieZewnetrzneEgzaminatora");

####################################################
#
# opisy
#
sub ustawOpisy{
  my ($self)=@_;
  $self->{naglowekOpisuZadania}=<<END
Drukowanie formularzy odpowiedzi
END
  ;
  $self->{tekstOpisuZadania}=<<END
  Przygotowane formularze odpowiedzi mona obejrze i wydrukowa przy uyciu
Acrobat Readera. Przy drukowaniu warto si upewni czy opcje typu "fit to page"
lub "scale to fit" s wyczone. Wydrukowanie formularzy przy wczonej takiej
opcji powoduje przeskalowanie wydruku, co moe utrudni lub wrcz uniemoliwi
pniejsze poprawne skanowanie wynikw.
END
  ;
  $self->{dopuscEdycje}=1;
  $self->{'nazwaEgzekutoraZewnetrznego'}='CzytnikPDF';
}

################################
#
# Konstruktor
#

sub new{
  my $class = shift;
  my $self = {};
  bless($self,$class);
  $self->ustawOpisy();
  return $self;
}

####################################################
#
# wywyoanie programu drukujcego testy
#

sub wykonajWlasciweZadanie{
  my ($self)=@_;

  my $baseName=$self->{referencjaZadania}->{par}->{nazwaBazowaTestu};

  my $numerEdycji=$self->{referencjaZadania}->{numerEdycji};
  $baseName.="-$numerEdycji" if($numerEdycji);
  my $command="\"$self->{referencjaZadania}->{par}->{CzytnikPDF}\" pdf/$baseName-formularze.pdf";
  $self->{oknoRaportu}->insert('end',"Wywouj: $command\n");
#  my $out=`$command`;
  Win32::Process::Create($Win32::Process::Create::ProcessObj,
    $self->{referencjaZadania}->{'par'}->{'Cmd'}, #
    "/c $command", #
    0, # Dont inherit.
    CREATE_NEW_CONSOLE,
    "."
  ) or
  die Win32::FormatMessage( Win32::GetLastError() );
}

########################################################################

1;

