##################
#
# Klasa drukujProtokoly
#
# wspiera drukowanie protokolow przez Excel
#
#

package drukujProtokoly;

use utilities;
use zadanieZewnetrzneEgzaminatora;
use Win32::Process;

@ISA = ("zadanieZewnetrzneEgzaminatora");

####################################################
#
# opisy
#
sub ustawOpisy{
  my ($self)=@_;
  $self->{naglowekOpisuZadania}=<<END
Drukowanie protokow
END
  ;
  $self->{tekstOpisuZadania}=<<END
  Przygotowane protokoy mona obejrze i wydrukowa
przy uyciu Excela. Przycinicie przycisku "Wykonaj"
powoduje uruchomienie Excela z otwartymi
wszystkimi plikami protokow (moe by ich kilka).
Niestety domylnie otwieraj si arkusze dla studentw
do wywieszenia na drzwiach. Trzeba klikn na Arkusz1
na dole strony by uzyska dostp do waciwych protokow.
END
  ;
  $self->{dopuscEdycje}=0;
  $self->{'nazwaEgzekutoraZewnetrznego'}='EdytorCSV';
}

################################
#
# Konstruktor
#

sub new{
  my $class = shift;
  my $self = {};
  bless($self,$class);
  $self->ustawOpisy();
  return $self;
}

####################################################
#
# wywyoanie programu drukujcego testy
#

sub wykonajWlasciweZadanie{
  my ($self)=@_;

  opendir (DIRHANDLE, 'protokoly');
  my @filelist = readdir (DIRHANDLE);
  closedir(DIRHANDLE);
  my @excelFiles=();
  foreach $file (@filelist){
#    push @excelFiles, $file if($file =~ /\.xls$/);
    push @excelFiles, "\"$file\"" if($file =~ /\.xls$/);
  }

  chdir('protokoly');
  my $command="\"$self->{referencjaZadania}->{par}->{EdytorCSV}\" @excelFiles";
  $self->{oknoRaportu}->insert('end',"Wywouj: $command\n");
#  my $out=`$command`;
  Win32::Process::Create($Win32::Process::Create::ProcessObj,
    $self->{referencjaZadania}->{'par'}->{'Cmd'}, #
    "/c $command", #
    0, # Dont inherit.
    CREATE_NEW_CONSOLE,
    "."
  ) or
  die Win32::FormatMessage( Win32::GetLastError() );
  chdir('..');
}

########################################################################

1;

