##################
#
# Klasa edytujListeStudentow
#
# wspiera drukowanie testw przez AcrobatReadera
#
#

package edytujListeStudentow;

use utilities;
use zadanieZewnetrzneEgzaminatora;
use FileDialog;
use Win32::Process;

@ISA = ("zadanieZewnetrzneEgzaminatora");

####################################################
#
# opisy
#
sub ustawOpisy{
  my ($self)=@_;
  $self->{naglowekOpisuZadania}=<<END
Edycja listy studentw
END
  ;
  $self->{tekstOpisuZadania}=<<END
  Tu uruchamiamy edytor w celu wprowadzenia i/lub edytowania listy
studentw przystpujcych do egzaminu. Lista ma format
  [Naglowek]
  DaneRekordu=imie;nazwisko;indeks
  [ListaStudentow]
  Jan;Kowalski;1038347
  Adam;Malinowski;1028262
  ......
Trzy pierwsze linie pozostawiamy niezmienione. W kolejnych liniach
wprowadzamy dane kolejnych studentw, ktre obejmuj rozdzielone
rednikami imi, nazwisko oraz indeks.

END
  ;
  $self->{dopuscEdycje}=1;
  $self->{'nazwaEgzekutoraZewnetrznego'}='EdytorCSV';
}

################################
#
# Konstruktor
#

sub new{
  my $class = shift;
  my $self = {};
  bless($self,$class);
  $self->ustawOpisy();
  return $self;
}

####################################################
#
# wywyoanie programu edytujcego list studentw
#

sub wykonajWlasciweZadanie{
  my ($self)=@_;

  my $baseName=$self->{referencjaZadania}->{par}->{nazwaBazowaTestu};

  my $numerEdycji=$self->{referencjaZadania}->{numerEdycji};
  $baseName.="-$numerEdycji" if($numerEdycji);

  my $fd=$self->{referencjaZadania}->{mainWindow}->FileDialog(
    -Path => 'studenci',
    -Chdir => 0,
    -FPat => '*.csv',
    -File => 'studenci.csv',
    -Title => 'Wybierz plik',
    -DisableShowAll => 1,
    -FileLBCaption => 'Lista plikw',
    -FileEntryLabel => 'Nazwa pliku:',
    -PathEntryLabel => 'cieka',
    -FltEntryLabel => 'Filtr'
  );
  my $file=$fd->Show();
  $file =~ s|/|\\|g;
  if($file){
    my $command="\"$self->{referencjaZadania}->{par}->{EdytorCSV}\" $file";
    $self->{oknoRaportu}->insert('end',"Wywouj: $command\n");
#    my $out=`$command`;
    Win32::Process::Create($Win32::Process::Create::ProcessObj,
      $self->{referencjaZadania}->{'par'}->{'Cmd'}, #
      "/c $command", #
      0, # Dont inherit.
      CREATE_NEW_CONSOLE,
      "."
    ) or
    die Win32::FormatMessage( Win32::GetLastError() );
  }
}

########################################################################

1;

