###############################
#
# Klasa egzekutorEgzaminatora
#
# (c) Marian Mrozek 2002
#
#

package egzekutorEgzaminatora;

use Tk;
# use strict;
require Tk::ROText;

use FindBin qw($Bin);
use lib "$Bin/utilities";
use zadanieEgzaminatora;
use raportOkienkowy;
use wystawiaczOcen;
use robWstepnaListeEgzaminacyjna;
use zadanieZewnetrzneEgzaminatora;
use Koryguj;

@ISA = ("zadanieEgzaminatora");

################################
#
# Konstruktor
#

sub new{
  my $class = shift;
  my $self = {};
  bless($self,$class);

  ($self->{referencjaEgzaminatora},$self->{zadanie})=@_;
  if(!$self->{zadanie}){
    die("egzekutorEgzaminatora: Nieokrelone zadanie!");
  }
  $self->{par}=$self->{referencjaEgzaminatora}->{par};
  $self->{mainWindow}=$self->{referencjaEgzaminatora}->{mainWindow};
  $self->{ramaZadania}=$self->{referencjaEgzaminatora}->{ramaZadania};
  $self->{numerDomyslnyEdycji}=$self->{par}->{numerDomyslnyEdycji};

  # Hasz zbierajcy wszystkie widgety wygenerowane dla danego zadania,
  # by mona byo potem je uniwersalnie pozamyka
  $self->{widgety}=[];

#print "use $self->{zadanie}\n";
my $out=eval("use $self->{zadanie}");

  $self->{task} = eval("new $self->{zadanie}");
#print "Got: =$self->{task}=\n";
#  $self->{task} = eval("new $self->{zadanie}($self->{par})");
  $self->{task}->{referencjaZadania}=$self;
  $self->{task}->{par}=$self->{par};
  $self->{task}->ustawOpisy();
  $self->{tekstOpisuZadania}=$self->{task}->{tekstOpisuZadania};
  $self->{dopuscEdycje}=$self->{task}->{dopuscEdycje};

  return $self;
}

################################
#
# Wywietlenie zadania
#

sub pokaz{
  my $self = shift;


  $self->SUPER::pokaz();

  # W ram okna zadania wpisujemy okno tekstowe do wypisywania wynikw
  $self->{oknoWyniku} = $self->{oknoZadania}->Scrolled('ROText',-scrollbars => 'osoe', -width => 80, -height => 5, -relief => 'ridge', -background => 'gray')->
    pack(-side => 'left', -anchor => 'e', -fill => 'both', -expand => 1);

  # Intencj (nieprzetestowan) wstawki jest wczeniejsze generowanie okna raportu
  # To jest raczej zy pomys i trzeba sprawdzi, czy mona si go pozby
  if(!defined($self->{raport})){
    $self->{oknoRaportu}=$self->{oknoWyniku};
    $self->{raport}=new raportOkienkowy("raport.txt",$self->{oknoRaportu},$self->{mainWindow});
    $egzaminator::biezacyRaport=$self->{raport};
    $self->{task}->{raport}=$self->{raport};
  }
  my $task = $self->{task};

  # Przekazujemy wygenerowanemu zadaniu informacje o egzekutorze
  $task->{oknoRaportu}=$self->{oknoWyniku};
  $task->{mainWindow}=$self->{mainWindow};

  $self->{oknoOpisuZadania}->Button(-text => "Wykonaj", -command => ['wykonaj' => $task] )->
      pack(-side => 'top', -anchor => 'c');
  if($self->{dopuscEdycje}){
    $self->{numerEdycji}=$self->{numerDomyslnyEdycji} if(defined($self->{numerDomyslnyEdycji}));
    $self->{oknoOpisuZadania}->Label(-text => 'Numer edycji (opcjonalnie):', -anchor => 'c')->
      pack(-side => 'left', -anchor => 'e');
    $self->{oknoOpisuZadania}->Entry(-textvariable => \$self->{numerEdycji}, -width => 2)->
      pack(-side => 'left', -anchor => 'e');
  }

  if($self->{zadanie} eq 'robFormularzeTestu'){
    $self->{oknoOpisuZadania}->Checkbutton(-text => 'Tylko egzemplarz kontrolny',-variable => \$self->{task}->{tylkoTestKontrolny}, -anchor => 'c')->
    pack(-side => 'right', -anchor => 'e');
# Opcja wykomentowana, bo mamy teraz oddzielne zadanie edycji listy studentw
#    $self->{oknoOpisuZadania}->Checkbutton(-text => 'Przygotuj rcznie list studentw',-variable => \$self->{task}->{tworzPlikStudencki}, -anchor => 'c')->
#    pack(-side => 'bottom', -anchor => 'e');
  }
}


###########################################################################

1;
