##################
#
# Klasa robFormularzeOdpowiedzi
#
#

package robFormularzeOdpowiedzi;
use pracujNaEdycjiTestu;

@ISA=("pracujNaEdycjiTestu");

use utilities;
use StudentRecordBase;

####################################################
#
# opisy
#
sub ustawOpisy{
  my ($self)=@_;
  $self->{naglowekOpisuZadania}=<<END
Przygotowanie formularzy odpowiedzi
END
  ;
  $self->{tekstOpisuZadania}=<<END
Do przygotowania formularzy odpowiedzi mona przystpi po przygotowaniu
ostatecznej listy studentw. Jeli na licie tej jest wicej studentw ni
pierwotnie, naley te powtrnie wygenerowa formularze testu oraz dodrukowa
wygenerowane dodatkowe formularze testu.
   Jest rwnie dopuszczalne uaktualnienie listy studentw (gdyby w ostatniej
chwili miaa nastpi zmiana) i po powtrnym wygenerowaniu formularzy odpowiedzi
dodrukowanie formularzy dodatkowych studentw, ktrzy zostan umieszczeni
po studentach z wczeniejszej listy.
END
  ;
  $self->{dopuscEdycje}=1;
}

################################
#
# Funkcja przygotowuje pust list do uzupenie
#
sub writeEmptyStudentSupplementList{
  my ($self)=@_;

  my $par={};
  $par->{'StanListy'}="suplement";
  my $emptyStudentRB = new StudentRecordBase;

  my @sortingFieldsArray=qw(nazwisko imie indeks);
  my @protokolHeaderFieldsArray=qw(DaneRekordu StanListy);
  my @protokolFieldsArray=     qw(numerOsoby indeks nazwisko imie examId numerProtokolu punktyCwiczeniowe);
  # Na podstawie poniszego argumentu funkcja write wypisuje pole DaneRekordu
  my @protokolFieldsNamesArray=qw(numerOsoby indeks nazwisko imie examId numerProtokolu punktyCwiczeniowe);

  my $dir='studenci';
  $dir="$dir-$self->{par}->{edycja}" if($self->{par}->{edycja});
  my $fileName="$self->{par}->{nazwaBazowaTestu}.studenci-suplement.csv";
  if(-d $dir && !(-r "$dir/$fileName")){
    $emptyStudentRB->write("$dir/$fileName",$par,\@protokolHeaderFieldsArray,\@protokolFieldsArray,\@sortingFieldsArray,\@protokolFieldsNamesArray);
  }
}

################################
#
# Funkcja przygotowuje pust list do uzupenie
#
sub writeEmptyKorektaList{
  my ($self)=@_;

  my $nazwaSkroconaTestu = ( $self->{par}->{nazwaBazowaTestu} =~ /^[^.]+.([^.]+$)/ ? $1 : 'egzamin');
  my $punktyEgzaminowe="punktyEgzaminowe-$nazwaSkroconaTestu";
  my $par={};
  $par->{'StanListy'}="aneks";
  my $emptyStudentRB = new StudentRecordBase;
  my @sortingFieldsArray=qw(nazwisko imie indeks);
  my @protokolHeaderFieldsArray=qw(DaneRekordu StanListy);

  my @protokolFieldsArray=     qw(numerOsoby indeks nazwisko imie $punktyEgzaminowe ocena);
  $protokolFieldsArray[4]=$punktyEgzaminowe;
  # Na podstawie poniszego argumentu funkcja write wypisuje pole DaneRekordu
  my @protokolFieldsNamesArray=qw(numerOsoby indeks nazwisko imie $punktyEgzaminowe ocena);
  $protokolFieldsNamesArray[4]=$punktyEgzaminowe;

  my $dir='studenci';
  $dir="$dir-$self->{par}->{edycja}" if($self->{par}->{edycja});
  my $fileName="korekta.csv";
  if(-d $dir && !(-r "$dir/$fileName")){
    $emptyStudentRB->write("$dir/$fileName",$par,\@protokolHeaderFieldsArray,\@protokolFieldsArray,\@sortingFieldsArray,\@protokolFieldsNamesArray);
  }
}

################################
#
# Funkcja przygotowuje pust list do uzupenie
#
sub writeEmptyAnulowaneSkorygowane{
  my ($self)=@_;

  my $fileName="anulowane.txt";
  if(!(-r "$fileName")){
    open(A,">$fileName");
    print A <<END
# W pliku tym umieszcza si odpowiedzi, ktre maj by anulowane
# co oznacza, e dla kadego studenta indywidualnie jego odpowied na anulowane
# pytanie zostanie zastpiona odpowiedzi dla niego korzystniejsz
#
# Poniej wpisz odpowiedzi anulowane w formacie nnX
# gdzie nn oznacza numer pytania, a X jedn z odpowiedzi A,B,C,D lub E
END
    ;
    close(A);
  }

  my $fileName="skorygowane.txt";
  if(!(-r "$fileName")){
    open(A,">$fileName");
    print A <<END
# W pliku tym umieszcza si odpowiedzi, ktre maj by skorygowane
# to znaczy zmienione z false na true lub odwrotnie
#
# Poniej wpisz odpowiedzi skorygowane w formacie nnX
# gdzie nn oznacza numer pytania, a X jedn z odpowiedzi A,B,C,D lub E
END
    ;
    close(A);
  }
}
############################## robLubOcenEdycjeTestu ######################
#
#  Wersja metody robLubOcenEdycjeTestu dla klasy robFormularzeOdpowiedzi

sub robLubOcenEdycjeTestu{
  my ($self,$plikKonfiguracyjnyEdycji)=@_;
  my ($uzywanyTest,$par,$sito,$niezbednaIloscTestow,$studentsByExamId,$pierwszyWolnyNr)=$self->init($plikKonfiguracyjnyEdycji);
  return if(!$uzywanyTest);
  my ($test,$form,$genListEgz);
  $test = $uzywanyTest->new($par,$sito,$niezbednaIloscTestow,$self->{raport});
  $form=new answerForm($par,$par->{iloscProblemow},$par->{iloscOpcji},$pierwszyWolnyNr,$self->{raport});
  $test->prepareForms($form,$studentsByExamId);
  $self->{raport}->wymaluj("Generuj listy egzaminacyjne.\n");
  $genListEgz=new generatorListEgzaminacyjnych($par,$par->{nazwaBazowaTestu},$self->{raport});
  $genListEgz->rozpiszEgzaminy();
  $self->writeEmptyStudentSupplementList();
  $self->writeEmptyKorektaList();
  $self->writeEmptyAnulowaneSkorygowane();
}

############################## wykonaj ######################
#

sub wykonaj{
  my ($self)=@_;

  if(-d "skaner"){
    $self->{referencjaZadania}->{mainWindow}->Dialog(
       -title => 'Powtrna generacja formularzy odpowiedzi',
       -text => "Egzamin zawiera zeskanowane testy.\n".
                "Tworzenie formularzy odpowiedzi uniemoliwi ocen zeskanowanych testw.\n".
                "Jeli mimo to chcesz kontynuowa, wczeniej rcznie usu katalog skaner",
       -default_button => 'OK',
       -buttons => ['OK'],
     )->Show();
     return;
  }

  $main::opt_e=$self->{referencjaZadania}->{numerEdycji} if($self->{referencjaZadania}->{numerEdycji} =~ /\d/);
  $self->wykonajPoczatek();
  $self->wykonajWlasciweZadanie();
  $self->wykonajKoniec();

}

########################################################################

1;