##################
#
# Klasa skanujTesty
#
# wspiera uruchamianie FineReadera
# w celu skanowania testw
#
#

package skanujTesty;

use utilities;
use zadanieZewnetrzneEgzaminatora;

@ISA = ("zadanieZewnetrzneEgzaminatora");

####################################################
#
# opisy
#
sub ustawOpisy{
  my ($self)=@_;
  $self->{naglowekOpisuZadania}=<<END
Skanowanie wynikw testu
END
  ;
  $self->{tekstOpisuZadania}=<<END
  W celu zeskanowania testw uruchamiony zostanie program
FineReader. Przy zapisywaniu zeskanowanych wynikw
naley upewni si czy zapis nastpi do podkatalogu skaner
umieszczonego w katalogu gwnym testu. FineReader domylnie
proponuje zapis nie w katalogu roboczym, lecz w katalogu
w ktrym zapisywa poprzednim razem, wic atwo o pomyk.
Do ju zeskanowanych testw mona w dowolnym momencie doskanowa
nowe. Po kadym skanowaniu naley jednak ponownie zapisa
wyniki skanowania w katalogu skaner.
END
  ;
  $self->{'nazwaEgzekutoraZewnetrznego'}='FineReader';

  if($self->{par}->{wlasnyCzytnik}){
    $self->{tekstOpisuZadania}=<<END
  Uruchamiony zostanie program skanujcy. Naley dokona wyboru skanera.
W okienku skanera naley ustawi rozdzielczo 300dpi, skanowanie czaronbiae,
jednostronne. Nastpnie naley przeprowadzi skanowanie i zamkn okienko
skanera. Zapis wynikw skanowania dokona si automatycznie. Uwaga: po
zeskanowaniu pierwszego formularza moe wystpi kilkusekundowa przerwa.
Do ju zeskanowanych testw mona w dowolnym momencie doskanowa nowe.
Proces skanowania i rozpoznawania mona rozdzieli dobierajc odpowiednie opcje.
Istnieje moliwo rozpoznawania skanw wykonanych innym programem i zapisanych
w formacie tif  (np. programem FineReader) lub png.
Musz zosta umieszczone w podkatalogu o nazwie skaner, nazwane skanernnnn.tif
(lub odpowiednio skanernnnn.png) gdzie nnnn oznacza numer skanu: 0001, 0002, .... .
W katalogu skaner trzeba te umieci plik lastRecordNumber.txt, a w nim
numer ostatniego skanu (bez wiodcych zer).
END
    ;
    $self->{'nazwaEgzekutoraZewnetrznego'}='ScanAndRecognize';
  }
  $self->{dopuscEdycje}=0;
#  $self->{'nazwaEgzekutoraZewnetrznego'}=(
#    $self->{par}->{wlasnyCzytnik} ?
#    'ScanAndRecognize' :
#    'FineReader'
#  );
}

################################
#
# Konstruktor
#

sub new{
  my $class = shift;
  my $self = {};
  bless($self,$class);
## Niepotrzebne, wywoywane w egzekutorEgzaminatora
#  $self->ustawOpisy();
#  $self->{'nazwaEgzekutoraZewnetrznego'}='FineReader';
#  Na tym etapie jeszcze nie okrelony $self->{par}, ustawiany przez egzekutorEgzaminatora
#  $self->{'nazwaEgzekutoraZewnetrznego'}=(
#    $self->{par}->{wlasnyCzytnik} ?
#    'ScanAndRecognize' :
#    'FineReader'
#  );
  return $self;
}

################################
# Potrzebujemy plik recognizedRecords.txt
# z wykazem rozpoznanych formularzy testu
# FineReader takiego pliku nie tworzy, ale
# tworzy plik *.box dla kadego rozpoznanego testu
# Na jego podstawie tworzymy stosowny plik recognizedRecords.txt
# Potrzene w okresie przejciowym, gdy jeszcze s zapisy
# z FineReadera

sub zrobNazwyRekordow{
  my ($self)=@_;

  opendir (DIRHANDLE, ".");
  my @filelist = readdir (DIRHANDLE);
  closedir(DIRHANDLE);
  open(NR,">recognizedRecords.txt");
  # Poszukuj pliki o rozszerzeniu *.box
  my $i=0;
  foreach my $file(@filelist){
    if($file =~ /(skaner\d+)\.box$/i){
      print NR $1,"\n";
    }
  }
  close(NR);
}

####################################################
#
# wywyoanie programu skanujcego testy
#

sub wykonajWlasciweZadanie{
  my ($self)=@_;

  my $baseName="skaner";
  my $frFile="$baseName.frm";
  my $pwd=pwd();

  mkdir('skaner',0660) if(!(-d 'skaner'));
  chdir('skaner');
  my $command;
  if($self->{par}->{wlasnyCzytnik}){
    my $bin=$self->{referencjaZadania}->{par}->{Bin};
    $bin =~ s|\/|\\|g;
    my $c='ScanAndRecognize';
    $c='Scan' if($self->{tylkoSkanowanie});
    $c='ReadAndRecognize' if($self->{tylkoRozpoznawanie});
    $command="$bin\\$c $bin";
#    $command="$bin\\ScanAndRecognize $bin\\";
 print "Command $command\n";
    copy("$self->{referencjaZadania}->{par}->{Bin}/egzaminator/szablony/mtba4-50-5/wzorzec.bmp","wzorzec.bmp");
  }else{
    if(!(-r $frFile)){
      my $dir="$self->{referencjaZadania}->{par}->{Bin}/egzaminator/szablony/mtba4-50-5";
      opendir(DIR,$dir);
      my @filelist=readdir(DIR);
      closedir(DIR);
      foreach my $file(@filelist){
        if($file =~ /^mtba4-50-5.(\w+)$/){
          print "Copying $file:  $self->{referencjaZadania}->{par}->{Bin}/egzaminator/szablony/mtba4-50-5/$file\n" if($main::opt_v);
          copy("$self->{referencjaZadania}->{par}->{Bin}/egzaminator/szablony/mtba4-50-5/$file","$baseName.$1");
        }
      }
      print "Utworzono $frFile\n";
    }
    $command="\"$self->{referencjaZadania}->{par}->{FineReader}\"  -Form $baseName.frm";
  }
  $self->{oknoRaportu}->insert('end',"Wywouj: $command\n");
#  my $out=`$command`;
#  $self->{oknoRaportu}->insert('end',"$out\n");
  open(IN,"$command |") or die("Failed to run $command\n");
  my $line;
  while($line = <IN>){
    $self->{oknoRaportu}->insert('end',$line);
  }
  close(IN);
  die("Command $command returned error: $CHILD_ERRROR\n") if ($CHILD_ERRROR);
  # W przypadku FineReadera potrzebujemy jeszcze stworzy plik records.txt
  if(!$self->{par}->{wlasnyCzytnik}){
    $self->zrobNazwyRekordow();
  }
  chdir('..');
}

########################################################################

1;

