################################
#
# klasa abstrakcyjna examTest
#
# klasa czyta zestaw pyta do testu
# (ewentualnie podzielony na grupy)
# i generuje losowe testy

package examTest;

use strict;
use utilities;
use binary;
use student;
use FindBin qw($Bin);



################################
#
# Konstruktor
sub new{
  my ($class,$par,$seed,$niezbednaIloscTestow,$raport) = @_;
  my $self = {};
  bless($self,$class);

# Do wypisywania raportw
  $self->{raport} = $raport;

# UWAGA ponizsze dwa pola sa jedynie wykorzystywane przy tworzeniu testow
# Przy ocenie testow sa one czytane z pliku z kluczami odpowiedzi
# Mozna je ew. wtedy wykorzystac do sprawdzenia czy sa z ponizszymi identyczne
# i sprawdzac czy oceniamy test z poprawnymi parametrami
  $self->{maxIloscOpcji} = $par->{iloscOpcji};
  $self->{iloscProblemow} = $par->{iloscProblemow};
print "examTest: iloscProblemow: $self->{iloscProblemow}\n";


  $self->{par}=$par;
  $self->{iloscProblemowWGrupie} = $par->{iloscProblemowWGrupie} ? $par->{iloscProblemowWGrupie} : $par->{iloscProblemow};
  $self->{nazwaBazowaTestu} = $par->{nazwaBazowaTestu};
  $self->{formularzWzorcowy} = $par->{formularzWzorcowy};
  $self->{formatKoncowy} = $par->{formatKoncowy};
  $self->{kurs}=$par->{kurs};
  $self->{test}=$par->{test};
  $self->{data}=$par->{data};
  $self->{data}=$par->{data}=$par->{termin} if(!$par->{data}); # Bo w starej wersji uywaem termin w miejsce data
  $self->{sala}=$par->{sala};
  $self->{iloscZapasowychExamId}=$par->{iloscZapasowychExamId};
  $self->{ilosc_okienek_kodu} = $par->{ilosc_okienek_kodu};
  $self->{ostatniZapasowyExamId} = $par->{ostatniZapasowyExamId};
  $self->{pierwszyZapasowyExamId} = $par->{pierwszyZapasowyExamId};
  $self->{odpowiedziWNowejLinii} = $par->{odpowiedziWNowejLinii};
  $self->{typStrony} = $par->{typStrony};
  # nazwaSkroconaTestu powinna by taka jak podano w terms.txt
  # jeli wic nazwaBazowaTestu zawiera kropk, to bierzemy tylko drug cz
#  $self->{nazwaSkroconaTestu} = ( $self->{nazwaBazowaTestu} =~ /^[^.]+.([^.]+$)/ ? $1 : $self->{nazwaBazowaTestu});
  $self->{nazwaSkroconaTestu} = ( $self->{nazwaBazowaTestu} =~ /^[^.]+\.([^.]+$)/ ? $1 : 'egzamin');
  my $typStrony = $self->{typStrony};

  $self->{testGraphicFormExtension}=($self->{par}->{wlasnyCzytnik} ? 'png' : 'tif' );

  my $odstepMiedzyLiniami=
     (defined($par->{odstepMiedzyLiniami})?$par->{odstepMiedzyLiniami}:int(1.2*$par->{wielkoscCzcionki}));
  my $wielkoscCzcionkiOrazOdstepMiedzyLiniami=
     (defined($par->{wielkoscCzcionki})?"\\fontsize{$par->{wielkoscCzcionki}}{$par->{odstepMiedzyLiniami}}\\selectfont":'');


  # Generujemy nazwy plikw
  $self->fileNames($self->{nazwaBazowaTestu});

  # Licznik liczb losowych ustawiamy na podanym w linii komend
  # a jesli nie podano, bierzemy aktualny czas
  my $inttime=int(time());
  $self->{seed}=($seed ? $seed : $inttime % 10000);
  srand($self->{seed});

  my $extraTests = $par->{iloscTestowDodatkowych};
  $extraTests=($extraTests =~ /\d/ ? $extraTests : int(0.03*$niezbednaIloscTestow+0.5));
  # Test zerowy dla celow kontrolnych + test dla kadego studenta + testy awaryjne + testy dla zapasowych
print "niezbednaIloscTestow=$niezbednaIloscTestow\n";
print "extraTests=$extraTests\n";
print "self->{iloscZapasowychExamId}=$self->{iloscZapasowychExamId}\n";
  $self->{iloscTestow}=1+$niezbednaIloscTestow+$extraTests+$self->{iloscZapasowychExamId};


  # Od tego numeru bed nadawane numery studentom jesli wystapi duplikat numeru studenta
  # Numer tak duy by nie bylo konfliktu z wczesniej nadanymi numerami
  $self->{awaryjnyNumerStudenta} = 10000;

  my $rozdzielczosc = ($par->{rozdzielczosc} == 10) || ($par->{rozdzielczosc} == 11)  ? "$par->{rozdzielczosc}pt" : "12pt";
  $self->{iloscKolumn} = $par->{iloscKolumn} == 2 ? 2 : 1;
  my $twoColumn = $self->{iloscKolumn} == 2 ? ",twocolumn" : "";
  my $twoSide = $par->{typDrukarki} == 2 ? ",twoside" : "";
  my $mathTest = $par->{mathTest}  ? "\\usepackage{amsmath}\n\\input myMathDefinitions\n" : "";
  my $articleType = $par->{mathTest}  ? "amsart" : "article";
  # przy wydrukach PDFowych w formacie Landscape konieczne jest zaznaczenie wymiarw strony
  my $pdfLandscape=( $typStrony == 2 && $self->{formatKoncowy} == 4 ? <<END
\\setlength{\\pdfpageheight}{210mm}
\\setlength{\\pdfpagewidth}{297mm}
END
  : "");

  # Nagwek formularza testu: uwzgldniamy ukad na stronie dany parametrami
  $self->{testCopiesHead} =<<END
\\documentclass[$rozdzielczosc$twoColumn$twoSide,a4paper]{$articleType}
\\pagestyle{empty}
\\usepackage{polski}
\\usepackage[cp1250]{inputenc}
$mathTest
$pdfLandscape
END
   ;

  # Nagwek formularza testu do weryfikacji przez studenta, zawsze w tym samym formacie
  $self->{verificationTestCopiesHead} =<<END
\\documentclass[10pt,a4paper]{$articleType}
\\pagestyle{empty}
\\usepackage{polski}
\\usepackage[cp1250]{inputenc}
$mathTest
END
   ;


  my $szerokoscWydruku=$self->{par}->{szerokoscWydruku};
  my $wysokoscWydruku=$self->{par}->{wysokoscWydruku};
  $szerokoscWydruku=195 if(!$szerokoscWydruku);
  $wysokoscWydruku=275 if(!$wysokoscWydruku);

  my ($textHeight,$textWidth)=( $typStrony == 1 ? ($wysokoscWydruku."mm",$szerokoscWydruku."mm") : ($szerokoscWydruku."mm",$wysokoscWydruku."mm") );
  # na pocztek wpisujemy do nagwka dane formatujce stron
  # chodzi o zminimalizowanie marginesw
  $self->{testCopiesHead}.=<<END
\\setlength{\\textheight}{$textHeight}
\\setlength{\\textwidth}{$textWidth}
END
  ;

  # teraz wpisujemy wszystkie definicje potrzebne w pliku texowym
  open(TEXDEF,"<$Bin/egzaminator/definicjeGeneratoraTestow.tex");
  my $znacznik = $/;
  undef $/;   #przeczytam caly plik na raz
  my $texDefinicje = <TEXDEF>;
  close(TEXDEF);
  $/ = $znacznik; #przywracam stara warto separatora
  $self->{testCopiesHead} .= $texDefinicje;
  $self->{verificationTestCopiesHead} .= $texDefinicje;


  # Zmienna showanswers TeXa ustala czy w tecie bd zaznaczone poprawne
  # odpowiedzi (potrzebne do celw kontrolnych). Tu moemy j ustawi na tak,
  # bo przy generacji testu w inny sposb regulujemy czy korzystamy z tego mechanizmu
  # czy nie (patrz generateCopy)
  $self->{testCopiesHead} .=<<END
\\begin{document}
\\let\\showanswers y
$wielkoscCzcionkiOrazOdstepMiedzyLiniami
END
   ;
  $self->{verificationTestCopiesHead} .=<<END
\\begin{document}
\\let\\showanswers y
END
   ;

# Sprawdzamy jak koczyc strone dla dukarki:
# dla drukarki jednostronnej - \clearpage
# dla drukarki dwustronnej - \cleardoublepage

  $self->{testCopyTail} = $par->{typDrukarki} == 2 ? "\\cleardoublepage" : "\\clearpage";

  $self->{testCopiesTail}  = "\\end{document}";

  return $self;


}

################################
#
# Generator nazw plikw
sub fileNames{
  my ($self,$baseFileName)=@_;
  $self->{resultsDir}="";
  $self->{auxDir}="auxil/";

  $self->{input}=$baseFileName . ".src";
  $self->{input}=$baseFileName . ".xml" if($self->{par}->{formatTestu} eq 'xml');
  $self->{output}=$baseFileName . "-testy.tex";
  $self->{groupDescriptions_output}=$baseFileName . "-opisy.tex";
  $self->{forms_output}=$baseFileName . "-formularze.tex";
  $self->{lecturer_output}=$baseFileName . "-dodatkoweFormularze.tex";
  $self->{solvedTest_output}=$baseFileName . "-rozwiazanyTest.tex";
  $self->{controlTest_output}=$baseFileName . "-kontrolnyTest.tex";
  $self->{testkey_output}=$self->{auxDir}.$baseFileName . ".ans";
  $self->{template_output}="wzorcowy_formularz.tex";
  $self->{student_answers}=$baseFileName . ".txt";

  $self->{partialResults}=$self->{auxDir}.$baseFileName . "-wynikiCzesciowe.csv";
  $self->{results}=$self->{resultsDir}.$baseFileName . "-wyniki.csv";
  $self->{resultsGlobal}=$self->{auxDir}.$baseFileName . "-wyniki-dokladne.txt";
  $self->{resultsHTML}=$self->{resultsDir}.$baseFileName . "-wyniki.html";
  $self->{resultsHTMLforStudents}=$self->{resultsDir}.$baseFileName . "-wynikiDlaStudentow.html";
  $self->{resultsHTMLsortedByResult}=$self->{resultsDir}.$baseFileName . "-wynikiPosortowane.html";

  $self->{resultsByName}=$self->{resultsDir}.$baseFileName . "-wyniki-wg-nazwiska.txt";
  $self->{resultsByIndex}=$self->{resultsDir}.$baseFileName . "-wyniki-wg-indeksu.txt";
  $self->{zapasowe_numery}=$self->{resultsDir}.$baseFileName . "-zapasowe-numery.tex";
}

############################### Stamp #########################
#  Generuje kontroln seri, ktra m.in. na kocu zawiera seed
#
sub make_stamp{
  my ($self)=@_;
  my @aux=split(/\s*/,uc($self->{kurs}));
  my ($w,$ctrl)=('',0);
  my $word="";
  foreach $w (@aux){
    $word+=ord($w)-ord('A');
  }
  my $data=$self->{data};
  if($data =~ /^(\d+-\d+-\d+)/){
    $data=$1;
  };
  my $seria="$word:$data:$self->{seed}";
print "Generated stamp: $seria\n";
  $seria =~ s/\s+/:/g;
  $self->{seria}=$seria;
  return $seria;
}




################################
#
# Funkcja czyta plik rdowy z testem
# i generuje odpowiedni obiekt
sub read{
  die("examTest:: read not implemented in abstract class\n");
}


1;
