################################
#
# klasa abstrakcyjna examTest2XML
#
# Pochodna od examTestGenerator

package examTest2XML;



use examTestGenerator;

@ISA = ("examTestGenerator");

################################
#
# Funkcja zamyka tekst w CDATA
#

sub cdata{
  my ($self,$text)=@_;
  return "<![CDATA[$text]]>";
}

################################
#
# Funkcja generuje zadane wcicie w porcji tekstu
#

sub makeIndent{
  my ($self,$text,$indent)=@_;
  $text=$self->cdata($text) if($text =~ /[&<>'"]/); #"'
#  my @chunks=split(/\s*\n\s*/,$text);
  my @chunks=split(/\n/,$text);
  foreach my $piece (@chunks){
    $piece=$indent.$piece;
  }
  $text=join("\n",@chunks);
  return "$text\n";
}

################################
#
# Funkcja zwraca stosown ilo spacji
#

sub blanks{
  my ($self,$number)=@_;
  my $text='';
  while($number-- > 0){
    $text.=' ';
  }
  return $text;
}


################################
#
# Funkcja zapisuje test w formacie XML
#
sub XMLform{
  my ($self)=@_;
  my $out="<?xml version=\"1.0\" encoding=\"windows-1250\"?>\n";
  $out.="<test>\n";
  my $indentUnit=4;
  my $currentIndent=0;
  foreach my $groupId (sort keys(%{$self->{groups}})){
    $currentIndent+=$indentUnit;
    my $group=$self->{groups}->{$groupId};
    $out.=$self->blanks($currentIndent)."<group>\n";
    $indent=$currentIndent;
    $out.=$self->makeIndent($group->{text},$self->blanks($currentIndent+$indentUnit));
    foreach my $problemId (sort keys(%{$group->{problems}})){
      $currentIndent+=$indentUnit;
      my $problem=$group->{problems}->{$problemId};
      $out.=$self->blanks($currentIndent)."<problem>\n";
      $out.=$self->makeIndent($problem->{text},$self->blanks($currentIndent+$indentUnit));
      foreach my $answerId (sort keys(%{$problem->{answers}})){
        $currentIndent+=$indentUnit;
        my $answer=$problem->{answers}->{$answerId};
        if($answer->{value}){
          $out.=$self->blanks($currentIndent)."<answer value=\"true\" >\n";
        }else{
          $out.=$self->blanks($currentIndent)."<answer value=\"false\" >\n";
        }
        $out.=$self->makeIndent($answer->{text},$self->blanks($currentIndent+$indentUnit));
        $out.=$self->blanks($currentIndent)."</answer>\n";
        $currentIndent-=$indentUnit;
      }
      $out.=$self->blanks($currentIndent)."</problem>\n";
      $currentIndent-=$indentUnit;
    }
    $out.=$self->blanks($currentIndent)."</group>\n";
    $currentIndent-=$indentUnit;
  }
  $out.="</test>\n";
  return $out;
}

1;
