################################
#
# klasa abstrakcyjna examTestEvaluator
#
# Pochodna od examTestGenerator
# W niej implementowana jest obrbka wynikw testu

package examTestEvaluator;


@ISA = ("examTestGenerator");
use FindBin qw($Bin);

use binary;
use examTestGenerator;
use XML::TreeBuilder;
use XML::Element;
use polChar;
use utilities;
use textUtil;
use StudentRecordBase;
use printerPDF;
use ExamUtil;


################################
#  Funkcja kontrolna
#
sub checkStudentsByExamId{
  my ($self,$studentsByExamId,$location)=@_;
  my @studkeys=keys(%$studentsByExamId);
  my $studkey;

  my $errorFound=0;

  my $cnt=0;
  foreach $studkey (@studkeys){
    my $student=$studentsByExamId->{$studkey};
    if($studkey !~ /\d+/){
      $self->{raport}->wypisz("!!!Bad studKey=$studkey= nazwisko=$student->{nazwisko}=  nrTestu=$student->{nrTestu}=\n");
      $errorFound=1;
    }else{
      ++$cnt;
      $self->{raport}->wypisz("  --> studKey=$studkey= nazwisko=$student->{nazwisko}=  nrTestu=$student->{nrTestu}=\n");
    }
  }
  if($errorFound){
    $self->{raport}->wypisz("checkStudentsByExamId($location): Error\n");
  }else{
    $self->{raport}->wypisz("checkStudentsByExamId($location): OK\n");
  }
  $self->{raport}->wypisz(" studentsByExamId ma $cnt rekordow\n");
}


################################
#
# Sprawdzamy jaka jest nazwa bazowa zeskanowanych plikw
# przeszukujc katalog i poszukujc takich plikw
#
sub getScanBaseName{
  my ($self)=@_;
  opendir (DIRHANDLE, 'skaner');
  my @filelist = readdir (DIRHANDLE);
  closedir(DIRHANDLE);
  $self->{scanBaseName}='';
print "Testing for scanBaseName with self->{testGraphicFormExtension}=$self->{testGraphicFormExtension}\n";
  foreach my $file (@filelist){
# Poprawione, bo w katalogu skanera mog by rne nazwy bazowe o rozszerzeniu TIF
# jeli najpierw tylko skanowano, a potem wczytywano obrazy zamiast skanowania.
# Rozszerzenia BOX pojawiaj si dopiero w przypadku zakoczenia procesu OCR
# Ostatecznie wrciem dla FineReadera do tif (dla ScanReadera do png),
# bo te cyfry uniemoliwiaj rozpoznanie czego innego
#    if($file =~ /^(.*)\d\d\d\d\.TIF$/){
#    if($file =~ /^(.*)\d\d\d\d\.BOX$/){
    if($file =~ /^(.*)\d\d\d\d\.$self->{testGraphicFormExtension}$/i){
      $self->{scanBaseName}=$1;
      last;
    }
  }
#  $self->{raport}->wymalujError("Nie znaleziono zeskanowanych plikw -$typWydruku-=$self->{testGraphicFormExtension}= +$self->{scanBaseName}+\n") if(!$self->{scanBaseName} && !$self->{par}->{wlasnyCzytnik});
  $self->{raport}->wymalujError("Nie znaleziono zeskanowanych plikw -$typWydruku-=$self->{testGraphicFormExtension}= +$self->{scanBaseName}+\n") if(!$self->{scanBaseName} );
}

################################
# Wyznaczamy pozycje w wizce zajmowane przez
# kolejnych studentw. Chodzi o przypadek
# gdy w rekordach FineReadera s le przeczytane
# kartki, ktre zaburzaj naturaln kolejno
# Robimy to poprzez odszukanie plikw o rozszerzeniu *.box
# Tylko poprawnie odczytane rekordy maj swoje *.box
#
# Nowa wersja poniej
sub obliczPozycjeWWiazceOld{
  my ($self)=@_;

  opendir (DIRHANDLE, "skaner");
  my @filelist = readdir (DIRHANDLE);
  closedir(DIRHANDLE);
  my @listaPoprawnychPozycji=();
  # Poszukuj pliki o rozszerzeniu *.box
  my $i=0;
  foreach my $file(@filelist){
    if($file =~ /(\d+)\.box$/i){
      $listaPoprawnychPozycji[$i++]=$1;
    }
  }
  $self->{pozycjeWWiazce}=[];
  @{$self->{pozycjeWWiazce}}=sort(@listaPoprawnychPozycji);
}

################################
# Z pliku recognizedRecords.txt
# odczytujemy pozycje w wizce zajmowane przez
# kolejnych studentw. Plik generowany jest przez
# ScanAndRecognize automatycznie, a dla FineReadera
# odpowiednia metoda jest w skanujTesty.pm
#
sub obliczPozycjeWWiazce{
  my ($self)=@_;


  if(!open(NR,"<skaner/recognizedRecords.txt")){
    die("Nie znaleziono pliku recognizedRecords.txt");
  }
  my @listaPoprawnychPozycji=();
  while(<NR>){
    chop;
    if(/^\s*skaner(\d+)$/){
      $listaPoprawnychPozycji[$i++]=$1;
    }
  }

  $self->{pozycjeWWiazce}=[];
  @{$self->{pozycjeWWiazce}}=sort(@listaPoprawnychPozycji);
}

#########################################################
# Odczytujemy plik skaner.txt (stara forma z FineReadera)
# i zapisujemy go w nowej formie records.exm
#
sub rewriteScannerFile{
  my ($self,$nazwaPliku)=@_;
  my $student;
  my $pozycjaWWiazce=0;
  my $iloscPolOdpowiedziTestowychFormularza;

  $self->getScanBaseName();

  # Mona uywa wzorca FineReadera, ktry ma przewidziane wicej pl odpowiedzi
  # ni zaplanowano na formularzu odpowiedzi. Dlatego potrzebna ponisza zmienna,
  # do ktrej wstawimy rozpoznan z wzorca ilo pl odpowiedzi
  my $maxIloscOpcjiWeWzorcu;

  $self->obliczPozycjeWWiazce();

  open(ANS,"<$nazwaPliku") || $self->{raport}->zakoncz("rewriteScannerFile: Failed to open $nazwaPliku\n");
  open(REC,">skaner/records.txt") || $self->{raport}->zakoncz("rewriteScannerFile: Failed to open records.exm\n");

  my $licznikPrzeanalizowanychStudentow=0;
  LOOP:
  while(<ANS>){
    chop();
    # Pierwsza linia zawiera etykiety poszczeglnych pl i powinna zaczyna si od litery
    # w przeciwiestwie do linii z odpowiedziami, ktre zaczynaj si od cyfry i tylko te czytamy
    if(/^\s*Field/){
       $self->{raport}->wymalujError("\n\nUyto starego wzorca. \n\nTa wersja pakietu wsppracuje tylko z wzorcami MTB\n");
    }
    if(/^\s*kod-studenta/){
      # Rozpoznajemy ile pl odpowiedzi byo przewidzianych we wzorcu
      if(/\s1e\s/){
        $maxIloscOpcjiWeWzorcu=5;
      }elsif(/\s1d\s/){
        $maxIloscOpcjiWeWzorcu=4;
      }elsif(/\s1c\s/){
        $maxIloscOpcjiWeWzorcu=3;
      }else{
        $maxIloscOpcjiWeWzorcu=2;
      }
      print "Found maxIloscOpcjiWeWzorcu=$maxIloscOpcjiWeWzorcu\n" if($main::opt_v);
      my @ans=split(/\t/);
      $iloscPolOdpowiedziTestowychFormularza=0;
      foreach my $a (@ans){
        $iloscPolOdpowiedziTestowychFormularza++ if($a =~ /^\s*\d+[a-zA-Z]\s*$/);
      }
    }
    if(/^\s*\d/){
       $pozycjaWWiazce=$self->{pozycjeWWiazce}->[$licznikPrzeanalizowanychStudentow++];
      # Rozkodowujemy dane
      my @ans=split(/\t/);
      my $nrStud=fill_to_left(fromBin(splice(@ans,0,9)),4);
      my $nrTestu=fromBin(splice(@ans,0,9));
      my $xnazwisko=shift(@ans);
      my $ximie=shift(@ans);
      my $xindeks=shift(@ans);
      my $seria=shift(@ans);

      # Teraz nastpuj waciwe odpowiedzi
      my @xans=splice(@ans,0,$iloscPolOdpowiedziTestowychFormularza);
      # Na kocu @ans znajduj si informacje dodane w rozszerzonym formularzu
#        my $left=$#ans;
      my $przeczytanyNumerEdycjiTerminu=fromBin(splice(@ans,0,3));
      my $przeczytanyNumerGrupySal=fromBin(splice(@ans,0,3));
      my $id=shift(@ans);
      my $ord=fill_to_left($licznikPrzeanalizowanychStudentow,4,'0');
      my $imageFile="$self->{scanBaseName}$ord.$self->{testGraphicFormExtension}";
      print REC "$imageFile;$licznikPrzeanalizowanychStudentow;$nrStud;$nrTestu;$przeczytanyNumerEdycjiTerminu;$przeczytanyNumerGrupySal;";
      for(my $i=0;$i<$iloscPolOdpowiedziTestowychFormularza;++$i){
        print REC $xans[$i];
        print REC ( ($i+1) % $maxIloscOpcjiWeWzorcu ? '-' : ':' ) if($i<$iloscPolOdpowiedziTestowychFormularza-1);
      }
      print REC "\n";
    }
  }
  close(ANS);
  close(REC);
}


################################
# Pomocnicza dla poniszej metody
#
sub extractResultsFromLine{
  my ($line)=@_;
  my @fields=split(';',$line);
  return $fields[@fields-1];
}

################################
# Odczytujemy jeden plik ze skanera
#
sub readOneFileWithStudentAnswers{
  my ($self,$studentsByExamId,$nazwaPliku)=@_;
  my $student;
  my $pozycjaWWiazce=0;
  # Jeli uywano FineReadera, trzeba przeformatowa dane do pliku records.txt
  if(!$self->{par}->{wlasnyCzytnik}){
    $self->rewriteScannerFile($nazwaPliku);
  }else{
    $self->getScanBaseName(); # W przeciwnym razie tylko ustalamy nazw bazow zeskanowanych plikw
  }

  open(ANS,"<skaner/records.txt") || $self->{raport}->zakoncz("readOneFileWithStudentAnswers: Failed to open records.txt\n");

  my $licznikPrzeanalizowanychStudentow=0;
  LOOP:
  while(<ANS>){
    my ($imageFile,$pozycjaWWiazce,$nrStud,$nrTestu,$przeczytanyNumerEdycjiTerminu,$przeczytanyNumerGrupySal,$ans)=rozpakujWyniki($_);
    my ($xnazwisko,$ximie,$xindeks,$seria,$id);
    next if($przeczytanyNumerEdycjiTerminu != $self->{par}->{numerEdycjiTerminu});
    next if($przeczytanyNumerGrupySal != $self->{par}->{numerGrupySal});

    # Jeli numer studenta wynosi zero ....
    if($nrStud == 0){
      # i numer testu te wynosi zero, to jest to test kontrolny
      if($nrTestu == 0){
        $student = new student("kontrolny","test","0000");
        my $lp=fill_to_left("0",4);
# print "Dodano test kontrolny z kluczem =$lp= do studentsByExamId\n";
        if($lp =~ /\d/){
          $studentsByExamId->{$lp}=$student;
        }else{
          $self->{raport}->wymalujError("Prba dodania klucza do studentsByExamId nie bdcego liczb\n");
        }
      # ale zerowy numer studenta z niezerowym numerem testu to bd!
      }else{
         $self->{raport}->wymalujError("Znaleziono test kontrolny (nr studenta == 0) z niezerowym numerem testu = $nrTestu!!!\n");
      }
    # natomiast przy niezerowym numerze studenta pobieramy jego rekord,
    # chyba, e takiego studenta nie zarejestrowano
    }else{
      # sygnalizujemy, jeli takiego numeru nie zarejstrowano
      if(!$studentsByExamId->{$nrStud}){
        print "Nie zarejestrowano studenta o numerze examId rwnym $nrStud\n    Pozycja w wizce: $pozycjaWWiazce\n";
        next LOOP;
      }
      $student=$studentsByExamId->{$nrStud};
    }
# $self->{raport}->wypisz( "Znaleziono student=$student= nrStud=$nrStud= nazwisko=$student->{nazwisko}=\n");
    # Jeli student (zlokalizowany wedug numeru studenta) ma ju przypisany numer testu,
    # to znaczy, e wystpi duplikat numeru studenta. Moe to by spowodowane:
    # bdem skanera, niepoprawnym rcznym wpisaniem numeru studenta
    # lub dwukrotnym przeskanowaniem tego samego testu
    if( defined( $student->{nrTestu} ) ){
      my $alternatywnaPozycjaWWiazce=$studentsByExamId->{$self->{nrStudDlaNrTestu}->[$student->{nrTestu}]}->{pozycjaWWiazce};
      # Jeli obok numerw studentw pokrywaj si te numery testw
      # to chodzi najprawdopodobniej o t sam kartk zeskanowan dwukrotnie
      # i jeli wynik skanowania jest ten sam, nie ma si czym martwi
      if($nrTestu == $student->{nrTestu}){
        if(extractResultsFromLine($_) eq $student->{zestawWynikow}){
#              $self->{raport}->wypisz("\n\nStudent (examId=$nrStud) z testem $nrTestu pojawi si ponownie\n".
#                  "Dwukrotnie zeskanowano ten sam test z tym samym wynikiem. \n");
        }else{
          $self->{raport}->wymalujError("\n\nStudent (examId=$nrStud) z testem $nrTestu pojawi si ponownie,\n".
              "ale z rnymi odpowiedziami \n" .
              "Trzeba sprawdzic wynik skanowania: $nazwaPliku(frm)\n Pozycja w wizce: $pozycjaWWiazce i $alternatywnaPozycjaWWiazce\n");
        }
      # Jeli jednak numer testu jest inny, to na pewno jest to bd
      }else{
        # Jeli zapamitany numer testu wynosi zero,
        # to najprawdopodobniej chodzi o powtrnie
        # zeskanowany formularz, w ktrym uzupeniono numer testu nie
        # wpisany przez studenta. Anulujemy stare odpowiedzi
        # i wprowadzamy je od nowa
        if($student->{nrTestu} == 0){
          $student->{nrTestu}=$nrTestu;
          $student->{brakNrTestu}=0;
#              $student->{nieobecny}=0;
          $student->{nieobecny}='';
        # w przeciwnym razie mamy do czynienia z duplikatem i generujemy dla niego
        # nowy rekord
        }else{
          $self->{raport}->wymalujError("\n\nWsrod odpowiedzi wystapil duplikat numeru studenta (examId = $nrStud)\n".
              "Sprawdz plik: $nazwaPliku(frm), pozycja w wizce: $pozycjaWWiazce lub $alternatywnaPozycjaWWiazce\n");
          $student = new student("Duplikat-". $student->imie(),"Duplikat-".$student->nazwisko(),"Duplikat-$student->{indeks}");
          # Student o tym numerze ju jest, wic temu drugiemu nadajemy kolejny awaryjny numer
          $nrStud = $self->{awaryjnyNumerStudenta};
          $self->{awaryjnyNumerStudenta}++;
          if($nrStud =~ /\d/){
            $studentsByExamId->{$nrStud}=$student;
          }else{
            $self->{raport}->wymalujError("Prba dodania studenta Duplicat- ze nieliczbowym kluczem do studentsByExamId\n");
          }
        }
      }
    }

    # zapamitujemy informacje o studencie
    $student->{nrTestu}=$nrTestu;
# print "Zapamitano student=$student nrTestu=$nrTestu\n";
    $student->{pozycjaWWiazce}=$pozycjaWWiazce;
    # W celach kontrolnych zapamitujemy lini dotyczc studenta w pliku zeskanowanych odpowiedzi
    $student->{zestawWynikow}=extractResultsFromLine($_);

    $student->{xnazwisko}=$xnazwisko;
    $student->{ximie}=$ximie;
    $student->{xindeks}=$xindeks;

    # Wreszcie zapamitujemy jakie odpowiedzi wprowadzi student
#    my ($i,$j);
    my $czy_jest_jakas_odpowiedz=0;
    for($i=0;$i<$self->{iloscProblemow};$i++){
      for($j=0;$j<$self->{maxIloscOpcji};$j++){
#          my $odp=$xans[$i*$maxIloscOpcjiWeWzorcu+$j];
        $student->{odpowiedzi}->[$i]->[$j]=$ans->[$i]->[$j];
        $czy_jest_jakas_odpowiedz = $czy_jest_jakas_odpowiedz || $odp;
      }
    }
    # Analizujemy przypadek gdy brak numeru testu, a nie jest to test kontrolny (nrStud != 0)
    # Robimy to dopiero po przeczytaniu odpowiedzi, bo jeli nic nie byo zaznaczone,
    # to najprawdopodobniej chodzi o studenta nieobecnego
    # W przeciwnym razie oznacza to, e student nie wpisa numeru testu
    if($nrTestu == 0 && $nrStud != 0){
      if($czy_jest_jakas_odpowiedz){
        $student->{brakNrTestu}=1;
        $self->{raport}->wymalujError("\n\nBrak numeru testu!!!\n".
              $student->imie(). " ".  $student->nazwisko().
              "  examId=$nrStud pozycja w wizce=" . $student->{pozycjaWWiazce} ."\n\n");
      }else{
        # Nie potrafimy sprawdzi w 100%, e student by nieobecny.
        # Nieobecny jest rwnie gdy odda pusty formularz odpowiedzi (bez numeru testu i adnej odpowiedzi)
#            $student->{nieobecny}=1;
        $student->{nieobecny}='nieobecny';
      }
    }
    # Jeli by to student obecny i wpisa numeru testu, to w celach kontrolnych
    # sprawdzamy czy przypadkiem nie znaleziono ju studenta z takim numerem testu,
    if( !$student->{nieobecny} && !$student->{brakNrTestu}){
      # Jeli zarejestrowano ju studenta, ktry pisa taki numer testu
      # zapamitujemy jego numer w zmiennej $podejrzany i ...
      if(my $podejrzany = $self->{nrStudDlaNrTestu}->[$student->{nrTestu}]){
        # w przypadku gdy $podejrzany jest inny ni analizowany student podnosimy alaram
        if($studentsByExamId->{$podejrzany} != $student){
          $self->{raport}->wymalujError("\n\nDuplikat numerow testow!!!\nTest numer: ". $student->{nrTestu}.
             "\nStudenci w pliku $nazwaPliku(frm): \n   ".
                $student->imie(). " ".  $student->nazwisko().
                "  examId=$nrStud pozycja w wizce=" . $student->{pozycjaWWiazce} ."\n   ".
                $studentsByExamId->{$podejrzany}->imie(). " ". $studentsByExamId->{$podejrzany}->nazwisko().
                "  examId=$podejrzany  pozycja w wizce=". $studentsByExamId->{$podejrzany}->{pozycjaWWiazce}."\n\n");
          $self->{licznikPowtorzenTestow}++;
        }
      }
      # Na koniec zapamitujemy jaki student pisa ten numer testu
      $self->{nrStudDlaNrTestu}->[$student->{nrTestu}]=$nrStud;
    }

    # Na kocu @ans znajduj si informacje dodane w rozszerzonym formularzu
#        my $left=$#ans;
    $student->{numerEdycjiTerminu}=$przeczytanyNumerEdycjiTerminu;
    $student->{numerGrupySal}=$przeczytanyNumerGrupySal;
    if($id =~ /\:/){
      my ($numerEdycjiTerminu,$numerGrupySal,$altNrStud)=split(/[-.,:;]/,$id);
      if($numerEdycjiTerminu != $student->{numerEdycjiTerminu}){
        $self->{raport}->wymalujError("\n\nBrak zgodnoci odczytu numeru terminu  ($student->{numerEdycjiTerminu} != $numerEdycjiTerminu)\n".
              $student->imie(). " " .  $student->nazwisko().
              "   Sprawdz plik: $nazwaPliku, pozycja w wizce: $pozycjaWWiazce \n");
        print "id=$id=($numerEdycjiTerminu,$numerGrupySal,$altNrStud)\n"
      }
      if($numerGrupySal != $student->{numerGrupySal}){
        $self->{raport}->wymalujError("\n\nBrak zgodnoci odczytu numeru sali  ($student->{numerGrupySal} != $numerGrupySal)\n".
              $student->imie(). " " .  $student->nazwisko().
              "   Sprawdz plik: $nazwaPliku, pozycja w wizce: $pozycjaWWiazce \n");
        print "id=$id=($numerEdycjiTerminu,$numerGrupySal,$altNrStud)\n"
      }
      if($altNrStud != $nrStud){
        $self->{raport}->wymalujError("\n\nBrak zgodnoci odczytu examId studenta  ($nrStud != $altNrStud)\n".
              $student->imie(). " " .  $student->nazwisko().
              "   Sprawdz plik: $nazwaPliku, pozycja w wizce: $pozycjaWWiazce \n");
        print "id=$id=($numerEdycjiTerminu,$numerGrupySal,$altNrStud)\n"
      }
    }
    $student->{nazwaPlikuZeSkanera}=$nazwaPliku;
  }
  close(ANS);
}

################################
#
# Generator kolejnych nazw plikow z odpowiedziami
sub kolejnyPlikOdpowiedzi{
  my ($self, $nr)=@_;
  my $nazwaPliku = $self->{nazwaBazowaTestu} . "_$nr.txt";
  return $nazwaPliku;
}



################################
# Odczytujemy plik ze skanera
# Dopuszczamy mozliwosc istnienia kilku plikow z odpowiedziami
# Kolejne (dodatkowe) pliki z odpowiedziami beda mialy tak nazwe
# powstala z $self->{student_answers} z doklejonym _i - gdzie i to kolejny mumer
#
sub readStudentAnswersOldForm{
  my ($self,$studentsByExamId)=@_;
  open(ANS,"<$self->{student_answers}") || $self->{raport}->zakoncz("Nie moge otworzy pliku: $self->{student_answers}\n");
  close(ANS);
  my $nrPliku = 1;
  my $nazwaPliku = $self->{student_answers};
  while( open(ANS,"<$nazwaPliku") ){
    $self->readOneFileWithStudentAnswers($studentsByExamId,$nazwaPliku);
    close(ANS);
    $nazwaPliku = $self->kolejnyPlikOdpowiedzi($nrPliku);
    $nrPliku++ ;
  }
}

################################
# Przegldamy katalog skaner i szukamy plikw z wynikami
# Jeli znajdziemy zero lub wicej ni jeden, sygnalizujemy bd
# W przeciwnym razie jedyny znaleziony plik czytamy
sub readStudentAnswersNewForm{
  my ($self,$studentsByExamId)=@_;

  if($self->{par}->{wlasnyCzytnik}){
    if(open(REC,"<skaner/records.txt")){
      close(REC);
      $self->readOneFileWithStudentAnswers($studentsByExamId,"skaner/records.txt");
    }else{
      $self->{raport}->wymalujError("\nNie znaleziono pliku skaner/records.txt\n")
    }
  }else{
    opendir (DIRHANDLE, "skaner");
    my @filelist = readdir (DIRHANDLE);
    closedir(DIRHANDLE);
    # Przegldam wszystkie pliki o rozszerzeniu *.txt
    my $found=0;
#    my $answerFile="";
    foreach my $file(@filelist){
      if($file =~ /\.txt$/){
        open(FILE,"<skaner/$file") || $self->{raport}->zakoncz("readStudentAnswersNewForm: Failed to open file $file\n");
        my $line=<FILE>;
        next if(!($line =~ /Field/ || $line =~ /kod-studenta-0/));
        $self->{raport}->zakoncz("Znaleziono plik ze skanera, ale bez znakw tabulatora\n") if(!($line =~ /\t/));
        $found++;
        $self->{raport}->wymaluj("Czytam plik $file z odpowiedziami ze skanera\n");
        $self->readOneFileWithStudentAnswers($studentsByExamId,"skaner/$file");
      }
    }
    $self->{raport}->wymalujError("Jest wicej ni jeden plik z odpowiedziami ze skanera!\n") if($found>1);
    $self->{raport}->wymalujError("\nNie znaleziono pliku z odpowiedziami w katalogu skaner\n") if (!$found);
  }
}

################################
# Gwny podprogram czytajcy pliki ze skanera
# W zalenoci od istnienia podkatalogu skaner czyta
# po nowemu lub po staremu
#
sub readStudentAnswers{
  my ($self,$studentsByExamId)=@_;
  $self->{nrStudDlaNrTestu}=[];
  $self->{licznikPowtorzenTestow} = 0;
  if(-d "skaner"){
    $self->readStudentAnswersNewForm($studentsByExamId);
  }else{
    $self->{raport}->wymaluj("Brak katalogu skaner\n"."Szukam pliku $self->{student_answers}\n");
    $self->readStudentAnswersOldForm($studentsByExamId);
  }
  $self->{raport}->wymaluj("Nie stwierdzono powtarzajacych sie numerow testow\n") if  $self->{licznikPowtorzenTestow} == 0;
}

################################
#
# Wyznaczamy wyniki jednego pytania
#
sub evaluateOneQuestion{
  my ($self,$studentQuestionAnswers,$correctQuestionAnswers,$debug)=@_;
  my ($iloscBlednychZaznaczen,
      $iloscBrakujacychZaznaczen,
      $iloscPoprawnychZaznaczen,
      $iloscPoprawnychZaznaczenWeWzorcu,
      $iloscPunktowZaJednoPytanie)=(0,0,0,0,0,0);
  for(my $j=0;$j<$self->{maxIloscOpcji};$j++){
#print "=$studentQuestionAnswers->[$j]= " if($debug);
    $iloscBlednychZaznaczen+=($studentQuestionAnswers->[$j]>$correctQuestionAnswers->[$j]);
    $iloscBrakujacychZaznaczen+=($studentQuestionAnswers->[$j]<$correctQuestionAnswers->[$j]);
    $iloscPoprawnychZaznaczen+=($studentQuestionAnswers->[$j] && $correctQuestionAnswers->[$j]);
    $iloscPoprawnychZaznaczenWeWzorcu+=$correctQuestionAnswers->[$j];
  }
#if($debug){
#  print "\n:::$iloscBlednychZaznaczen,$iloscBrakujacychZaznaczen,$iloscPoprawnychZaznaczen,$iloscPoprawnychZaznaczenWeWzorcu\n";
#}
  return $self->obliczPunkty($iloscBlednychZaznaczen,
                             $iloscBrakujacychZaznaczen,
                             $iloscPoprawnychZaznaczen,
                             $iloscPoprawnychZaznaczenWeWzorcu);
}

################################
#
# Wyznaczamy wyniki jednego formularza
#
sub evaluateOneStudent{
  my ($self,$studentAnswers,$studentAnswersWithAnnulation,$correctAnswers,$debug)=@_;

  my ($i,$j,$iloscPunktow,$iloscPunktowDodatnich,$iloscPunktowUjemnych)=(0,0,0,0,0);
  my $punktyWgPytan="";
  for($i=0;$i<$self->{iloscProblemow};$i++){
    my $iloscPunktowZaJednoPytanie=
           $self->evaluateOneQuestion($studentAnswers->[$i],$correctAnswers->[$i],$i>=48 && $debug);
    my $iloscPunktowZaJednoPytaniePoUwzgldnieniuAnulacji=
           $self->evaluateOneQuestion($studentAnswersWithAnnulation->[$i],$correctAnswers->[$i]);
#print "   Dla i=$i jest iloscPunktow=$iloscPunktowZaJednoPytanie iloscPunktow2=$iloscPunktowZaJednoPytaniePoUwzgldnieniuAnulacji\n" if($i>=48 && $debug);
    if($iloscPunktowZaJednoPytanie<$iloscPunktowZaJednoPytaniePoUwzgldnieniuAnulacji){
# print "Skorygowano pyt $i z $iloscPunktowZaJednoPytanie na $iloscPunktowZaJednoPytaniePoUwzgldnieniuAnulacji\n";
      $iloscPunktowZaJednoPytanie=$iloscPunktowZaJednoPytaniePoUwzgldnieniuAnulacji;
    }
    $studentAnswers->[$i]->[$self->{maxIloscOpcji}]->{wynik} = $iloscPunktowZaJednoPytanie;

    if($iloscPunktowZaJednoPytanie>0){
      $iloscPunktowDodatnich+=$iloscPunktowZaJednoPytanie;
    }else{
      $iloscPunktowUjemnych+=$iloscPunktowZaJednoPytanie;
    }
    $punktyWgPytan.=fill_to_left($iloscPunktowZaJednoPytanie,3);
    $iloscPunktow+=$iloscPunktowZaJednoPytanie;
# print "    iloscPunktow=$iloscPunktow\n";
  }
  $iloscPunktow=($iloscPunktow>0 ? $iloscPunktow : 0);
# print " === Razem   iloscPunktow=$iloscPunktow\n";
  return ($iloscPunktowDodatnich,$iloscPunktowUjemnych,$punktyWgPytan,$iloscPunktow);
}

################################
#
# Wyznaczamy przypadkowy wynik oczekiwany
#
sub evaluateExpectedRandomResult{
  my ($self,$correctAnswers)=@_;

  my ($i,$j,$iloscPunktow,$loscPunktowDlaStrategiiPojedynczychOdpowiedzi)=(0,0,0,0);
  for($i=0;$i<$self->{iloscProblemow};$i++){
    my $k=1;
    for($j=0;$j<32;$j++){
      my @randomAnswers=toBin($j,5);
      my $iloscPunktowZaJednoPytanie=
             $self->evaluateOneQuestion(\@randomAnswers,$correctAnswers->[$i]);

      $iloscPunktow+=$iloscPunktowZaJednoPytanie/32.0;
      if($j==$k){
         $k*=2;
         $loscPunktowDlaStrategiiPojedynczychOdpowiedzi+=$iloscPunktowZaJednoPytanie/5.0;
      }
    }
  }
  return ($iloscPunktow,$loscPunktowDlaStrategiiPojedynczychOdpowiedzi);
}

################################
#
# Wyznaczamy wyniki
#
sub evaluateStudentAnswers{
  my ($self,$studentsByExamId,$answers)=@_;
  my @studkeys=keys(%$studentsByExamId);
  my $studkey;
  my $sprawdzonoTestowy = 0;

  # Wyznaczamy maksymaln moliw ilo punktw oceniajc test wzorcowy wedug klucza
  my ($iloscPunktowDodatnich,$iloscPunktowUjemnych,$punktyWgPytan,$maxPoints)=
                                      $self->evaluateOneStudent($answers->[0],$answers->[0],$answers->[0]);
  my ($OczekiwanyWynikPrzypadkowy,$OczekiwanyWynikPrzypadkowyDlaStrategiiPojedynczychOdpowiedzi)=
                                      $self->evaluateExpectedRandomResult($answers->[0]);
  my $maksymalnaIloscPunktowStudenta=0;
  STUDENTLOOP:
  foreach $studkey (@studkeys){
    # Gdzie jest bd, ktry powoduje generowanie rekordu studenta z pustym kluczem
    # Pniej taki rekord jest traktowany jako Test Kontrolny ze zym kluczem
    # Poniej odrzucenie takich rekordw
    if($studkey !~ /\d/){
      $self->{raport}->wypisz("Znaleziono bdny klucz studkey=$studkey=\n".
      "To nie jest referencja klucza studenta! Rekord pominito.\n");
      next STUDENTLOOP;
    };

    my $student=$studentsByExamId->{$studkey};
    my $studentAnswers=$student->{odpowiedzi};
    my $studentAnswersWithAnnulation=$student->{odpowiedziPoKorekcieAnulacji};
    my $correctAnswers;
    if($studkey == 0){
      $correctAnswers=$answers->[$student->{nrTestu}]; # w starej wersji sigalimy bezporednio do klucza, teraz robimy to tylko dla testu kontrolnego
    }else{
      $correctAnswers=$student->{kluczKorygowany};    # w nowej wersji  sigamy do klucza po naniesieniu korekty z pliku skorygowane.txt z wyjtkiem testu kontrolnego
    }
#print " ===> $student->{nazwisko} $studkey:\n" if($student->{nazwisko} =~ /Ja/);
    my ($iloscPunktowDodatnich,$iloscPunktowUjemnych,$punktyWgPytan,$iloscPunktow)=
                                   $self->evaluateOneStudent($studentAnswers,$studentAnswersWithAnnulation,$correctAnswers,$student->{nazwisko} =~ /Ja/);

    # Liczymy maksymaln ilo punktw na studenta, ale pomijamy test wzorcowy
    $maksymalnaIloscPunktowStudenta=$iloscPunktow if($iloscPunktow>$maksymalnaIloscPunktowStudenta && $studkey != 0);
    # iloscPunktow to suma zebranych punktow
    # wynikProcentowyTestu to suma punktow przeliczona na procenty wedug umownych punktw odniesienia
    # wynikTestu to iloscPunktow lub wynikProcentowyTestu
    $student->{iloscPunktow}=$iloscPunktow;
    $student->{wynikTestu}=$iloscPunktow;
    $student->{iloscPunktowDodatnich}=$iloscPunktowDodatnich;
    $student->{iloscPunktowUjemnych}=$iloscPunktowUjemnych;
    $student->{punktyWgPytan}=$punktyWgPytan;

#  W poprzedniej wersji kady rodzaj testu musia samodzielnie dostarczy
#  ponisz metod podajc maksymaln ilo punktw z testu
#   my $maxPoints=$self->maksymalnaIloscPunktow();
#  Jednak to si da policzy wystawiajc punktacj dla wzorcowych odpowiedzi
#  wzgldem wzorcowych odpowiedzi, ktre s w  $answers->[0]
#  Poprawka ta jest zrobiona  27 linijek wyej.
#  Tak wic metoda maksymalnaIloscPunktow() jest ju zaszoci
    if($studkey == 0){
      if($iloscPunktow != $maxPoints){
        $self->{raport}->wymalujError("\n\nTest kontrolny uzyskal $iloscPunktow punktow.\n".
            "Powinien by uzyska $maxPoints punktow\n".
            "Pozycja w wizce $student->{pozycjaWWiazce}\n".
            "!!!WYNIKI MOG BY NIEPOPRAWNE !!!\n".
            "Sprawdz czy wybrales dobry format przy wczytywaniu danych przez program rozpoznajcy\n".
            "Lub czy test sprawdzajacy nie jest zabrudzony, lub czy wywolujesz program w dobrym katalogu, ITP, ITD \n\n");
        $sprawdzonoTestowy = 1;
      }else{
        $self->{raport}->wymaluj("\nPozycja testu kontrolnego w wizce: $student->{pozycjaWWiazce}\n" .
        "OK: test kontrolny uzyska maksimum punktw\n\n");
        $sprawdzonoTestowy = 1;
      }
    }
  }
  if($sprawdzonoTestowy == 0){
     $self->{raport}->wymalujError("Nie sprawdzano testu kontrolnego!!!!\n\n");
  }

  $self->{raport}->wymaluj("Maksymalny moliwy wynik: $maxPoints\n" .
  "Oczekiwany wynik przypadkowy przy wielokrotnym wyborze: $OczekiwanyWynikPrzypadkowy \n" .
  "Oczekiwany wynik przypadkowy przy jednokrotnym wyborze: $OczekiwanyWynikPrzypadkowyDlaStrategiiPojedynczychOdpowiedzi\n\n");
  $self->{MaxStudentPoints}=
    $self->{par}->{MaxStudentPoints}=
    $maksymalnaIloscPunktowStudenta;
  $self->{MaxPoints}=
    $self->{par}->{MaxPoints}=
    $maxPoints;
  $self->{OczekiwanyWynikPrzypadkowy}=
    $self->{par}->{OczekiwanyWynikPrzypadkowy}=
    $OczekiwanyWynikPrzypadkowy;
  $self->{OczekiwanyWynikPrzypadkowyDlaStrategiiPojedynczychOdpowiedzi}=
    $self->{par}->{OczekiwanyWynikPrzypadkowyDlaStrategiiPojedynczychOdpowiedzi}=
    $OczekiwanyWynikPrzypadkowyDlaStrategiiPojedynczychOdpowiedzi;
}

##########################################
# Dolacz punkty za zadania
#
sub dolaczPunktyZadaniowe{
  my ($self,$studentsByExamId)=@_;
  my @studkeys=keys(%$studentsByExamId);
  my $studkey;


  # Dodajemy punkty za zadania z biecego katalogu
  opendir(DIR,".");
  my @filelist=readdir(DIR);
  closedir(DIR);
  # doczamy dane wycznie z plikw, ktre maj nazwisko asystenta po slowie cwiczenia
  my $studentRB=new StudentRecordBase($self->{raport});
  $RecordBase::warnOnFindingNewRecords=0;
  foreach my $file (@filelist){
    if($file =~ /-wyniki-zad\d+\.csv$/){
      $self->{raport}->wymaluj( "====> Dodaj punkty zadaniowe z pliku $file\n");
      $studentRB->merge("$file",$parbis,'student',$masterRecord);
    }
  }
  $RecordBase::warnOnFindingNewRecords=1;

  my $ileZadan=$self->{'par'}->{'ocenZadania'};
  foreach $studkey (@studkeys){
    my $student=$studentsByExamId->{$studkey};
    my $RBkey=$student->key;
    my $suma=0;
    my @punkty;
    for(my $i=1;$i<=$ileZadan;++$i){
      my $pkt=$studentRB->{$RBkey}->{"zad$i"};
      $student->{"zad$i"}=$pkt;
      push(@punkty,$pkt);
    }
    @punkty=sort {$b <=> $a} @punkty;
    my $ileNajlepszychZadanUwzglednic=(
       $self->{'par'}->{'ileNajlepszychZadanUwzglednic'}>0 ?
       $self->{'par'}->{'ileNajlepszychZadanUwzglednic'} :
       $ileZadan
     );
    for(my $i=0;$i<$ileNajlepszychZadanUwzglednic;++$i){
      $suma+=$punkty[$i];
    }
    $student->{zadania}=int(100*$suma/$ileNajlepszychZadanUwzglednic+0.5)/100;
#print "Student $RBkey z zadan: $student->{zadania}\n";
  }
}

################################
#
# Wyznaczamy wyniki procentowe
#
sub wyznaczWynikiProcentowe{
  my ($self,$studentsByExamId,$answers)=@_;
  my @studkeys=keys(%$studentsByExamId);
  my $studkey;
  # Wagi przy wyliczeniu redniej z testu i zada (tylko jeli s zadania oprcz testu)
  my ($wt,$wmtz,$wz)=(1,0,1);
    if($self->{par}->{'wagiTestZadania'}){
      ($wt,$wmtz,$wz)=split(',',$self->{par}->{'wagiTestZadania'});
    }


  my $iloscPunktowNa100Procent=
    $self->{OstatecznaIloscPunktowNa100Procent}=
    $self->{par}->{OstatecznaIloscPunktowNa100Procent}=
    $self->{par}->{iloscPunktowNa100Procent} ?
    $self->{par}->{iloscPunktowNa100Procent} :
    $self->{MaxPoints};
  my $iloscPunktowNa0Procent=
    $self->{OstatecznaIloscPunktowNa0Procent}=
    $self->{par}->{OstatecznaIloscPunktowNa0Procent}=
    $self->{par}->{iloscPunktowNa0Procent} ?
    $self->{par}->{iloscPunktowNa0Procent} :
    $self->{OczekiwanyWynikPrzypadkowyDlaStrategiiPojedynczychOdpowiedzi};
  STUDENTLOOP:
  foreach $studkey (@studkeys){
    # Gdzie jest bd, ktry powoduje generowanie rekordu studenta z pustym kluczem
    # Pniej taki rekord jest traktowany jako Test Kontrolny ze zym kluczem
    # Poniej odrzucenie takich rekordw
    if($studkey !~ /\d/){
      $self->{raport}->wypisz("Znaleziono bdny klucz studkey=$studkey=\n".
      "To nie jest referencja klucza studenta! Rekord pominito.\n");
      next STUDENTLOOP;
    };

    my $student=$studentsByExamId->{$studkey};
    $student->{wynikProcentowyTestu}=
        int(0.5+10000.0*($student->{iloscPunktow}-$iloscPunktowNa0Procent)/
              ($iloscPunktowNa100Procent-$iloscPunktowNa0Procent))/100.00;
    $student->{wynikProcentowyTestu}=0 if($student->{wynikProcentowyTestu} < 0);
#    $student->{wynikProcentowyTestu}=100.00 if($student->{wynikProcentowyTestu} > 100);
    # wynikProcentowy w przypadku obecnosci zadan uwzglednia tez wyniki zadan
    if($self->{par}->{'ocenZadania'}){
      my $wpt=$student->{wynikProcentowyTestu};
      my $wpz=$student->{zadania};
      my $maxwptwpz=($wpt>$wpz ? $wpt : $wpz);
#      $student->{wynikProcentowy}=($student->{wynikProcentowyTestu}+$student->{zadania})/2;
      $student->{wynikProcentowy}=($wt*$wpt+$wmtz*$maxwptwpz+$wz*$wpz)/($wt+$wmtz+$wz);
      $student->{wynikProcentowy}=int(0.5+100*$student->{wynikProcentowy})/100;
    }else{
      $student->{wynikProcentowy}=$student->{wynikProcentowyTestu};
    }
    $student->{wynikTestu}=$student->{wynikProcentowy};
  }
}

################################
#
#
sub coreFileNameForStudent{
  my ($self,$student)=@_;
#  return text2filename($student->key());
  return text2filename('__'.$student->nazwisko.'+'.$student->imie.'+'.$student->indeks);
}

################################
#
# Przygotowujemy plik z rozszyfrowaniem odpowiedzi studenta
#
sub writeHTMLstudentAnswers{
  my ($self,$student,$plikFormularzaTestu)=@_;
  my $nazwisko=$student->nazwisko();
  my $imie=$student->imie();
  my $indeks=$student->indeks();
  my $numerTestu="$student->{numerEdycjiTerminu}-$student->{numerGrupySal}-$student->{nrTestu}";
  $numerTestu=($student->{brakNrTestu}?"Brak Numeru Testu":$numerTestu);
  $numerTestu=($student->{nieobecny}?"Nieobecny":$numerTestu);
  my $examId="$student->{numerEdycjiTerminu}-$student->{numerGrupySal}-$student->{examId}";
  my $pozycjaWWiazce=$student->{pozycjaWWiazce};
  $pozycjaWWiazce=fill_to_left($pozycjaWWiazce,4,'0');

#  my $corename=text2filename($student->key());
  my $corename=$self->coreFileNameForStudent($student);
#  my $plikFormularzaOdpowiedziFineReadera="$self->{scanBaseName}$pozycjaWWiazce.TIF";
  my $plikFormularzaOdpowiedziFineReadera="$self->{scanBaseName}$pozycjaWWiazce.$self->{testGraphicFormExtension}";
#  my $plikFormularzaOdpowiedzi="$corename.tif";
  my $plikFormularzaOdpowiedzi="$corename.$self->{testGraphicFormExtension}";

my $k=$student->key();
print "Student $k Numer testu $student->{nrTestu} Pozycja:  $pozycjaWWiazce\n";
print "Kopiuj  $plikFormularzaOdpowiedziFineReadera,$plikFormularzaOdpowiedzi\n";
  copy($plikFormularzaOdpowiedziFineReadera,$plikFormularzaOdpowiedzi);

  my @numerTestuBin=toBin($student->{nrTestu},9);
  my @numerTestuIcons=();
  my @numerTestuBinX=();
  for(my $i=0;$i<=$#numerTestuBin;$i++){
    $numerTestuIcons[$i]=( $numerTestuBin[$i] ? "_markOK.bmp" : "_unmarkOK.bmp" );
    $numerTestuBinX[$i]=( $numerTestuBin[$i] ? 'X' : '&nbsp;&nbsp;' );
  }

#    <tr> <td> <img src="$numerTestuIcons[0]"><td> <img src="$numerTestuIcons[1]"><td> <img src="$numerTestuIcons[2]">
#    <tr> <td> <img src="$numerTestuIcons[3]"><td> <img src="$numerTestuIcons[4]"><td> <img src="$numerTestuIcons[5]">
#    <tr> <td> <img src="$numerTestuIcons[6]"><td> <img src="$numerTestuIcons[7]"><td> <img src="$numerTestuIcons[8]">
  my $text=<<END
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=windows-1250">
  </head>
  <body>
  <h2> Wyniki testu: $nazwisko $imie </h2>
  <table border=1>
    <tr> <td> $numerTestuBinX[0] <td> $numerTestuBinX[1] <td> $numerTestuBinX[2]
    <tr> <td> $numerTestuBinX[3] <td> $numerTestuBinX[4] <td> $numerTestuBinX[5]
    <tr> <td> $numerTestuBinX[6] <td> $numerTestuBinX[7] <td> $numerTestuBinX[8]
  </table>
  <h3> Numer indeksu: $indeks</h3>
  <h3> Numer testu: $numerTestu</h3>
  <h3> Egzaminacyjny numer identyfikacyjny: $examId</h3>
  <h3> Pozycja w pliku ze skanera: $pozycjaWWiazce</h3>
  <div style="font-family:monospace">
  <a href="$plikFormularzaTestu"> Formularz testu </a><br>
  <a href="$plikFormularzaOdpowiedzi"> Formularz odpowiedzi </a><br>
  <br>
  <h3> Wykaz odpowiedzi </h3>
  Klucz:<br>
  <font style="background:#ff8080">&nbsp;</font> - niepoprawna niezaznaczona <br>
  <font style="background:#80ff80">&nbsp;</font> - poprawna niezaznaczona <br>
  <font style="background:#ff8080">X</font> - niepoprawna zaznaczona <br>
  <font style="background:#80ff80">X</font> - poprawna zaznaczona <br>
   a - odpowied anulowana <br>
  <br>
END
  ;
  # my $correctAnswers=$self->{answers}->[$student->{nrTestu}];
  my $correctAnswers=$student->{kluczKorygowany}; # Powinien wywietla si klucz skorygowany
  my $studentAnswers=$student->{odpowiedzi};
  my $studentCzyAnulowana=$student->{czyAnulowana};

  my $reverseNumbering=$self->{reverseNumbering}->[$student->{nrTestu}];
  for (my $i = 0; $i < $self->{iloscProblemow}; $i++){
    my $pyt=fill_to_left($i + 1,6).") ";
    $pyt =~ s/ /&nbsp;/g;
    $text.=$pyt;
    for($j=0;$j<$self->{maxIloscOpcji};$j++){
      $text.=chr(ord("A") + $j).'&nbsp;';
      my $scA=$studentAnswers->[$i]->[$j].$correctAnswers->[$i]->[$j];
      my $an=($studentCzyAnulowana->[$i]->[$j] ? "a" : "&nbsp;");
      # A teraz wyznaczamy stosowne to, a przy okazji robimy statystyk
      my $pict;
      if($scA =~ /0\s*0/){
         $pict='<font style="background:#ff8080">&nbsp;'.$an.'</font>';
      }elsif($scA =~ /0\s*1/){
         $pict='<font style="background:#80ff80">&nbsp;'.$an.'</font>';
      }elsif($scA =~ /1\s*0/){
         $pict='<font style="background:#ff8080">X'.$an.'</font>';
      }else{
         $pict='<font style="background:#80ff80">X'.$an.'</font>';
      }
      $text.="$pict &nbsp;&nbsp;";
    }
    $text.=fill_to_left($studentAnswers->[$i]->[$self->{maxIloscOpcji}]->{wynik},4)."<br><br>\n";
  }
  $text.="\nRazem";
  $text.="&nbsp;" x (5 + 6*$self->{maxIloscOpcji} );
  $text.="$student->{iloscPunktow}<br>\n";
  if($self->{par}->{wynikProcentowyTestu}){
    $text.=" Przypadkowy wynik punktowy: $self->{OstatecznaIloscPunktowNa0Procent}<br>\n";
    $text.=" Wzorcowy wynik punktowy:  $self->{OstatecznaIloscPunktowNa100Procent}<br>\n";
    $text.=" Wynik procentowy: ($student->{iloscPunktow}-$self->{OstatecznaIloscPunktowNa0Procent})/($self->{OstatecznaIloscPunktowNa100Procent}-$self->{OstatecznaIloscPunktowNa0Procent})*100%=<b> $student->{wynikProcentowyTestu}%</b><br>\n";
  }
  $text.="</div></body></html>\n";
  return $text;
}

################################
#
# Funkcja drukuje test i wypeniony
# formularz odpowiedzi dla konkretnego studenta
#
sub writePdfTestAndFormForVerification{
  my ($self,$student)=@_;
  my $numerTestu=$student->{nrTestu};
  my $examId=$student->{examId};
  my $indeks=$student->{indeks};

  my $correctAnswers=$self->{answers}->[$numerTestu];
  my $studentAnswers=$student->{odpowiedzi};

  my $corename=$self->coreFileNameForStudent($student);
  my $key=$student->key;

  $self->{raport}->wymaluj("$key $indeks\n");

  my $filename="$corename.tex";
  my $kod=toBinForm($numerTestu,$self->{ilosc_okienek_kodu});
  my $pozycjaWWiazce=$student->{pozycjaWWiazce};
  $pozycjaWWiazce=fill_to_left($pozycjaWWiazce,4,'0');

  my $testTexFormFileName="../tex/test-$numerTestu.tex";
  my $text;
  if(open(ONE_TEST,"<$testTexFormFileName")){
    my $size = -s $testTexFormFileName;
    read(ONE_TEST,$text,$size);
  }else{
    $self->{raport}->wymalujError("Zagubiony lub nieistniejcy plik $testTexFormFileName\n");
  }

  open(TEST,">$filename") || $self->{raport}->zakoncz("Failed to open $filename\n");
  print TEST $self->{verificationTestCopiesHead};
#  Dawniej powtrnie generowaem testy by teraz mc zapisa formularz testu
#  dla studenta. Teraz korzystam z pliku utworzonego w trakcie wyjciowego
# generowania testw
#  print TEST $self->{tests}->[$numerTestu];
  print TEST $text;

  print TEST $self->{testCopiesTail};
  close(TEST);

  my $drukarz=new printerPDF($self);
  $drukarz->printFile($filename);

  unlink $filename;
  if(-r "$corename.aux"){
    unlink "$corename.aux";
#    print "Removed $corename.aux\n";
  }else{
    print "Failed to find $corename.aux\n";
  }
  if(-r "$corename.log"){
    unlink "$corename.log";
#    print "Removed $corename.log\n";
  }else{
    print "Failed to find $corename.log\n";
  }

  $filename="$corename.html";
  open(ANS,">$filename") || $self->{raport}->zakoncz("Failed to open $filename\n");
  print ANS $self->writeHTMLstudentAnswers($student,"$corename.pdf");
  close(ANS);
}


##########################################
# Dodaj link do nazwiska, jeli jest odpowiedni plik
#
sub nameAndLink{
  my ($self,$name,$student) = @_;
  my $corename=$self->coreFileNameForStudent($student);
  my $filename="$corename.html";
  my $text=(-e $filename ? "<a href=\"skaner/$filename\">$name</a>" : $name);
  return ($text,$filename);
}

##########################################
# Kopiuj pliki z ikonami
# Teraz ju niepotrzebne
#
sub copyIcons{
  my ($self,$iconsDir) = @_;
  $iconsDir=dirSlash($iconsDir);
  opendir (DIRHANDLE, "$Bin/egzaminator/icons");

  foreach my $file (readdir (DIRHANDLE)){
    copy("$Bin/egzaminator/icons/$file","$iconsDir"."$file") if($file =~ /\.bmp/);
  }
  closedir(DIRHANDLE);
}

################################
#
# Drukujemy wyniki dla studentw
#
sub printTestEvaluationForStudents{
  my ($self,$studentsByExamId,$answers,$par,$typWydruku)=@_;

  my $alfabetyczna=($typWydruku==0);
  my $dlaStudentow=($typWydruku==1);
  my $posortowanaWedlugWynikow=($typWydruku==2);
  my @examIds;
  my $studentResulsFileNames="|";
#  if(!$posortowanaWedlugWynikow){
#    @examIds=sort {$a <=> $b} keys(%$studentsByExamId);
#  }else{
#    @examIds=sort {$studentsByExamId->{$b}->{wynikProcentowy} <=> $studentsByExamId->{$a}->{wynikProcentowy}} keys(%$studentsByExamId);
#  }
  if($posortowanaWedlugWynikow){
    @examIds=sort {$studentsByExamId->{$b}->{wynikProcentowy} <=> $studentsByExamId->{$a}->{wynikProcentowy}} keys(%$studentsByExamId);
  }elsif($alfabetyczna){
    @examIds=sort {$a <=> $b} keys(%$studentsByExamId);
  }else{
    if($par->{ocenZadania}){
      foreach my $examId (keys(%$studentsByExamId)){
        $studentsByExamId->{$examId}->{partHiddenId}='xxxx'.substr('x'.$studentsByExamId->{$examId}->{pesel},5);
      }
      @examIds=sort {$studentsByExamId->{$a}->{partHiddenId} cmp $studentsByExamId->{$b}->{partHiddenId}} keys(%$studentsByExamId);
    }else{
      @examIds=sort {$studentsByExamId->{$a}->{indeks} <=> $studentsByExamId->{$b}->{indeks}} keys(%$studentsByExamId);
    }

  }
  my $examId;
  if($dlaStudentow){
    open(HTML,">$self->{resultsHTMLforStudents}") || $self->{raport}->zakoncz("Failed to open wyniki-dla-studentow.html\n");
  }else{
    if($posortowanaWedlugWynikow){
      open(HTML,">$self->{resultsHTMLsortedByResult}") || $self->{raport}->zakoncz("Failed to open $self->{resultsHTMLsortedByResult}\n");
    }else{
      open(HTML,">$self->{resultsHTML}") || $self->{raport}->zakoncz("Failed to open $self->{resultsHTML}\n");
    }
  };
  chdir('skaner');


  if($main::opt_d && $alfabetyczna){
    $self->{raport}->wymaluj("\nGeneruje indywidualne pliki z odpowiedziami:\n"."To jest czasochonne\n");
  }else{
    $self->{raport}->wymaluj("\nGeneruje plik z wynikami. Wersja $typWydruku.\n");
  }
  my $kurs=$par->{'Kurs'};

  print HTML <<END;
  <html
  <head>
    <meta http-equiv="content-type" content="text/html; charset=windows-1250">
     <title> $kurs </title>
  </head>
  <body>
  <h2> $kurs </h2>
  <table border=1>
END
  ;
  my $tabhead1="<tr><th>Lp.";
  my $tabhead2="<tr><th>   ";
  my $stid=$par->{ocenZadania} ? 'Pesel' : 'Indeks';
  if(!$dlaStudentow){
    $tabhead1.="<th>examId<th>Pozycja <th>Numer<th>Nazwisko";
    $tabhead2.="<th>      <th>w wizce<th>testu<th>        ";
  }
  $tabhead1.="<th>$stid<th>Punkty <th>Wynik";
  $tabhead2.="<th>      <th>z testu<th>Procentowy";
  if($par->{ocenZadania}){
    for(my $i=1;$i<=$par->{ocenZadania};++$i){
      $tabhead1.="<th> Zad. $i";
      $tabhead2.="<th>        ";
    }
    $tabhead1.="<th> rednia<th>Wynik kocowy";
    $tabhead2.="<th> z zada<th>             ";
  }
  print HTML   "$tabhead1\n";
  print HTML   "$tabhead2\n";
#  if($dlaStudentow){
#    print HTML "<tr><th>Lp.<th>Indeks<th>Punkty <th>Wynik\n";
#    print HTML "<tr><th>   <th>      <th>z testu<th>Procentowy\n";
#  }else{
#    print HTML "<tr><th>Lp.<th>examId<th>Pozycja <th>Numer<th>Indeks<th>Nazwisko<th>Punkty <th>Wynik\n";
#    print HTML "<tr><th>   <th>      <th>w wizce<th>testu<th>      <th>        <th>z testu<th>Procentowy\n";
#  }

  # Anonimowa tablica bdzie potrzebna do zbierania statystyki
  $self->{answerStat}=[];

  # A teraz analizujemy po kolei wszystkich studentw
  my $lp=0;
  STUDENTLOOP:
  foreach $examId (@examIds){

    # Zerowy $examId to test kontrolny, inne s bdne
    next if($examId == 0);
    $self->{raport}->zakoncz("printTestEvaluation - Fatal error:  examId=$examId\n") if($examId<0);

    my $student=$studentsByExamId->{$examId};
    my $studentAnswers=$student->{odpowiedzi};
    my $RBkey=$student->key;
    if(!defined($par->{studentRecordBase}->{$RBkey}) && $RBkey !~ /^Dodatkowy\+\d+\+Dodatkowy-\d+$/){
       print "printTestEvaluationForStudent: Studenta o kluczu $RBkey brak w bazie danych\n";
       next STUDENTLOOP;
    };
    if( defined($studentAnswers) &&  $main::opt_d && $alfabetyczna){
       $self->writePdfTestAndFormForVerification($student);
    }

    my $nazwisko="$student->{'nazwisko'} $student->{'imie'}";
    my $indeks=$student->{'indeks'};
    my $filename;
    ($nazwisko,$filename)=$self->nameAndLink($nazwisko,$student);
    $studentResulsFileNames.="$filename|" if($alfabetyczna);
    my $nrTestu="$student->{numerEdycjiTerminu}-$student->{numerGrupySal}-$student->{nrTestu}";
    $nrTestu=($student->{brakNrTestu}?"Brak Numeru Testu":$nrTestu);
    $nrTestu=($student->{nieobecny}?"Nieobecny":$nrTestu);
    my $pozycjaWWiazce=$student->{pozycjaWWiazce};
    my $examId="$student->{numerEdycjiTerminu}-$student->{numerGrupySal}-$student->{examId}";
    my $punkty=$student->{iloscPunktow};
    my $wynikProcentowyTestu=$student->{wynikProcentowyTestu};
    ++$lp;
    my $line="<tr><td>$lp";
    if(!$dlaStudentow){
      $line.="<td>$examId<td>$pozycjaWWiazce<td>$nrTestu<td>$nazwisko";
    }
    $stid=$par->{ocenZadania} && $dlaStudentow ? $student->{'partHiddenId'} : $indeks;
    $line.="<td>$stid<td>$punkty<td>$wynikProcentowyTestu";
    if($par->{ocenZadania}){
      for(my $i=1;$i<=$par->{ocenZadania};++$i){
        my $zad="zad$i";
        $line.="<td> $student->{$zad}";
      }
    }
    $line.="<td> $student->{zadania}<td>$student->{wynikProcentowy}";
    print HTML   "$line\n";
  }
#    if($dlaStudentow){
#      print HTML "<tr><td>$lp<td>$indeks<td>$punkty<td>$wynikProcentowyTestu\n";
#    }else{
#      print HTML "<tr><td>$lp<td>$indeks<td>$nazwisko<td>$punkty<td>$wynikProcentowyTestu<td>$examId<td>$pozycjaWWiazce<td>$nrTestu\n";
#      print HTML "<tr><td>$lp<td>$examId<td>$pozycjaWWiazce<td>$nrTestu<td>$indeks<td>$nazwisko<td>$punkty<td>$wynikProcentowyTestu\n";
#    }
#  }
  print HTML <<END;
  </table>
END
  ;
  if(!$dlaStudentow){
    print HTML <<END;
  <p>
  <table border=1>
  <tr><th> Oczekiwany wynik przypadkowy <td> $self->{OczekiwanyWynikPrzypadkowy}
  <tr><th> Oczekiwany wynik przypadkowy <br>przy strategii pojedynczych odpowiedzi<td> $self->{OczekiwanyWynikPrzypadkowyDlaStrategiiPojedynczychOdpowiedzi}
  <tr><th> Maksymalny uzyskany wynik <td> $self->{MaxStudentPoints}
  <tr><th> Maksymalny moliwy wynik <td> $self->{MaxPoints}
  <tr><th> Punktw na 0 procent: <td> $self->{OstatecznaIloscPunktowNa0Procent}
  <tr><th> Punktw na 100 procent: <td> $self->{OstatecznaIloscPunktowNa100Procent}
  </table>
END
  ;
  }
  print HTML <<END;
  </body>
  </html>
END
  ;
  chdir('..');
  close(HTML);

  return $studentResulsFileNames;
}

################################
#
#
# Dua liczba pierwsza uywana do generowania hasza

my $bigPrime=31991;

################################
#
#
# Generowanie hasza z teksu

sub haszujTekst{
  my ($tekst)=@_;
  my $kod=1;
  my $i;
  for($i=0;$i<length($tekst);++$i){
    $kod*=ord(substr($tekst,$i));
#    $kod%=31991;
    $kod%=$bigPrime;
  }
  return $kod;
}

################################
#
#
# Normalizacja teksu

sub normalizuj{
  my ($text)=@_;
  $text =~ s/ /+/g;
  $text =~ s//a/g;
  $text =~ s//c/g;
  $text =~ s//e/g;
  $text =~ s//l/g;
  $text =~ s//n/g;
  $text =~ s//o/g;
  $text =~ s//s/g;
  $text =~ s//z/g;
  $text =~ s//z/g;
  $text =~ s//A/g;
  $text =~ s//C/g;
  $text =~ s//E/g;
  $text =~ s//L/g;
  $text =~ s//N/g;
  $text =~ s//O/g;
  $text =~ s//S/g;
  $text =~ s//Z/g;
  $text =~ s//Z/g;
  $text=lc($text);
  return $text;
}

################################
#
#
# Wypisuje plik index.php, ktry zawiera skrypt w php
# udostpniajcy studentom indywidualne pliki z rozwizaniami
# W przeciwietwie do metody nastpnej chroni numery indeksw
# studentw, bo posuguje si kluczami wygenerowanymi przez metod haszujTekst powyej

sub wypiszIndeksPhp{
  my ($self,$studentsByExamId)=@_;
  my $file=$self->{resultsDir}."skaner/index.php";
  $studentResulsFileNames="\"$studentResulsFileNames\"";
#$self->{raport}->wymaluj("Otwieram plik $file\n");
  open(PHP,">$file") || $self->{raport}->zakoncz("Failed to open $file\n");
  print PHP <<END;
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=windows-1250">
  <title>Wyniki Testu</title>
<?php
\$success=false;
\$hashValues=array(
END
  ;
  my @examIds=sort {$a <=> $b} keys(%$studentsByExamId);
  my $examId;
  my $cnt=0;
  foreach $examId (@examIds){
    # Zerowy $examId to test kontrolny, inne s bdne
    # Przy okazji pomijamy bdne rekordy puste
    next if($examId <= 0);
    my $student=$studentsByExamId->{$examId};
    my $imie=$student->{'imie'};
    my $nazwisko=$student->{'nazwisko'};
    my $indeks=$student->{'indeks'};
    my $key=$nazwisko."+".$imie;
    $key=normalizuj($key);
    my $value=$nazwisko."+".$imie."+".$indeks;
    $value=normalizuj($value);
    my $hashValue=haszujTekst($value);
    print PHP "\"$key\" => \"$hashValue\"";
    if($cnt<$#examIds){ print PHP ","; }
    print PHP "\n";
    ++$cnt;
  }

  print PHP <<END;
);

function normalizuj(\$text){
  \$text=str_replace(" ","+",\$text);
  \$text=str_replace("","a",\$text);
  \$text=str_replace("","c",\$text);
  \$text=str_replace("","e",\$text);
  \$text=str_replace("","l",\$text);
  \$text=str_replace("","n",\$text);
  \$text=str_replace("","o",\$text);
  \$text=str_replace("","s",\$text);
  \$text=str_replace("","z",\$text);
  \$text=str_replace("","z",\$text);
  \$text=str_replace("","A",\$text);
  \$text=str_replace("","C",\$text);
  \$text=str_replace("","E",\$text);
  \$text=str_replace("","L",\$text);
  \$text=str_replace("","N",\$text);
  \$text=str_replace("","O",\$text);
  \$text=str_replace("","S",\$text);
  \$text=str_replace("","Z",\$text);
  \$text=str_replace("","Z",\$text);
  \$text=strtolower(\$text);
  return \$text;
}

function haszujTekst(\$tekst){
  \$kod=1;
  \$i;
  for(\$i=0;\$i<strlen(\$tekst);++\$i){
    \$kod*=ord(substr(\$tekst,\$i));
    \$kod%=$bigPrime; #31991;
  }
  return \$kod;
}
?>
</head>

<body>
<?php
\$nazwisko=\$_POST["nazwisko"];
\$imie=\$_POST["imie"];
\$indeks=\$_POST["indeks"];
if(\$nazwisko){
  \$link='__'.\$nazwisko."+".\$imie."+".\$indeks.".html";
  \$link=normalizuj(\$link);
  \$link=str_replace("/",".",\$link);
  \$key=\$nazwisko."+".\$imie;
  \$key=normalizuj(\$key);
  \$value=\$nazwisko."+".\$imie."+".\$indeks;
  \$value=normalizuj(\$value);
  \$hashValue=haszujTekst(\$value);
  if(\$hashValues[\$key]==\$hashValue){
    echo("<input type=\\\"button\\\" value=\\\"Twj test\\\" onClick=\\\"window.open('".\$link."','')\\\">");
    \$success=true;
  }else{
    echo("<b>Niepoprawne dane</b>: wpisujc tekst pomi spacje i ogonki w polskich znakach, uywaj wycznie maych liter!<br>");
  }
}
if(!\$success){
?>
<form name="formularz" action="index.php" method="post" enctype="multipart/form-data">
<input type="hidden" name="link" value="">
<h2> Wyniki Testu </h2>
  Wpisz swoje nazwisko: (pomi \"ogonki\": a zamiast , l zamiast  itd.) <br>
  <input type="text" name="nazwisko"> <br>

  Wpisz swoje imi: (pomi \"ogonki\": a zamiast , l zamiast  itd.)<br>
  <input type="text" name="imie"> <br>

  Wpisz swj numer indeksu:<br>
  <input type="text" name="indeks"> <br>

  <input type="submit" name="submit" value="Wywietl wynik">

</form>

  <table border=1>
  <tr><th> Oczekiwany wynik przypadkowy <td> $self->{OczekiwanyWynikPrzypadkowy}
  <tr><th> Oczekiwany wynik przypadkowy <br>przy strategii pojedynczych odpowiedzi<td> $self->{OczekiwanyWynikPrzypadkowyDlaStrategiiPojedynczychOdpowiedzi}
  <tr><th> Maksymalny uzyskany wynik <td> $self->{MaxStudentPoints}
  <tr><th> Maksymalny moliwy wynik <td> $self->{MaxPoints}
  <tr><th> Punktw na 0 procent: <td> $self->{OstatecznaIloscPunktowNa0Procent}
  <tr><th> Punktw na 100 procent: <td> $self->{OstatecznaIloscPunktowNa100Procent}
  </table>
<?php
}
?>
<hr><small> (c) Marian Mrozek, Krakw 1996-2008 </small>
</body>
</html>

END
  ;
  close(PHP);
}

################################
#
#
# Wypisuje plik index.html, ktry zawiera skrypt w JavaScript
# udostpniajcy studentom indywidualne pliki z rozwizaniami

sub wypiszIndeksHtml{
  my ($self,$studentResulsFileNames)=@_;
  my $file=$self->{resultsDir}."skaner/index.html";
  $studentResulsFileNames="\"$studentResulsFileNames\"";
#$self->{raport}->wymaluj("Otwieram plik $file\n");
  open(HTML,">$file") || $self->{raport}->zakoncz("Failed to open $file\n");
  print HTML <<END;
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=windows-1250">
  <title>Wyniki Testu</title>
  <script language="JavaScript">
var files=$studentResulsFileNames;

function text2filename(text){
  text=text.replace(/ /g,"+");
  text=text.replace(/\\//g,".");
  text=text.replace(//g,"a");
  text=text.replace(//g,"c");
  text=text.replace(//g,"e");
  text=text.replace(//g,"l");
  text=text.replace(//g,"n");
  text=text.replace(//g,"o");
  text=text.replace(//g,"s");
  text=text.replace(//g,"z");
  text=text.replace(//g,"z");
  text=text.replace(//g,"A");
  text=text.replace(//g,"C");
  text=text.replace(//g,"E");
  text=text.replace(//g,"L");
  text=text.replace(//g,"N");
  text=text.replace(//g,"O");
  text=text.replace(//g,"S");
  text=text.replace(//g,"Z");
  text=text.replace(//g,"Z");
  text=text.replace(/A/g,"a");
  text=text.toLowerCase();
  return text;
}

function otworzOkno(){
  var link='__'+document.formularz.nazwisko.value+'+'+
           document.formularz.imie.value+'+'+
           document.formularz.indeks.value+'.html';
  link=text2filename(link);


  var regex=link;
  regex=regex.replace(/\\+/g,"\\\\+");
  regex=regex.replace(/\\./g,"\\\\.");
  if(files.match(regex)!=null){
    open(link,'');
  }else{
    alert('Niepoprawne dane: wpisujc tekst pomi spacje i ogonki w polskich znakach, uywaj wycznie maych liter.');
  }
}
  </script>
</head>

<body>
<form name="formularz">

<h2> Wyniki Testu </h2>
  Wpisz swoje nazwisko:<br>
  <input type="text" name="nazwisko"> <br>

  Wpisz swoje imi:<br>
  <input type="text" name="imie"> <br>

  Wpisz swj numer indeksu:<br>
  <input type="text" name="indeks"> <br>

  <input type="button" value="Wywietl wynik" onClick="otworzOkno()">

</form>

  <table border=1>
  <tr><th> Oczekiwany wynik przypadkowy <td> $self->{OczekiwanyWynikPrzypadkowy}
  <tr><th> Oczekiwany wynik przypadkowy <br>przy strategii pojedynczych odpowiedzi<td> $self->{OczekiwanyWynikPrzypadkowyDlaStrategiiPojedynczychOdpowiedzi}
  <tr><th> Maksymalny uzyskany wynik <td> $self->{MaxStudentPoints}
  <tr><th> Maksymalny moliwy wynik <td> $self->{MaxPoints}
  <tr><th> Punktw na 0 procent: <td> $self->{OstatecznaIloscPunktowNa0Procent}
  <tr><th> Punktw na 100 procent: <td> $self->{OstatecznaIloscPunktowNa100Procent}
  </table>

<hr><small> (c) Marian Mrozek, Krakw 1996-2008 </small>
</body>
</html>

END
  ;
  close(HTML);
}

################################
#
# Funkcja wyznacza wsprzdne
# pytania w zestawie nietasowanym (numer 0)
#

sub wyznaczWspolrzednePytanWeWzorcuDlaStudenta{
  my ($self,$student)=@_;

  $student->{keyCoordinates}=[];

  my $reverseNumbering=$self->{reverseNumbering}->[$student->{nrTestu}];

  for (my $i = 0; $i < $self->{iloscProblemow}; $i++){
    $student->{keyCoordinates}->[$i]=[];

    # przechodzimy do odpowiedzi
    for($j=0;$j<$self->{maxIloscOpcji};$j++){
      $student->{keyCoordinates}->[$i]->[$j]={};

      # Wyznaczamy oryginalne wsprzdne pytania i odpowiedzi
      my ($orgGroup,$orgProblem,$orgAnswer)=split(/:/,$reverseNumbering->[$i]->[$j]);
      next unless($orgGroup =~ /^g0*([1-9]\d*)$/);
      $orgGroup=$1;
      next unless($orgProblem =~ /^p0*([1-9]\d*)$/);
      $orgProblem=$1;
      next unless($orgAnswer =~ /^o0*([1-9]\d*)$/);
      $orgAnswer=$1;
      # Zapisujemy wyznaczone dane
      $student->{keyCoordinates}->[$i]->[$j]->{group}=$orgGroup;
      $student->{keyCoordinates}->[$i]->[$j]->{problemInGroup}=$orgProblem;
      $student->{keyCoordinates}->[$i]->[$j]->{answer}=$orgAnswer;
    }
  }
}

################################
#
# wyznaczamy wspolrzedne pytan w wzorcowym
# zestawie pyta (zestaw nr 0) dla wszystkich studentw
#
sub wyznaczWspolrzednePytanWeWzorcu{
  my ($self,$studentsByExamId,$par)=@_;
  my @examIds=sort {$a <=> $b} keys(%$studentsByExamId);
  my $examId;

  # A teraz analizujemy po kolei wszystkich studentw
  STUDENTLOOP:
  foreach $examId (@examIds){

    # Zerowy $examId to test kontrolny, inne s bdne
    next if($examId == 0);
    $self->{raport}->zakoncz("printTestEvaluation - Fatal error:  examId=$examId\n") if($examId<0);

    my $student=$studentsByExamId->{$examId};

    my $RBkey=$student->key;

    if(!defined($par->{studentRecordBase}->{$RBkey}) && $RBkey !~ /^Dodatkowy\+\d+\+Dodatkowy-\d+$/){
       print "wyznaczWspolrzednePytanWeWzorcu: Studenta o kluczu $RBkey brak w bazie danych\n";
       next STUDENTLOOP;
    };
    $self->wyznaczWspolrzednePytanWeWzorcuDlaStudenta($student);
  }
}

################################
#
# Funkcja wyznacza odpowiedzi studenta
# po uwzgldnieniu pyta anulowanych
#

sub naniesOdpowiedziAnulowaneKorygowaneDlaStudenta{
  my ($self,$student)=@_;

  my $correctAnswers=$self->{answers}->[$student->{nrTestu}];
  my $studentAnswers=$student->{odpowiedzi};

  $student->{odpowiedziPoKorekcieAnulacji}=[];
  $student->{kluczKorygowany}=[]; # Klucz korygowany zawiera to co correctAnswers, ale z uwzgldnieniem poprawek w pliku skorygowane.txt
  for (my $i = 0; $i < $self->{iloscProblemow}; $i++){
    $student->{odpowiedziPoKorekcieAnulacji}->[$i]=[];
    $student->{czyAnulowana}->[$i]=[];
    $student->{kluczKorygowany}->[$i]=[];
    # przechodzimy do odpowiedzi
    for($j=0;$j<$self->{maxIloscOpcji};$j++){
      # Wyznaczamy oryginalne wsprzdne pytania i odpowiedzi
      my $keyCoords=$student->{keyCoordinates}->[$i]->[$j];
      my ($orgGroup,$orgProblemInGroup,$orgAnswer)=
              ($keyCoords->{group},$keyCoords->{problemInGroup},$keyCoords->{answer});

      # Wyznaczamy bezwzgldny ( nie w grupie ) oryginalny (przed przetasowaniem) numer pytania
      my $orgProblem=0;
      for(my $g=0;$g<$orgGroup;$g++){
        $orgProblem+=$self->{'wielkoscGrup'}->[$g];
      }
      $orgProblem+=$orgProblemInGroup;

      # Odpowiedz pierwotnie przewidziana jako poprawna
      my $c=$correctAnswers->[$i]->[$j];
      # Zmieniamy odpowied na przeciwn, jeli jest zaznaczona jako korygowana
      $c=1-$c if($self->{'korygowane'}->[$orgProblem]->[$orgAnswer]);
      $student->{kluczKorygowany}->[$i]->[$j]=$c;
      # Ponadto nanosimy wariant odpowiedzi studenta, w ktorym pozycje
      # anulowane nadpisujemy poprawnymi w miejsce studenckich
      if($self->{'anulowane'}->[$orgProblem]->[$orgAnswer]){
        my $pyt=1+$i;
        my $odp=chr(ord('A')+$j);
        my $orgPyt=$orgProblem;
        my $orgOdp=chr(ord('A')+$orgAnswer-1);
        my $RBkey=$student->key;
# print "Naniesiono odpowiedz anulowana $pyt$odp (orig: $orgPyt$orgOdp) dla $RBkey\n";
        $student->{odpowiedziPoKorekcieAnulacji}->[$i]->[$j]=$c;
        $student->{czyAnulowana}->[$i]->[$j]=1;
      }else{
        $student->{odpowiedziPoKorekcieAnulacji}->[$i]->[$j]=$studentAnswers->[$i]->[$j];
        $student->{czyAnulowana}->[$i]->[$j]=0;
      }

    }
  }
}

################################
#
# nanosimy ewentualne odpowiedzi anulowane dla
# wszystkich studentw
#
sub naniesOdpowiedziAnulowaneKorygowane{
  my ($self,$studentsByExamId,$par)=@_;
  my @examIds=sort {$a <=> $b} keys(%$studentsByExamId);
  my $examId;

  $self->{'anulowane'}=[];
  $self->{'korygowane'}=[];
  for(my $i=1;$i<=$self->{iloscProblemow};$i++){
    $self->{'anulowane'}->[$i]=[];
    $self->{'korygowane'}->[$i]=[];
    for(my $j=1;$j<=$self->{maxIloscOpcji};$j++){
      $self->{'anulowane'}->[$i]->[$j]=0;
      $self->{'korygowane'}->[$i]->[$j]=0;
    }
  }
  my $wd=pwd();
  print "Sprawdzam czy sa korygowane w $wd:";
  if(-r "skorygowane.txt"){
    print " tak\n";
    open(ANS,"<skorygowane.txt") || $self->{raport}->zakoncz("Failed to open skorygowane.txt\n");
    while(<ANS>){
      if(/^\s*(\d+)\s*([a-zA-Z])\s*$/){
        my ($pyt,$odp)=($1,1+ord(uc($2))-ord('A'));
        $self->{'korygowane'}->[$pyt]->[$odp]=1;
        print "Skorygowano $pyt".chr(ord('A')+$odp-1)."\n";;
      }
    }
  }else{
    print " nie\n";
  }
  print "Sprawdzam czy sa anulowane w $wd:";
  if(-r "anulowane.txt"){
    print " tak\n";
    if(-r "anulowano.txt"){
        $self->{raport}->wymalujError("Znaleziono plik anulowano.txt\n Powinno by anulowane.txt\n");
    }
    open(ANS,"<anulowane.txt") || $self->{raport}->zakoncz("Failed to open anulowane.txt\n");
    while(<ANS>){
      if(/^\s*(\d+)\s*([a-zA-Z])\s*$/){
        my ($pyt,$odp)=($1,1+ord(uc($2))-ord('A'));
        $self->{'anulowane'}->[$pyt]->[$odp]=1;
        print "Anulowano $pyt".chr(ord('A')+$odp-1)."\n";;
      }
    }
  }else{
    print " nie\n";
  }
#  else{
#    print " nie\n";
#    # Jeli nie ma anulowanych, to nie ma co ich nanosi
#    return;
#  }

  # Jeli byy odpowiedzi anulowane, nanosimy je po kolei dla wszystkich studentw
  STUDENTLOOP:
  foreach $examId (@examIds){

    my $student=$studentsByExamId->{$examId};
    if(ref($student) ne 'student'){
      $self->{raport}->wypisz("Dla examId=$examId= znaleziono bdny klucz student=$student=\n".
      "To nie jest referencja klucza studenta! Rekord pominito.\n");
      next STUDENTLOOP;
    }
    my $RBkey=$student->key;

    # Zerowy $examId to test kontrolny, inne zerowe s bdne
    next if($examId == 0);
    next if($student->{nrTestu} == 0);
    $self->{raport}->zakoncz("printTestEvaluation - Fatal error:  examId=$examId\n") if($examId<0);
    my $student=$studentsByExamId->{$examId};
    my $RBkey=$student->key;
    if(!defined($par->{studentRecordBase}->{$RBkey}) && $RBkey !~ /^Dodatkowy\+\d+\+Dodatkowy-\d+$/){
       print "Studenta o kluczu $RBkey brak w bazie danych\n";
       next STUDENTLOOP;
    };
#print "Student $student RBkey=$RBkey\n";
    $self->naniesOdpowiedziAnulowaneKorygowaneDlaStudenta($student);
  }
}

################################
#
# Funkcja zbiera dane statystyczne od studenta
#

sub takeStatisticsDataFromStudent{
  my ($self,$student)=@_;

  my $correctAnswers=$self->{answers}->[$student->{nrTestu}];
  my $studentAnswers=$student->{odpowiedzi};
  for (my $i = 0; $i < $self->{iloscProblemow}; $i++){

    # przechodzimy do odpowiedzi
    for($j=0;$j<$self->{maxIloscOpcji};$j++){

      # Wyznaczamy oryginalne wsprzdne pytania i odpowiedzi
      my $keyCoords=$student->{keyCoordinates}->[$i]->[$j];
      my ($orgGroup,$orgProblemInGroup,$orgAnswer)=
              ($keyCoords->{group},$keyCoords->{problemInGroup},$keyCoords->{answer});

      # W miar potrzeby inicjujemy tablice do statystyki odpowiedzi
      if(!defined($self->{answerStat}->[$orgGroup])){
        $self->{answerStat}->[$orgGroup]=[];
        if(!defined($self->{answerStat}->[$orgGroup]->[$orgProblemInGroup])){
          $self->{answerStat}->[$orgGroup]->[$orgProblemInGroup]=[];
          if(!defined($self->{answerStat}->[$orgGroup]->[$orgProblemInGroup]->[$orgAnswer])){
            $self->{answerStat}->[$orgGroup]->[$orgProblemInGroup]->[$orgAnswer]={};
            $self->{answerStat}->[$orgGroup]->[$orgProblemInGroup]->[$orgAnswer]->{'unmarkBAD'}=0;
            $self->{answerStat}->[$orgGroup]->[$orgProblemInGroup]->[$orgAnswer]->{'unmarkOK'}=0;
            $self->{answerStat}->[$orgGroup]->[$orgProblemInGroup]->[$orgAnswer]->{'markBAD'}=0;
            $self->{answerStat}->[$orgGroup]->[$orgProblemInGroup]->[$orgAnswer]->{'markOK'}=0;
          }
        }
      }

      #  robimy  statystyk odpowiedzi
      my $scA=$studentAnswers->[$i]->[$j].$correctAnswers->[$i]->[$j];
      if($scA =~ /0\s*0/){
        $self->{answerStat}->[$orgGroup]->[$orgProblemInGroup]->[$orgAnswer]->{'unmarkBAD'}+=1;
      }elsif($scA =~ /0\s*1/){
        $self->{answerStat}->[$orgGroup]->[$orgProblemInGroup]->[$orgAnswer]->{'unmarkOK'}+=1;
      }elsif($scA =~ /1\s*0/){
        $self->{answerStat}->[$orgGroup]->[$orgProblemInGroup]->[$orgAnswer]->{'markBAD'}+=1;
      }else{
        $self->{answerStat}->[$orgGroup]->[$orgProblemInGroup]->[$orgAnswer]->{'markOK'}+=1;
      }

      # ponadto w pierwszym przejciu robimy te statystyk pyta ....
      next if($j);
      if(!defined($self->{problemStat}->[$orgGroup])){
        $self->{problemStat}->[$orgGroup]=[];
      }elsif(!defined($self->{problemStat}->[$orgGroup]->[$orgProblemInGroup])){
        $self->{problemStat}->[$orgGroup]->[$orgProblemInGroup]={};
      }else{
        my $wynik="$studentAnswers->[$i]->[$self->{maxIloscOpcji}]->{wynik}";
        if(!defined($self->{problemStat}->[$orgGroup]->[$orgProblemInGroup]->{$wynik})){
          $self->{problemStat}->[$orgGroup]->[$orgProblemInGroup]->{$wynik}=1;
        }else{
          $self->{problemStat}->[$orgGroup]->[$orgProblemInGroup]->{$wynik}+=1;
        }
        if(!defined($self->{problemStat}->[$orgGroup]->[$orgProblemInGroup]->{sumaWynikow})){
          $self->{problemStat}->[$orgGroup]->[$orgProblemInGroup]->{sumaWynikow}=$wynik;
        }else{
          $self->{problemStat}->[$orgGroup]->[$orgProblemInGroup]->{sumaWynikow}+=$wynik;
        }
      }
    }
  }
}

################################
#
# Zbieramy statystyk odpowiedzi
#
sub collectAnswerStatistics{
  my ($self,$studentsByExamId,$answers,$par)=@_;
#  $self->read();
#  $self->generateCopies([]);
  my @examIds=sort {$a <=> $b} keys(%$studentsByExamId);
  my $examId;
  open(TXT,">statystyka.txt") || $self->{raport}->zakoncz("Failed to open statystyka.txt\n");

  print "Analizuje odpowiedzi:\n";
  my $kurs=$par->{'Kurs'};

  # Anonimowa tablica bdzie potrzebna do zbierania statystyki
  $self->{answerStat}=[];

  # A teraz analizujemy po kolei wszystkich studentw
  STUDENTLOOP:
  foreach $examId (@examIds){

    # Zerowy $examId to test kontrolny, inne s bdne
    next if($examId == 0);
    $self->{raport}->zakoncz("printTestEvaluation - Fatal error:  examId=$examId\n") if($examId<0);

    my $student=$studentsByExamId->{$examId};
    my $studentAnswers=$student->{odpowiedzi};
    my $RBkey=$student->key;

    if(!defined($par->{studentRecordBase}->{$RBkey}) && $RBkey !~ /^Dodatkowy\+\d+\+Dodatkowy-\d+$/){
#       print "Studenta o kluczu $RBkey brak w bazie danych\n";
       next STUDENTLOOP;
    };
    if( defined($studentAnswers)){
       $self->takeStatisticsDataFromStudent($student);
    }
  }

  # Na kocu informujemy o statystyce
  my $i=0;
  my @groups=@{$self->{answerStat}};
  for(my $group=1;$group<=$#groups;$group++){
    print TXT "==== Grupa $group ===\n";
    my @problems=@{$self->{answerStat}->[$group]};
    for(my $problem=1;$problem<=$#problems;$problem++){
      $i++;
      print TXT "  Problem $i:  Suma uzyskanych punktw=$self->{problemStat}->[$group]->[$problem]->{sumaWynikow}\n";

      # Zaczynamy od statystyki odpowiedzi
      my @wyniki=keys(%{$self->{problemStat}->[$group]->[$problem]});
      my $suma=0;
      foreach my $wyn (@wyniki){
        $suma+=$self->{problemStat}->[$group]->[$problem]->{$wyn} if($wyn =~ /^-?\d+$/);
      }

      print TXT "    ";
      foreach my $wyn (sort{$a <=> $b}(@wyniki)){
        if($wyn =~ /^-?\d+$/){
          my $val=int(1000*$self->{problemStat}->[$group]->[$problem]->{$wyn}/$suma)/10;
          print TXT "Wynik $wyn : $val% stud    ";
        }
      }
      print TXT "\n";

      my @answers=@{$self->{answerStat}->[$group]->[$problem]};
      for(my $answer=1;$answer<=$#answers;$answer++){
        my $t=( $self->{answers}->[0]->[$i-1]->[$answer-1]  ?
                chr(ord("A")+$answer-1) :
                chr(ord("a")+$answer-1)
              );
        my $unmarkBAD=$self->{answerStat}->[$group]->[$problem]->[$answer]->{'unmarkBAD'};
        my $unmarkOK=$self->{answerStat}->[$group]->[$problem]->[$answer]->{'unmarkOK'};
        my $markBAD=$self->{answerStat}->[$group]->[$problem]->[$answer]->{'markBAD'};
        my $markOK=$self->{answerStat}->[$group]->[$problem]->[$answer]->{'markOK'};
        my $ok=$unmarkBAD+$markOK;
        my $bad=$unmarkOK+$markBAD;
        my $total=$ok+$bad;
        my $val= ($total ? int(100*$ok/$total) : 'xxx');
        print TXT "    $t) $val% poprawnych\n";
      }
    }
  }
  close(TXT);
}

################################
#
# Drukujemy wyniki testu w formacie *.csv
#
sub printTestEvaluation{
  my ($self,$studentsByExamId,$answers,$par)=@_;
  open(RES,">$self->{partialResults}") || $self->{raport}->zakoncz("Failed to open $self->{partialResults}\n");
  my @examIds=sort {$a <=> $b} keys(%$studentsByExamId);
  my $examId;
  print RES <<END
[Nagwek]
DaneRekordu=nazwisko;imie;indeks;numerOsoby;punktyEgzaminoweBezwzgledne;punktyEgzaminowe;nieobecny;numerProtokolu
[ListaStudentw]
END
  ;

  my ($licznikBrakujacychFormularzy,$licznikOddanychFormularzy)=(0,0);
  STUDENTLOOP:
  foreach $examId (@examIds){

    # Zerowy $examId to test kontrolny, inne s bdne
    # Przy okazji pomijamy bdne rekordy puste
    next if($examId == 0);
    $self->{raport}->zakoncz("printTestEvaluation - Fatal error:  examId=$examId\n") if($examId<0);

    my $student=$studentsByExamId->{$examId};
    my $correctAnswers=$answers->[$student->{nrTestu}];
    my $studentAnswers=$student->{odpowiedzi};
    my $RBkey=$student->key;
    # Jeli odpowiedzi studenta nie istniej, to znaczy, e jego formularz testu
    # nie zosta w ogle zeskanowany.
    if(!defined($studentAnswers) && $self->{par}->{sygnalizujBrakujaceFormularze}){
       $self->{raport}->wymaluj(
          "=*=> Nie odnaleziono formularza studenta o kluczu $RBkey!!!\n".
          "Student nie odda formularza, formularz zosta zagubiony,\n".
          "albo sklei si przy skanowaniu\n\n");
       $licznikBrakujacychFormularzy++;
    }
    $licznikOddanychFormularzy++;

    # Jeli numeru testu nie wskazuje na istniejce prawidowe odpowiedzi, musia zosta
    # bdnie zeskanowany
    if( !$correctAnswers  ){
      $self->{raport}->wymalujError("\n\nW pliku ze skanera znaleziono nieistniejcy numer testu: $student->{numerEdycjiTerminu}-$student->{numerGrupySal}-$student->{nrTestu}!!!\n".
                  $student->imie(). " " .  $student->nazwisko().
                  "   Sprawdz plik: $student->{nazwaPlikuZeSkanera}, pozycja w wizce: $student->{pozycjaWWiazce} \n");
      $student->{brakNrTestu}=1;
    }
    if(!defined($par->{studentRecordBase}->{$RBkey}) && $RBkey !~ /^Dodatkowy\+\d+\+Dodatkowy-\d+$/){
       print "printTestEvaluation: Studenta o kluczu $RBkey brak w bazie danych\n";
    };

    # wynikTestu jest pojciem oglnym: to moe by wynikBezwzgledny lub wynikBezwzgledny
    # umownie przeliczony na procenty
    my $wynikTestu=(defined($studentAnswers) ? $student->{wynikTestu} :'');

    # Nie potrafimy sprawdzi w 100%, e student by nieobecny.
    # Nieobecny oznacza, e oddano pusty formularz odpowiedzi
    # t.zn. bez numeru testu i adnej odpowiedzi
#  To trzeba zmieni tak by przy braku oceny byo puste pole, a inne pole przekazywao
#  informacj o przyczynie
    $wynikTestu=( $student->{nieobecny} ? 'nieobecny': $wynikTestu);
    $wynikTestu=( $student->{brakNrTestu} ? '*': $wynikTestu);
    print RES "$student->{nazwisko};$student->{imie};$student->{indeks};$student->{numerOsoby};$student->{iloscPunktow};$wynikTestu;$student->{nieobecny};$student->{numerProtokolu};\n" ;
  }
  if($self->{par}->{sygnalizujBrakujaceFormularze} && !$licznikBrakujacychFormularzy){
    $self->{raport}->wymaluj("Oddano wszystkie formularze\n\n");
  }else{
    my $razemFormularzy=$licznikOddanychFormularzy+$licznikBrakujacychFormularzy;
    $self->{raport}->wymalujError("Brakuje $licznikBrakujacychFormularzy z $razemFormularzy formularzy!!!\n".
                                  "Zostay zagubione lub dokleiy si do innych przy skanowaniu\n\n");
  }
  close(RES);
}

################################
#
# Tworzymy zbiorczy plik z wynikami testu
#
sub zbierzWyniki{
#  my ($self,$nazwaBazowaTestu)=@_;
  my ($self,$par)=@_;

  my $nazwaBazowaTestu=$par->{nazwaBazowaTestu};
  my @sortingFieldsArray=qw(nazwisko imie indeks);
  my @protokolHeaderFieldsArray=qw(TypListy Protokol KodowaniePolskichLiter StanListy Wykladowca Kurs TypEgzaminu Rok Semestr DataEgzaminu RodzajStudiow FormaStudiow MaxPoints MaxStudentPoints OstatecznaIloscPunktowNa0Procent OstatecznaIloscPunktowNa100Procent OczekiwanyWynikPrzypadkowy OczekiwanyWynikPrzypadkowyDlaStrategiiPojedynczychOdpowiedzi DaneRekordu);
  my @protokolFieldsArray=     qw(nazwisko imie indeks numerOsoby nieobecny punktyEgzaminoweBezwzgledne);
  my @protokolFieldsNamesArray=qw(nazwisko imie numerAlbumu numerOsoby nieobecny punktyEgzaminoweBezwzgledne);
  my $punktyEgzaminoweKey="punktyEgzaminowe-$self->{nazwaSkroconaTestu}";
  my $numerProtokoluKey="numerProtokolu-$self->{nazwaSkroconaTestu}";

  push (@protokolFieldsArray,$punktyEgzaminoweKey);
  push (@protokolFieldsArray,$numerProtokoluKey);
  push (@protokolFieldsNamesArray,$punktyEgzaminoweKey);
  push (@protokolFieldsNamesArray,$numerProtokoluKey);

  my $studentRB=new StudentRecordBase($self->{raport});
  my $parBis={};

  opendir(DIR,$self->{auxDir});
  my @filelist=readdir(DIR);
  closedir(DIR);

  $RecordBase::warnOnFindingNewRecords=0;
  # doczamy dane z plikw -wynikiCzesciowe.csv
  foreach my $file (@filelist){
    if($file =~ /^[-\w\.]+-wynikiCzesciowe.csv$/){
#      print "Czytam wyniki czciowe z $file\n" if($main::opt_v);
      print "Czytam wyniki czciowe z $file\n";
      $studentRB->merge("$self->{auxDir}/$file",$parBis,'student');
    }
  }
  $RecordBase::warnOnFindingNewRecords=1;

  # Ustalamy punkty egzaminowe studentw
  while(my($studKey,$studentRef)=each(%$studentRB)){
#print " -->$studKey\n";
    $studentRef->{$punktyEgzaminoweKey}=$studentRef->{punktyEgzaminowe};
    $studentRef->{$numerProtokoluKey}=$studentRef->{numerProtokolu};
  }
  $studentRB->write("$nazwaBazowaTestu-wyniki.csv",$par,\@protokolHeaderFieldsArray,\@protokolFieldsArray,\@sortingFieldsArray,\@protokolFieldsNamesArray);
  copy "$nazwaBazowaTestu-wyniki.csv","../$nazwaBazowaTestu-wyniki.csv";
}

################################
#
# Oceniamy testy i drukujemy wyniki
#
sub evaluateTests{
  my ($self,$par,$studentsByExamId)=@_;

  $self->{raport}->wymaluj("Czytam klucze\n");
  my $answers=$self->{answers}=$self->readTestKey();

  $self->{raport}->wymaluj("Czytam odpowiedzi studentw\n");
  $self->readStudentAnswers($studentsByExamId);

  if($self->{par}->{'ocenZadania'}){
    $self->dolaczPunktyZadaniowe($studentsByExamId);
  }

  $self->wyznaczWspolrzednePytanWeWzorcu($studentsByExamId,$par);
  $self->naniesOdpowiedziAnulowaneKorygowane($studentsByExamId,$par);

  $self->{raport}->wymaluj("Punktuj odpowiedzi studentw\n");
  $self->evaluateStudentAnswers($studentsByExamId,$answers);
  $self->wyznaczWynikiProcentowe($studentsByExamId,$answers) if($self->{par}->{wynikProcentowy});

  $self->{raport}->wymaluj("Drukuj wyniki\n");
  $self->printTestEvaluation($studentsByExamId,$answers,$par);

  # Wersja alfabetyczna
  my $studentResulsFileNames=$self->printTestEvaluationForStudents($studentsByExamId,$answers,$par,0);
  # Wersja posortowana wedug wynikw
  $self->printTestEvaluationForStudents($studentsByExamId,$answers,$par,2);
  # Wersja tylko z numerami indeksw
  $self->printTestEvaluationForStudents($studentsByExamId,$answers,$par,1);

  if($par->{'indeksHtml'}){
    $self->wypiszIndeksHtml($studentResulsFileNames) if($main::opt_d);
  }else{
    $self->wypiszIndeksPhp($studentsByExamId) if($main::opt_d);
  }

  $self->{raport}->wymaluj("Przeprowadzam analiz statystyczn\n");

  $self->collectAnswerStatistics($studentsByExamId,$answers,$par);

}




1;
