###############################
#
# Klasa generatorListEgzaminacyjnych
# wersja dostosowana do pracy z jednym
# terminem, wraz z generatorem testw
#

package generatorListEgzaminacyjnych;

use utilities;
use polChar;
use StudentRecordBase;

################################
#
# Konstruktor
#
sub new{
  my ($class,$par,$nazwaBazowaTestu,$raport) = @_;
  my $self = {};
  bless($self,$class);

  $self->{pojemnosciSal}={};
  $self->{par}=$par;
  $self->{nazwaBazowaTestu}=$nazwaBazowaTestu;
  $self->{raport}=$raport;

  return $self;
}

################################
#
# Podprogram czytajcy sale z pliku
#
sub readRooms{
  my ($self) = @_;
  my $rooms="rooms.txt";
  my $found=0;
  LOOP:
  for (my $i=0;$i<5;$i++){
    if(open(ROOMS,"<$rooms")){
      $found=1;
      last LOOP;
    }
    $rooms="../$rooms";
  }
  if($found){
    while(<ROOMS>){
      if( !($_ =~ /^\s*\#/ || $_ =~ /^\s*$/) ){
        s/\n//g;
        if($_ =~ /^([^=]+)=(.*)$/){
          my ($nrsali,$pojemn) = ( eject_blanks($1), eject_blanks($2) );
          $nrsali =~s/\//-/g;
          $self->{pojemnosciSal}->{$nrsali}=$pojemn;
          print "Zadeklarowano sale $nrsali o pojemnosci $pojemn\n" if($main::opt_v);
        }
      }
    }
    close(ROOMS);
  }elsif(my $rooms=$self->{par}->{rooms}){
    while($rooms =~ /^\s*([\w.-]+)\s*:\s*(\d+),?(.*)\s*$/){
      $self->{pojemnosciSal}->{$1}=$2;
      $rooms=$3;
    }
  }else{
    $self->{raport}->wypisz("Nie odnaleziono informacji o pojemnociach sal") if(!$found);
    return 0; # Wczytanie sal zakoczone niepowodzeniem
  }
  return 1; # Wczytanie sal zakoczone sukcesem
}

##########################################
# Funkcja rozdziela studentow na grupy egzaminacyjne i sale
#
sub scheduleExams{
#  my ($self,$students_file) = @_;
  my ($self) = @_;

  print "Rozpisuje egzamin dla $self->{nazwaBazowaTestu}\n";
  # Czytamy pojemnoci sal
  if(!$self->readRooms()){
    $self->{raport}->wymaluj("Brak informacji o pojemnociach sal, pomijam rozpisanie egzaminw\n");
    return;
  }

  # Wyznaczamy calkowita pojemnosc sal dla danego terminu;
  my @sale=split(',',$self->{par}->{sala});
  my $total=0;
  my ($i,$j);
  foreach my $sala (@sale){
    print "Dodaje pojemnosc sali $sala = $self->{pojemnosciSal}->{$sala}\n" if($main::opt_v);
    if(!$self->{pojemnosciSal}->{$sala}){
      $self{raport}->wymaluj("Sala $sala ma pojemno zero!") ;
    }
    $total+=$self->{pojemnosciSal}->{$sala};
    $self->{groupsByTerm}->{"$self->{nazwaBazowaTestu}-listaSali-$sale[$i]"}={}
  }
  if($total<=0){
     $self{raport}->wymalujError("Rozdzia studentw do sal nie powid si.\n");
     next;
  }

  # Czytamy studentw
#  my($lstud,$studentRB)=$self->wczytajStudentow($students_file);
  my $studentRB=new StudentRecordBase();
  $studentRB->wczytajStudentow({},$self->{raport},'studenci',$self->{par}->{edycja});
  my @studList=polSort(keys(%{$studentRB}));
  my $lstud=$#studList+1;

  next if($lstud<=0);

  # Wyznaczamy limity dla sal proporcjonalnie do ich pojemnosci
  my @border=();
  my $subtotal=0;
  for ($i=0;$i<$#sale;$i++){
    $subtotal+=int($self->{pojemnosciSal}->{$sale[$i]}*$lstud/$total+0.5);
    $border[$i]=$subtotal;
    print "Subtotal =$subtotal Border nr $i=$border[$i]\n" if($main::opt_v);
  }
  # Zaokrglenia nie mog wykluczy adnego ze studentw, wic ostatni border ustawiamy rwny liczbie studentw
  $border[$#sale]=$lstud;

 # Rozdzielamy studentow danego terminu proporcjonalnie miedzy sale
  $i=$j=0;
  for($j=0;$j<$lstud;$j++){
    $i++ if($j==$border[$i]);
    my $studKey=$studList[$j];
    my $student=$studentRB->{$studKey};
    $student->{'data'}=$self->{par}->{'data'};
    $student->{'godzina'}=$self->{par}->{'godzina'};
    $student->{'sala'}=$sale[$i];
    print "Dopisuje  $student->{nazwisko} $student->{imie} do listy egzaminacyjnej egz-$self->{nazwaBazowaTestu}-$sale[$i]\n" if($main::opt_v);
    $self->{groupsByTerm}->{"$self->{nazwaBazowaTestu}-listaSali-$sale[$i]"}->{$studKey}=$student;
    $self->{groupsByTerm}->{"$self->{nazwaBazowaTestu}-listaSali-$sale[$i]"}->{jestKomentarz}=1 if($studRef->{przesunietyPierwszyTermin});
    $self->{groupsByTerm}->{"$self->{nazwaBazowaTestu}-listaZbiorcza"}->{$studKey}=$student;

  }
}

##########################################
# wyznacza termin, typ i sal grupy
# na podstawie jej nazwy
#
sub decomposeGroup{
  my ($grupa)=@_;
  my ($typ,$termin,$sala);
  if($grupa =~ /^(.*)-listaSali-([^-]*)$/){
    ($termin,$sala,$typ)=($1,$2,'listaSali');
  }elsif($grupa =~ /^(.*)-listaZbiorcza$/){
    ($termin,$sala,$typ)=($1,'','listaZbiorcza');
  }elsif($grupa eq 'lista_egzaminacyjna-0'){
# Poprawiam, bo chc odrzni list zbiorcz (egzaminacyjn) od listy wstpnej
#    ($termin,$sala,$typ)=('','','listaZbiorcza');
    ($termin,$sala,$typ)=('','','listaWstepna');
  }else{
    $self->{raport}->zakoncz("Failed to decompose group $grupa\n");
  }
  return ($typ,$termin,$sala);
}
##########################################
# drukuje listy egzamiancyjne w HTMLu do wywieszenia w Internecie
#
sub printExamListInHtml{
  my ($self,$par,$grupa)=@_;
  my $listaZbiorcza=0;
  my ($typ,$termin,$sala)=decomposeGroup($grupa);
  $listaZbiorcza=1 if($typ eq 'listaZbiorcza' || $typ eq 'listaWstepna');
  my ($data,$godzina)=('','');
  if($typ ne 'all'){
    $data=$self->{par}->{data};
    $godzina=$self->{par}->{godzina}
  }
  print "Drukuj list egzaminacyjn dla grupy =$grupa=\n" if($main::opt_v);
  my $html_file_name=$grupa.'.html';
  open(HTML,">$html_file_name") || $self->{raport}->zakoncz("Failed to open $html_file_name for printExamListInHtml");
  print HTML "<HTML>\n";
  print HTML "<HEAD>\n";
  print HTML "  <META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=windows-1250\">\n";
  print HTML "   <TITLE> $par->{'kurs'} </TITLE>\n";
  print HTML "</HEAD>\n";
  print HTML "<CENTER><FONT SIZE=+3> Lista egzaminacyjna </FONT></CENTER>\n";
  my $opis;
  if($self->{par}->{wariant} eq 'UJ'){
  $opis=<<END
  <li> Ponisza lista obejmuje studentw zapisanych na kurs
       wedug stanu w Sekretariacie II UJ
  <li> Jeli kogo nie ma na tej licie, a powinien
       by, proszony jest o sprawdzenie w Sekretariacie
       dlaczego nie zosta dopisany do listy i o e-mail do mnie
       z imieniem, nazwiskiem, numerem indeksu oraz
       wyjanieniem podanym przez sekretariat dlaczego
       zabrako go na licie.
END
  ;
  }
  if($self->{par}->{wariant} eq 'WSB'){
    $opis=<<END
  <li> Ponisza lista obejmuje studentw zapisanych na kurs
       wedug stanu w Dziekanacie na pocztku semestru
       i w trakcie semestru nie jest aktualizowana
  <li> Jeli kogo nie ma na tej licie, a powinien
       by, proszony jest o sprawdzenie w Dziekanacie
       czy zosta dopisany do listy
  <li> Do egzaminu przystpi bd mogy tylko te osoby, ktre
       znajd si na licie pobranej z dziekanatu na tydzie przed
       egzaminem
  <li> <font color=red>  Brakw na licie prosz nie zgasza
       do mnie tylko do dziekanatu</font>
END
  ;
  }
  if($typ eq 'listaWstepna'){
     print HTML <<END
<center>
<table border=1>
<tr>
<td>
<ul>
END
     ;
     print HTML $opis;
     print HTML <<END

</ul>
</table>
</center>
END
     ;
  }
  print HTML "<H3> Kurs: $self->{par}->{'Kurs'} </H3>\n";
  print HTML "<H3> Rok: $self->{par}->{'Rok'} </H3>\n";
  print HTML "<H3> Forma Studiw: $par->{'FormaStudiow'} </H3>\n" if($self->{par}->{wariant} eq 'WSB');
  print HTML "<H3> Rodzaj Studiw: $par->{'RodzajStudiow'} </H3>\n" if($self->{par}->{wariant} eq 'WSB');
  print HTML "<H3> Data: $data </H3>\n" if($data);
  print HTML "<H3> Godzina: $godzina </H3>\n" if($godzina);
  print HTML "<H3> Sala: $sala </H3>\n" if($sala);
  print HTML "<p><TABLE BORDER=2 CELLSPACING=2 CELLPADDING=3>\n";
  if($grupa eq 'all'){
    print HTML "<TR><TH>Lp.</TH><TH>Nazwisko</TH><TH>Imi</TH><TH>Dzie</TH><TH>Godzina</TH>";
  }else{
    my $komentarz=($studRef->{przesunietyPierwszyTermin} ? "<TH>Komentarz</TH>":'');
    my $sala=($typ eq 'listaWstepna' ? "" : "<TH>Sala</TH>");
    print HTML "<TR><TH>Lp.</TH><TH>Nazwisko</TH><TH>Imi</TH><TH>Dzie</TH><TH>Godzina</TH>$sala$komentarz";
  }
  my $np=0;
  my $saZaleglosci=0;
  foreach my $studKey (polSort(keys(%{$self->{groupsByTerm}->{$grupa}}))){
    $np++;
    my $studRef=$self->{groupsByTerm}->{$grupa}->{$studKey};
    my $data=$studRef->{'data'};
    my $godzina=$studRef->{'godzina'};
    my $sala;
    $sala=($typ eq 'listaWstepna' ? "" : "<TD>$studRef->{'sala'}</TD>");
    my $komentarz=($studRef->{przesunietyPierwszyTermin} ? "<TD>pierwszy termin</TD>":'');
    print HTML  "<TR>";
    print HTML  "<TD>$np</TD>";
    print HTML  "<TD>$studRef->{'nazwisko'}</TD>";
    print HTML  "<TD>$studRef->{'imie'}</TD>";
    print HTML  "<TD>$data</TD>";
    print HTML  "<TD>$godzina</TD>";
    print HTML  $sala;
    print HTML  "$komentarz";
    print HTML  "</TR>\n";
  }
  print HTML "</TABLE></CENTER>\n";
  print HTML "</BODY>\n";
  print HTML "</HTML>\n";
  close(HTML);
  move($html_file_name,'lists') if(-d 'lists');
}

my @parFieldsArray=qw(Kurs Kierunek Studia Rok TypEgzaminu DataEgzaminu DaneRekordu);
my @fieldsArray=qw(liczbaPorzadkowa indeks nazwisko imie);
my @sortingFieldsArray=qw(nazwisko imie indeks);

####################################################
#   Podprogram rozpisujcy egzaminy
#

sub rozpiszEgzaminy{
  my ($self)=@_;
  my $par=$self->{par};

  $self->scheduleExams();
  foreach my $grupa (keys(%{$self->{groupsByTerm}})){
    $self->printExamListInHtml($par,$grupa);
  }
}

####################################################
#   Podprogram generujcy list dla prowadzcych wiczenia
#

sub przygotujListeCwiczeniowa{
  my ($self)=@_;
  print "Rozpisuje list wiczeniow dla $self->{nazwaBazowaTestu}\n";

  $self->{par}->{nazwaBazowaKursu}=$self->{par}->{nazwaBazowaTestu} if(!$self->{par}->{nazwaBazowaKursu});

  my $masterRecord={nazwisko => 1, imie => 1, indeks => 1, numerOsoby => 1, grupaCwiczeniowa => 1};
  print "Czytam list studentw dla listy wiczeniowej\n";
  my $studentRB=new StudentRecordBase();
  my $par={};
  $studentRB->wczytajStudentow($par,$self->{raport},'studenci',0,$masterRecord);

  my @fieldsArray=qw(nazwisko imie indeks punktyCwiczeniowe zaliczenie);
  # Przy kursie NeB punktacja z cwiczen musi byc rozbita na elementy
  if($self->{par}->{ocenProjekty}){
    @fieldsArray=qw(liczbaPorzadkowa grupaCwiczeniowa nazwisko imie numerOsoby indeks adresStrony pHTML pSSI pCSS pJS pXML pWML pForms pCGI pMulti pEst pAktywnosc);
  }
#  if($self->{par}->{wariant} eq 'UJ'){ # Pominite, bo pokrywa si z domylnym
#    @fieldsArray=qw(nazwisko imie indeks punktyCwiczeniowe zaliczenie);
#  }
  if($self->{par}->{wariant} eq 'WSB'){
    @fieldsArray=qw(grupaCwiczeniowa nazwisko imie numerOsoby indeks punktyCwiczeniowe);
  }
  my @cwiczeniaSortingFieldsArray=qw(grupaCwiczeniowa nazwisko imie indeks);
  # Wypisujemy list studentw do wpisania ocen wicze
  @{$self->{parFieldsArray}}=qw(Kurs Rok RodzajStudiow FormaStudiow Asystent DaneRekordu);
  $studentRB->write("$self->{par}->{nazwaBazowaKursu}-cwiczenia-nnn.csv",$self->{par},$self->{parFieldsArray},\@fieldsArray,\@cwiczeniaSortingFieldsArray);
}

##########################################
# Funkcja przygotowuje list wstpn studentw zapisanych na egzamin
#
sub przygotujListeWstepna{
  my ($self) = @_;


  print "Rozpisuje list wstpn dla $students_file\n";
  my $studentRB=new StudentRecordBase();
  $studentRB->wczytajStudentow({},$self->{raport},'studenci');

  foreach $studKey (keys(%{$studentRB})){
    my $student=$studentRB->{$studKey};
    $student->{'data'}=$self->{par}->{'data'};
    $student->{'godzina'}=$self->{par}->{'godzina'};
    print "Dopisuje  $student->{nazwisko} $student->{imie} do listy egzaminacyjnej egz-$self->{nazwaBazowaTestu}-$sale[$i]\n" if($main::opt_v);
    $self->{groupsByTerm}->{'lista_egzaminacyjna-0'}->{$studKey}=$student;
  }
  $self->printExamListInHtml($self->{'par'},'lista_egzaminacyjna-0');
}

###########################################################################

1;
