##################
#
# klasa grader
# Wystawia ocene w oparciu o podane limity i ukad ocen
#
#

package grader;

##################
#
# Konstruktor
#

sub new{
  my ($class,$limityOcen,$formaOcen) = @_;
  my $self = {};
  bless($self,$class);
  @{$self->{formaOcen}}=split(",",$formaOcen);
  @{$self->{limityOcen}}=split(",",$limityOcen);
  foreach my $x (@{$self->{formaOcen}}){
    if($x !~ /celujcy|bdb|db+|db|dst+|dst|mierny|ndst/){
      $egzaminator::biezacyRaport->wymalujError( "Niedopuszczalna forma oceny: $x\n".
      "Dopuszczalne formy to celujcy|bdb|db+|db|dst+|dst|mierny|ndst \n");
    }
  }
  return $self;
}

sub wyznaczOcene{
  my ($self,$punktyCwiczeniowe,$punktyEgzaminowe,$wynikProcentowy,$wagaEgzaminu)=@_;
  $wagaEgzaminu=0.5 if(!defined($wagaEgzaminu));
  my ($ocena,$punktyRazem,$poziomOceny);
  if( $punktyEgzaminowe =~ /^\s*\d*\.?\d*\s*$/ ){
    $punktyRazem=( $punktyCwiczeniowe =~ /\d/ ?
                   ($wynikProcentowy ?
                      int(0.5+(1-$wagaEgzaminu)*$punktyCwiczeniowe+$wagaEgzaminu*$punktyEgzaminowe) :
                      $punktyCwiczeniowe+$punktyEgzaminowe
                   ):
                   ($wynikProcentowy ?
                      int(0.5+$wagaEgzaminu*$punktyEgzaminowe) :
                      $punktyEgzaminowe
                   )
                 );
    $poziomOceny=0;
    while($punktyRazem<$self->{limityOcen}->[$poziomOceny]){$poziomOceny++;};
    $ocena=$self->{formaOcen}->[$poziomOceny];
  }else{
    $ocena='-';
    $punktyRazem='-';
    $poziomOceny=-1;
  }
  return ($ocena,$punktyRazem,$poziomOceny);
}

sub limityOcen{
  my ($self)=@_;
  return $self->{limityOcen};
}

sub formaOcen{
  my ($self)=@_;
  return $self->{formaOcen};
}

1;