###############################
#
# Klasa oceniaczProjektow
#

package oceniaczProjektow;

@ISA=qw(wystawiaczOcen);


use strict;
use utilities;
use textUtil;
use polChar;
use StudentRecordBase;
use wystawiaczOcen;


##########################################
# Metoda uzywana gdy asystenci oddaj czstkowe punkty
# z wicze i trzeba obliczy ich sum
#
sub obliczPunktyCwiczeniowe{
  my ($self,$studentRB)=@_;

  # Nastpnie analizujemy podejscia kadego studenta i ustalamy punkty
  # z egzaminu i poprawki
  while(my($studKey,$studentRef)=each(%$studentRB)){
    my $studentOnline = ($studentRef->{grupaCwiczeniowa} =~ /ON-LINE/);
    if($studentRef->{punktyCwiczeniowe} !~ /\d/){
      $studentRef->{punktyCwiczeniowe}=0;
      my @attributes=keys(%$studentRef);
      foreach my $attribute (@attributes){
        if($attribute =~ /^p[A-Z][\w]+$/){
           next if($attribute =~ /^punktyEgzaminowe/);
           # Nie liczymy punktw za aktywno
           next if($attribute =~ /^pAkt/ && !$studentOnline);
           $studentRef->{$attribute} =~ s/,/./g;
           # Korekta nieporozumienia z Kornatk w 07-2004 (zaokrglenie w gr od 0.5):
           $studentRef->{$attribute} = 1+int($studentRef->{$attribute}) if($self->{par}->{roundHalfsUp} && $studentRef->{$attribute} - int($studentRef->{$attribute}) >= 0.5);
           $studentRef->{$attribute}=0 if($studentRef->{$attribute} !~ /\d/);
           $studentRef->{punktyCwiczeniowe}+=$studentRef->{$attribute};
        }
      }
      # Przeliczenie na procenty przy max 100
      # w przeciwnym razie tylko zaokrglenie
      if($self->{par}->{wynikProcentowy}){
        my $maxPpunktyCwiczeniowe=($studentOnline ? 50.0 : 40.0);
        $studentRef->{punktyCwiczeniowe}=int(0.5+$studentRef->{punktyCwiczeniowe}/$maxPpunktyCwiczeniowe*100.0);
      }else{
        $studentRef->{punktyCwiczeniowe}=int(0.5+$studentRef->{punktyCwiczeniowe});
      }
      # Studenci on-line musz mie zatwierdzon stron
#      if($studentRef->{grupaCwiczeniowa} =~ /on-line/ && !$studentRef->{akceptacjaPunktowCwiczeniowych}){
#        print "Brak akceptacji punktow cwiczeniowych ($studentRef->{punktyCwiczeniowe}) dla $studKey\n";
#        $studentRef->{punktyCwiczeniowe}=0;
#      }
    }
  }
}

##########################################
# Wydrukuj wyniki z wicze z adresami stron w formacie HTML
# podporgram dodany z myl o kursie Narzdzia E-Biznesu
#
sub drukujWynikiCwiczen{
  my ($self,$list_type,$par,$studentRB) = @_;
  my (@grade_limit,@popr_limit,@ihs_limit,@grade_shift,@grade_coef,@grade_form,@grade_counter);

  my @sorted;
  my @to_sort;
  my $html_file="$self->{baseName}.lista-adresow-stron.by-$list_type.html";

  my $kurs=($par->{'Kurs'}?$par->{'Kurs'}:$par->{'kurs'});
  my $kierunek=($par->{'Kierunek'}?$par->{'Kierunek'}:$par->{'kierunek'});
  my $rok=($par->{'Rok'}?$par->{'Rok'}:$par->{'rok'});
  my $studia=($par->{'Studia'}?$par->{'Studia'}:$par->{'studia'});
  $studia=($par->{'RodzajStudiow'}?$par->{'RodzajStudiow'}:$studia);
  $studia.= " $par->{'FormaStudiow'}";
  open(HTML,">$html_file");
  print HTML "<HTML>\n";
  print HTML "<HEAD>\n";
  print HTML "  <META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=windows-1250\">\n";
  print HTML "   <TITLE> $kurs </TITLE>\n";
  print HTML "</HEAD>\n";
  print HTML "<CENTER><H2> $kurs </H2>\n";
  print HTML "<H3> Ocena projektw </H3>\n";
  print HTML "<TABLE BORDER=2 CELLSPACING=2 CELLPADDING=3>\n";
  print HTML "<TR><TH>L.p.</TH>";
  print HTML "<TH>Indeks</TH>";
  print HTML "<TH>Nazwisko</TH>" if($list_type ne 'indeks');
  print HTML "<TH>Adres strony</TH>" if($list_type ne 'indeks');
  if(!$main::opt_z){
    my $extraHeadings="";
    $extraHeadings.="<th>HTML</th>";
    $extraHeadings.="<th>SSI</th>";
    $extraHeadings.="<th>CSS</th>";
    $extraHeadings.="<th>JS</th>";
    $extraHeadings.="<th>XML</th>";
    $extraHeadings.="<th>WML</th>";
    $extraHeadings.="<th>Forms</th>";
    $extraHeadings.="<th>CGI</th>";
    $extraHeadings.="<th>Multi</th>";
    $extraHeadings.="<th>Est</th>";
    $extraHeadings.="<th></th>";
    $extraHeadings.="<th></th>";
    print HTML $extraHeadings;
  }
  print HTML "\n";


  my @studentKeys=keys %$studentRB;
  my $nstud=$#studentKeys+1;
  my $j;

  # Stosownie do zyczenia sortujemy
  for($j=0;$j<$nstud;$j++){
    my $studentRef=$studentRB->{$studentKeys[$j]};
    my $key;
    $key=($list_type eq 'name' ?
#         pol2ascii($studentRef->{'nazwisko'} .' '.$studentRef->{'imie'}) :
         pol2code($studentRef->{'nazwisko'} .' '.$studentRef->{'imie'}) :
         wystawiaczOcen::addLeadingZeros($studentRef->{'punktyCwiczeniowe'})
    );
    $key=($list_type eq 'indeks' ?
#         pol2ascii($studentRef->{'indeks'}) :
         pol2code($studentRef->{'indeks'}) :
         $key
    );
#    $to_sort[$j]=$key.":".$j;
# Poprawka do pary z nastpn ma na celu uniknicie problemw
# gdy w numerach indeksw s dwukropki
    $to_sort[$j]=$key.":\t:".$j;
#print "Added $to_sort[$j]\n";
  }
  @sorted = sort @to_sort;

  $self->{'oddaneProjekty'}={};

  for(my $j=0;$j<$nstud;$j++){
    # Z posortowanej tablicy wydobywamy indeks
#    my($key,$i)=split(/:/,$sorted[$j]);
    my($key,$i)=split(/:\t:/,$sorted[$j]);
    # i odczytujemy hash z damymi studenta
    my $studentRef=$studentRB->{$studentKeys[$i]};
    #Zliczamy ilo oddanych stron wedug protokow:
    if($studentRef->{'adresStrony'}){
      my $prot=$studentRef->{'numerProtokolu'};
      if($self->{'oddaneProjekty'}->{$prot}){
        $self->{'oddaneProjekty'}->{$prot}++;
      }else{
        $self->{'oddaneProjekty'}->{$prot}=1;
      }
    }
    my $lp=$j+1;
    if(1){
      print HTML  "<TR>";
      print HTML  "<TD>$lp</TD>";
      print HTML  "<TD>$studentRef->{'indeks'}</TD>";
      print HTML  "<TD>$studentRef->{'nazwisko'} $studentRef->{'imie'}</TD>" if($list_type ne 'indeks');
      my $adresStrony=$studentRef->{'adresStrony'};
      print HTML  "<TD><a href=\"$adresStrony\">$adresStrony</a>\n</TD>" if($list_type ne 'indeks');
      if(!$main::opt_z){
        my $pCzastkowe="";
        $pCzastkowe.='<td>'.fill_to_left($studentRef->{'pHTML'},2).'</td>';
        $pCzastkowe.='<td>'.fill_to_left($studentRef->{'pSSI'},2).'</td>';
        $pCzastkowe.='<td>'.fill_to_left($studentRef->{'pCSS'},2).'</td>';
        $pCzastkowe.='<td>'.fill_to_left($studentRef->{'pJS'},2).'</td>';
        $pCzastkowe.='<td>'.fill_to_left($studentRef->{'pXML'},2).'</td>';
        $pCzastkowe.='<td>'.fill_to_left($studentRef->{'pWML'},2).'</td>';
        $pCzastkowe.='<td>'.fill_to_left($studentRef->{'pForms'},2).'</td>';
        $pCzastkowe.='<td>'.fill_to_left($studentRef->{'pCGI'},2).'</td>';
        $pCzastkowe.='<td>'.fill_to_left($studentRef->{'pMulti'},2).'</td>';
        $pCzastkowe.='<td>'.fill_to_left($studentRef->{'pEst'},2).'</td>';
        $pCzastkowe.='<td>'.fill_to_left($studentRef->{'pAktywnosc'},2).'</td>';
        $pCzastkowe.='<td>'.fill_to_left($studentRef->{'punktyCwiczeniowe'},2).'</td>';
        print HTML  $pCzastkowe;
      }
      print HTML  "</TR>\n";
    }
  }
  print HTML "</TABLE></CENTER>\n";

  while (my ($key,$value) = each %{$self->{'oddaneProjekty'}}) {
     print HTML "<p> Protok $key: oddano $value projektw </p>\n";
  }
  print HTML "</BODY>\n";
  print HTML "</HTML>\n";
  close(HTML);
}

####################################################
#   Podprogram wyliczajcy punktacj z wicze
#   i przygotowujcy list zbiorcz adresw projektw
#   (dodany z myl o kursie Narzdzia e-biznesu)
#

sub ocenProjekty{
  my ($self)=@_;
  my $studentRB=$self->{studentRB};
  my $par=$self->{par};
  my $parbis={};
  my $basename=$self->{baseName};
  $self->dolaczPunktyCwiczeniowe($studentRB,$basename,$parbis);
  $self->obliczPunktyCwiczeniowe($studentRB);
  $self->drukujWynikiCwiczen('name',$par,$studentRB);
  $self->drukujWynikiCwiczen('score',$par,$studentRB);
  $self->drukujWynikiCwiczen('indeks',$par,$studentRB);
}

####################################################
#   Podprogram wyliczajcy punktacj z wicze
#   i przygotowujcy list zbiorcz adresw projektw
#   (dodany z myl o kursie Narzdzia e-biznesu)
#

sub dolaczPunktyCwiczeniowe{
  my ($self,$studentRB,$basename,$par)=@_;
  my $parbis={};
  $self->SUPER::dolaczPunktyCwiczeniowe($studentRB,$basename,$parbis);
#  $self->SUPER::dolaczPunktyCwiczeniowe($studentRB,$basename,$par);
  $self->obliczPunktyCwiczeniowe($studentRB);
  $self->drukujWynikiCwiczen('name',$par,$studentRB);
  $self->drukujWynikiCwiczen('score',$par,$studentRB);
  $self->drukujWynikiCwiczen('indeks',$par,$studentRB);
}


1;