##################
#
# Klasa pracujNaEdycjiTestu
#
# zawiera wsplne metody dla klas robtest i ocentest
#
#

package pracujNaEdycjiTestu;

use FindBin qw($Bin);
use Getopt::Long;
use lib "$Bin/egzaminator";
use lib "$Bin/utilities";
use lib "$Bin/xml";

use polChar;                  # biblioteka podprogramw obsugi polskich liter
use utilities;
use student;                  # klasa student
use answerform;               # klasa answerform
use binary;                   # biblioteka podprogramw do przetwarzania danych binarnych
use raport;                   # Klasa do robiena raportu.
use raportOkienkowy;



use examTestSimple;
use examTestMultiChoice2Pt;
use examTestMultiChoice2PtSymmetric;
use examTestMultiChoiceSymmetric;
use examTestHalfMultiChoice2Pt;
use examTestMultiChoice2PtNonAll;

use generatorListEgzaminacyjnych;

################################
#
# Konstruktor
#

sub new{
  my $class = shift;
  my $self = {};
  bless($self,$class);
  $self->ustawOpisy();
  return $self;
}

############################## wczytaj_sito ######################
#
#  Wczytuje haslo i zamienia go na liczbe naturalna
#
sub wczytaj_sito{
  my ($self,$par)=@_;

  my $haslo;
  if(!$par->{pwd}){
    print("\n\n*******************************************************\n");
    print("Podaj haslo ktore umozliwi ewentualne odzyskanie danych\n\n");
    print("!!! ZGUBIENIE HASLA JEST ROWNOZNACZNE Z NIEMOZLIWOSCIA ODZYSKIWANIA DANYCH !!!\n\n");
    print("*******************************************************\n\n");
    print("HASLO = ");
    # wczytuje z klawiatury
    $haslo = <>;
    chomp($haslo);
  }else{
    $haslo=$par->{pwd};
  }
  eject_blanks($haslo);

# print "Generuje sito z =$haslo=\n";
  my $liczba = 0;
  my @literki=split(/\s*/,uc($haslo));
  foreach my $w (@literki){
    $liczba += ord($w);
  };
# print "Wygenerowano =$liczba=\n";
  return $liczba

}

############################## ustawEdycje ######################
#
#  Jesli praca ma byc z edycja, odpowiednio ustawia potrzebne
#  nazwy parametrow i czyta odpowiednie pliki inicjalizacyjne
#
sub ustawEdycje{
  my ($self,$plikKonfiguracyjnyEdycji)=@_;

  my $dir=pwd();
  my $par={};
  $par=$self->{par} if(defined($self->{par}));
  # Czytamy pliki konfiguracyjne
  #      szczegowy  (ostatni parametr to reRead - wymusza odswieenie
  if(-r $plikKonfiguracyjnyEdycji){
    readConfiguration($dir,1,$par,$plikKonfiguracyjnyEdycji,1);
  }
  #      i oglne
  if(-r 'conf'){
    readConfiguration($dir,1,$par);
  }else{
    $self->{raport}->zakoncz("Nie znaleziono pliku konfiguracyjnego conf\n");
  }
  $par->{caller}=ref($self);
  print "$par->{caller}:\n";



  # Przywracamy pierwotn nazw bazow testu (bez edycji)
  $par->{nazwaBazowaTestu}=$par->{nazwaBazowaTestuBezEdycji};
  # Sprawdzamy czy dane s zgodne i ustalamy numery edycji i grupy sal
  if( $plikKonfiguracyjnyEdycji eq ''){
    # To oznacza stare rozwizanie
    $par->{numerEdycjiTerminu}=3;
    $par->{numerGrupySal}=7;
    $par->{edycja}='';
  }elsif( $plikKonfiguracyjnyEdycji =~ /^([\w.]+)-(\d)(\d?)\.conf$/){
    # To oznacza nowe rozwizanie z explicite podan edycj jedno lub dwucyfrow
    # Pierwsz cyfra to numer terminu, druga jeli jest to numer grup sal
    $par->{edycja}="$2$3";
    $self->{raport}->zakoncz("Zla nazwa pliku konfiguracyjnego: $plikKonfiguracyjnyEdycji($1) \nnie odpowiada nazwie bazowej testu: $par->{nazwaBazowaTestu}") if( $1 ne $par->{nazwaBazowaTestu});
    $par->{numerEdycjiTerminu}=$2;
    $par->{numerGrupySal}=$3;
    $self->{raport}->zakoncz("Numer edycji terminu $par->{numerEdycjiTerminu} poza przedzialem [1,7]\n") if($par->{numerEdycjiTerminu}<=0 || $par->{numerEdycjiTerminu}>7);
    $self->{raport}->zakoncz("Numer grupy sal $par->{numerGrupySal} poza przedzialem [1,7]\n") if($par->{numerGrupySal}<0 || $par->{numerGrupySal}>7 || $par->{numerGrupySal} eq '0');
  }elsif( $plikKonfiguracyjnyEdycji =~ /^([\w.]+)\.conf$/){
    # To oznacza nowe rozwizanie z domyln edycj terminu i grup sal zero.
    $self->{raport}->zakoncz("Zla nazwa pliku konfiguracyjnego: $plikKonfiguracyjnyEdycji \nnie odpowiada nazwie bazowej testu: $par->{nazwaBazowaTestu}") if( $1 ne $par->{nazwaBazowaTestu});
    $par->{numerEdycjiTerminu}=0;
    $par->{numerGrupySal}=0;
    $par->{edycja}='';
  }

  # Modyfikujemy nazw bazow stosownie do nazwy edycji
  if($par->{nazwaBazowaTestu} !~ /^[^-]+-\d+$/ && $par->{edycja}){
    $par->{nazwaBazowaTestu}=$par->{nazwaBazowaTestuBezEdycji}."-$par->{edycja}";
  }

  $self->{raport}->wymaluj("\n     --- $par->{nazwaBazowaTestu} ---\n");

}

############################## utworzKatalogi ######################
#
#  Tworzy potrzebne katalogi
#
sub utworzKatalogi{
  my ($self)=@_;

  my $par=$self->{par};
  # Sprawdzamy czy istniej odpowiednie katalogi wyjciowe
  # i w razie potrzeby generujemy je
  if($par->{rozdzielonePliki}){
    mkdir('tex',0660) if (!(-d 'tex') && $par->{formatKoncowy} >= 1);
    mkdir('dvi',0660) if (!(-d 'dvi') && ($par->{formatKoncowy} == 2 || $par->{formatKoncowy} == 3));
    mkdir('ps',0660) if (!(-d 'ps') && $par->{formatKoncowy} == 3);
    mkdir('pdf',0660) if (!(-d 'pdf') && $par->{formatKoncowy} == 4);
    mkdir('lists',0660) if (!(-d 'lists'));
    mkdir('html',0660) if (!(-d 'html') && $par->{generujPlikiOdpowiedzi});
  }
  mkdir('auxil',0660) if (!(-d 'auxil'));
}

############################## wyznaczUzywanyTest ######################
#
#  Wyznacza typ uywanego testu
#
sub wyznaczUzywanyTest{
  my ($self)=@_;
  my $par=$self->{par};

  # Sprawdzamy czy ustawiono wg jakiego rodzaju testu bedziemy oceniac
  # (To jest nieeleganckie rozwizanie, powinno si podawa nie numer, tylko
  # nazw rodzaju testu )
  my %listaRodzajowTestow = (1 => "examTestSimple",
                             2 => "examTestMultiChoice2Pt",
                             3 => "examTestMultiChoice2PtSymmetric",
                             4 => "examTestMultiChoiceSymmetric",
                             5 => "examTestHalfMultiChoice2Pt",
                             6 => "examTestMultiChoice2PtNonAll"
                             );
  if( ( $par->{rodzajTestu} < 1 ) ||
       ($par->{rodzajTestu})  > keys(%listaRodzajowTestow)
    )
  {
    $self->{raport}->zakoncz("\nPrzerywam dziaanie programu\n\nNie podano lub podano niepoprawny rodzaj testu w pliku konfiguracyjnym\n\n");
  }
  my $uzywanyTest = $listaRodzajowTestow{ $par->{rodzajTestu} };
  # W opcji use tylko ta klasa testu ktrej chce uytkownik
  eval {require "$uzywanyTest.pm"};
  if( $EVAL_ERROR ){
     $self->{raport}->zakoncz("Brak opisu danego moduu w kartotece z programem.\nTen modu to - $uzywanyTest.pm\n");
  }
  return $uzywanyTest;
}

############################## wczytajStudentowZalegajacych ######################
#
#  Wyznacza typ uywanego testu
#
sub wczytajStudentowZalegajacych{
  my ($self)=@_;
  my $par=$self->{par};

  # Jeli jest, mergujemy informacj o zalegociach
  my $studenciZalegajacy="zaleglosci.csv";
  my $masterRecord={nazwisko => 1, imie => 1, numerOsoby => 1, czyZalega => 1};
  if(-r $studenciZalegajacy && $self->{caller} eq 'robFormularzeTestu'){
    $self->{raport}->wymaluj("Czytam informacj o studentach zalegajacych w paceniu czesnego\n");
    $par->{studentRecordBase}->mergeData($studenciZalegajacy,'','student',1,$masterRecord);
  }else{
#    $self->{raport}->wymaluj("Nie znaleziono informacji o studentach zalegajacych w paceniu czesnego\n");
  }
}

############################## sprawdzPoprawnoscDanych ######################
#
#
sub sprawdzPoprawnoscDanych{
  my ($self)=@_;
  my $par=$self->{par};

  # Jeli parametr data lub termin (ten drugi to zaszo) nie zosta wczytany, to znaczy, e
  # mamy do czynienia z edycjami, a w tym podejciu podjto
  # jedynie prb generowania testu bezedycyjnego (bez pliku *.conf),
  # ktry nie ma by generowany
  if(!($par->{data} || $par->{termin})){
    $self->{raport}->wymaluj("Plik conf nie podaje terminu.\n Analizuje jedynie edycje w oparciu o pliki *.conf\n");
    return;
  }
  if( defined($par->{termin}) ){
    $self->{raport}->wymaluj("Parametr termin jest zaszoci. Zamiast niego uyj parametru data\n");
#    return;
  }
  if(!$par->{nazwaBazowaTestu}){
     $self->{raport}->zakoncz("\nNie ustawiono pola \"nazwaBazowaTestu\" w pliku conf\n\n");
  };
  my $who=ref($self);
  if($who eq 'robFormularzeOdpowiedzi' && !$par->{TypEgzaminu} && (!$par->{wariant} eq 'UJ') && !$par->{midtermSystem}){
    my $komunikat=<<END

Katalog studenci zawiera wstpn list egzaminacyjn, bo
w czci nagwkowej pliku parametr o nazwie TypEgzaminu nie
ma przypisanej wartoci.
   Generowanie formularzy odpowiedzi naley przeprowadza jedynie
w oparciu o list, ktra ma ten parametr wypeniony. Takie listy
dziekanat dostarcza nie wczeniej ni tydzie przed egzaminem.
Wczeniej dostarczona lista moe by nieaktualna.

END
    ;
    $self->{raport}->wymalujError($komunikat);
  }
}

############################## inicjalizujParametry ######################
#
#
sub inicjalizujParametry{
  my ($self)=@_;
  my $par=$self->{par};


  if(!$par->{iloscZapasowychExamId}){
    $par->{iloscZapasowychExamId}=1+int(0.025*$self->{iloscStudentow}+0.5);
  }
# Chyba niepotrzebne
#  $par->{iloscZapasowychExamId}=$par->{iloscZapasowychExamId}<2 ? 2 : $par->{iloscZapasowychExamId};
  $par->{ilosc_okienek_kodu}=$par->{ilosc_okienek_kodu} ? $par->{ilosc_okienek_kodu} : 9;
  $par->{ostatniZapasowyExamId} = 2**$par->{ilosc_okienek_kodu}-1;
  $par->{pierwszyZapasowyExamId}=$par->{ostatniZapasowyExamId}-$par->{iloscZapasowychExamId}+1;

}

################################
#
# Funkcja przygotowuje hasz ze studentami wedug examId
#
sub prepareStudentHashByExamId{
  my ($self,$students_file)=@_;

  $self->{iloscStudentow}=0;
  $self->{studentListByExamId}={};
  while(my($studKey,$stud)=each(%{$self->{studentRecordBase}})){
      my ($lp,$nazwisko,$imie,$indeks)=($stud->liczbaPorzadkowa,$stud->nazwisko,$stud->imie,$stud->indeks);
      # $formattedExamId suy jako klucz w haszu i uwzgldnia rwnie numer edycji
      my $formattedExamId=fill_to_left($stud->{examId},4);

      $stud->{examId}=$formattedExamId;
      $stud->{testEdition}=$self->{referencjaZadania}->{numerEdycji};

      #Sprawdzam czy nie powtorzyl sie numer studenta
      if($self->{studentListByExamId}->{$formattedExamId}){
        $self->{raport}->zakoncz("Duplikat numeru studenta. Numer: $formattedExamId\nProgram zakonczony\n" .
          "Sprawdz plik $students_file\n");
      }
      $self->{raport}->wypisz("Student $studKey has no exam Id\n") if($stud->{examId} !~ /^\s*\d+\s*$/);
      #Dodajemy do listy
      $self->{studentListByExamId}->{$formattedExamId}=$stud;
      print "Adding $studKey with examId=$stud->{examId}=\n" if($main::opt_v);
      $self->{iloscStudentow}++;
  }
  print "Lacznie znaleziono $self->{iloscStudentow} studentw\n";
}

############################## init ######################
#
#  Inicjalizuje zmienne i tablice,
#  czyta pliki konfiguracyjne i plik ze studentami
#
sub init{
  my ($self,$plikKonfiguracyjnyEdycji)=@_;

  my $par={};
  $par=$self->{par} if(defined($self->{par}));

  $self->utworzKatalogi();
  $self->inicjalizujParametry();
  my $uzywanyTest=$self->wyznaczUzywanyTest();
  my $sito=$self->wczytaj_sito($par);

  my $studentRB=$self->{studentRecordBase}=$par->{studentRecordBase}=new StudentRecordBase;
  $studentRB->wczytajStudentow($par,$self->{raport},'studenci',$self->{par}->{edycja});

  $self->sprawdzPoprawnoscDanych();

  # Przypisujemy studentom numery examId wg ktrych s identyfikowani na egzaminie
  #
  my $maxExamId=$studentRB->assignExamId($par,$self->{raport},$self->{referencjaZadania}->{oknoZadania});
#  my $maxExamId=$studentRB->assignExamId($par);

  # Przygotowujemy hasz ze studentami z examId jako kluczami
print "Przygotowuj hasz ze studentami z examId jako kluczami\n";
  $self->prepareStudentHashByExamId($students_file);

  $self->wczytajStudentowZalegajacych();

  return ($uzywanyTest,$par,$sito,$self->{iloscStudentow},$self->{studentListByExamId},$maxExamId + 1);
}

############################## sprawdzIstnienieEdycji ######################
#

sub sprawdzIstnienieEdycji{
  my ($self)=@_;
  my $saEdycje=0;
  foreach $file (@_){
    $saEdycje=1 if($file =~ /^[\w.]+-\d+\.conf$/);
  }
  return $saEdycje;
}

############################## wykonajPoczatek ######################
#

sub wykonajPoczatek{
  my ($self)=@_;

  # Lista wszystkich studentw czytana w celach kontrolnych
  student::wczytajListeOsob();

  my $parloc;
  $parloc=$self->{par} if defined($self->{par});

  if(-r 'conf'){
    $self->{'par'}=$parloc=readConfiguration('.',1,$parloc);
  }

  my $class=ref($self);

  $self->{raport}=new raportOkienkowy("raport.txt",$self->{oknoRaportu},$self->{mainWindow});

  $egzaminator::biezacyRaport=$self->{raport};
  $self->{raport}->wypisz("Uruchomiono: $class\nHaso: $self->{'par'}->{'pwd'}\n");

  if(!defined($parloc)){
    $self->{raport}->zakoncz("Nie znaleziono pliku konfiguracyjnego conf\n");
  }
  $self->{'par'}->{nazwaBazowaTestuBezEdycji}=$self->{'par'}->{nazwaBazowaTestu};
  while($self->{'par'}->{nazwaBazowaTestuBezEdycji} =~ /^([^-]+)-\d+$/ ){
    $self->{'par'}->{nazwaBazowaTestuBezEdycji}=$1;
  }
# print "Set nazwaBazowaTestuBezEdycji=$self->{'par'}->{nazwaBazowaTestuBezEdycji}\n";
}

############################## wykonajWlasciweZadanie ######################
#

sub wykonajWlasciweZadanie{
  my ($self)=@_;

  opendir (DIRHANDLE, '.');
  my @filelist = readdir (DIRHANDLE);
  closedir(DIRHANDLE);

  my $saEdycje=$self->sprawdzIstnienieEdycji(@filelist);

  if(!$saEdycje){
    $self->ustawEdycje('');
    $self->robLubOcenEdycjeTestu('');
  }else{
    foreach $file (@filelist){
      if($file =~ /^([\w.-]+)-(\d\d?)\.conf$/){
        if($main::opt_e eq $2 || !$main::opt_e){
          $self->ustawEdycje($file);
          $self->robLubOcenEdycjeTestu($file);
        };
      }elsif($file =~ /^([\w.-]+)\.conf$/){
        if($main::opt_e eq '0' || !$main::opt_e){
          $self->ustawEdycje($file);
          $self->robLubOcenEdycjeTestu($file);
        }
      }
    }
  }
}

############################## wykonajKoniec ######################
#

sub wykonajKoniec{
  my ($self)=@_;

  # Dodane 9-05-2003 jako prba poprawienia doklejania si kolejnych numerw edycji
  # Przywracamy pierwotn nazw bazow testu (bez edycji)
  $par->{nazwaBazowaTestu}=$par->{nazwaBazowaTestuBezEdycji};
  while($self->{'par'}->{nazwaBazowaTestu} =~ /^([^-]+)-\d+$/ ){
    $self->{'par'}->{nazwaBazowaTestu}=$1;
  }

  if($self->{raport}->{errorCounter}){
    $self->{raport}->wymaluj(' ');
    $self->{raport}->{textWidget}->insert('end',' ','errorSummary');
    $self->{raport}->{textWidget}->insert('end'," Wykonano, ale z bdami ",'error');
    $self->{raport}->{textWidget}->insert('end',' ','errorSummary');
    $self->{raport}->wymaluj("\n");
  }else{
    $self->{raport}->wymaluj(' ');
    $self->{raport}->{textWidget}->insert('end',' ','ok');
    $self->{raport}->wymaluj(" Wykonano \n");
  }
  $self->{raport}->zamknij_raport();
#  my $files="raporty/*$self->{caller}.raport.txt";
#  unlink <$files>;
#  mkdir('raporty',0660) if (!(-d 'raporty'));
#  move("*.raport.txt",'raporty');

  # Dodane z intencj powrotu do pierwotnego pliku konfiguracyjnego edycji,
  # po dodatkach wprowadzonych do par przy analizie edycji
  my $dir=pwd();
  if($self->{par}->{edycja} && -r 'conf'){
    $self->{par}=readConfiguration($dir,1,$self->{par});
  }
}

########################################################################

1;