################################
#
# klasa  abstrakcyjna printer
#
# klasa drukuje zadany plik w odpowiednim formacie
# okrelonym w klasach pochodnych

package printer;


################################
#
# Konstruktor
#

sub new{
  my $class = shift;
  my $callerRef = shift;
  my $self = {};
  bless($self,$class);
  $self->{callerRef}=$callerRef;
  return $self;
}

################################
#
# compileTeX
#
# metoda kompiluje podany plik jako plik TeXowy,
# oraz otwiera plik log skojarzony z plikiem texowym
# i sprawdza, czy nie ma w nim bdw typu LaTeX Error
#
sub compileTeX{
  my ($self, $filename)=@_;
#  `pdflatex --interaction=batchmode --src $filename`;
  my $command="\"$self->{callerRef}->{par}->{TexBin}pdflatex\" --interaction=batchmode --src $filename";
  print "Wykonuj $command\n";
  `$command`;
  my $logname=$filename;
  $logname =~ s/tex/log/;
  my $size = -s $logname;
  my $text;

  open(IN,"<$logname") || die("TeXExecutor: Failed to open file $logname\n");
  binmode(IN);
  read(IN,$text,$size);
  $text =~ s/\032/ /g;
  $text =~ s/\012//g;
  my $log="";
  if($text =~ /LaTeX Error/){
    $self->{callerRef}->{raport}->wymalujError("TeX sygnalizuje bdy - skompiluj rcznie plik $filename \n");
  }
  return $log;
}

################################
#
# metoda print
#

sub printFile{
  my $self=shift;
  $self->{callerRef}->{raport}->wymaluj("\nGeneruje $self->{printerType} dla $_[0]. To moze trwac kilka minut \n");
  $self->hardPrint(@_);
  $self->{callerRef}->{raport}->wymaluj("Wygenerowalem $self->{printerType} dla $_[0]. \n");
}

################################

1;