##################
#
# klasa student
#
#

package student;

@ISA = qw(Record);

use vars qw(@Fields $listaNazwisk);

use FindBin qw($Bin);
use lib "$Bin/utilities";
use StudentRecordBase;               # klasa StudentRecordBase
use studentWithIndex;
use egzaminator;
use utilities;

##################
#
# Zmienna klasowa Fields
#

@Fields=qw(liczbaPorzadkowa nazwisko imie indeks numerOsoby rokStudiow standard grupaCwiczeniowa grupaWykladowa terminEgzaminu nazwaPotoku punktyCwiczeniowe punktyEgzaminowe punktyEgzaminowePoprawkowe punktyIHS czyZalega);

##################
#
# Zmienna klasowa listaNazwisk wskazujaca hasz z lista osob
#

my $listaNazwisk={};
my $listaNumerowOsob={};
my $listaIndeksow={};

# Do zapamitania czy lista osb ju bya czytana
my $wczytanoListeOsob=0;
# Do przechowywania listy osb
my $listaOsob;


############################## wczytajListeOsob ######################
#
#  Metoda klasowa, ktra wczytuje liste osob
#  z pliku listaOsob.csv i generuje kontroln baz kluczy
#
sub wczytajListeOsob{

  # Jeli lista osb ju bya czytana, nie ma potrzeby czytania jej powtrnie
  return if($wczytanoListeOsob);

  my $class=shift;
  $listaOsob=new StudentRecordBase('studentWithIndex');
  my $parListyOsob={};


  my $plikListyOsob='listaOsob.csv';
  LISTA_OSOB:
  for (my $i=0;$i<4;$i++){
    if(-r $plikListyOsob){
      $RecordBase::warnOnFindingKeyRepetitions=0;
      $listaOsob->read($plikListyOsob,$parListyOsob,'studentWithIndex');
      $RecordBase::warnOnFindingKeyRepetitions=0;
      print "Uaktywniono odszukiwanie brakujcych numerw identyfikacyjnych\n";
      print "na podstawie pliku $plikListyOsob\n";
      $wczytanoListeOsob=1;
      last LISTA_OSOB;
    }
    ## Szukamy w katalogu wyej
    $plikListyOsob="../$plikListyOsob";
  };

  # Jeli nie udao si w katalogu lokalnym, prbuj zamiast listy osb wczyta list
  # studentw z katalogu studenci, co przydaje si przy doczaniu studentw
  # z egzaminu zerowego, ktrzy nie maj zazwyczaj podanego numeru osoby
  if(!$wczytanoListeOsob){
    $RecordBase::warnOnFindingNewRecords=0;
    my $dir=pwd();
    opendir(DIR,'studenci');
    my @filelist=readdir(DIR);
    closedir(DIR);
    my $firstFile=1;
    foreach my $file (@filelist){
      my $plikListyOsob="studenci/$file";
      if($plikListyOsob =~ /.csv$/){
# print "Probuje czytac $file\n";
        $RecordBase::warnOnFindingKeyRepetitions=0;
        if($firstFile){
          $listaOsob->read($plikListyOsob,$parListyOsob,'studentWithIndex');
          $firstFile=0;
        }else{
          $listaOsob->merge($plikListyOsob,$parListyOsob,'studentWithIndex');
        }
        $RecordBase::warnOnFindingKeyRepetitions=0;
        print "Uaktywniono odszukiwanie brakujcych numerw identyfikacyjnych\n";
        print "Na podstawie zawartoci katalogu studenci\n";
        $wczytanoListeOsob=1;
      }
    }
    $RecordBase::warnOnFindingNewRecords=1;
  }


  if(!$wczytanoListeOsob){
#   Ta wersja wykomentowana, bo na tym etapie z jakiego powodu
#   zmienna $egzaminator::biezacyRaport jeszcze nie jest okrelona
#    $egzaminator::biezacyRaport->wymaluj("Odszukiwanie brakujcych numerw identyfikacyjnych nieaktywne \n");
    print "Odszukiwanie brakujcych numerw identyfikacyjnych nieaktywne \n";
  }

  my @names=keys (%{$listaOsob});
  foreach my $name (@names){
    my $student=$listaOsob->{$name};
#print "Analyzing $student for $name\n";
    my $nazw=$student->nazwisko;
    my $imie=$student->imie;
    my $indeks= $student->indeks;
    my $numerOsoby=$student->{numerOsoby};
    if(!defined($listaNumerowOsob->{$numerOsoby})){
      $listaNumerowOsob->{$numerOsoby}={'nazwisko' => $nazw, 'imie'=> $imie};
      $listaNumerowOsob->{$numerOsoby}->{'indeks'}=$indeks if($indeks !~ /^\s*WK/);
    }else{
      print "powtorzony numer osoby: $numerOsoby ($nazw, $imie, $indeks)\n" if($indeks !~ /^\s*WK/ && $main::opt_v);
    }
    if(!defined($listaIndeksow->{$indeks})){
      $listaIndeksow->{$indeks}={'nazwisko' => $nazw, 'imie'=> $imie, 'numerOsoby' => $numerOsoby };
    }else{
      print "powtorzony numer indeksu: $indeks\n"if($main::opt_v);
    }
    my $shortKey="$student->{'nazwisko'}+$student->{'imie'}";
    if(!defined($listaNazwisk->{$shortKey})){
      $listaNazwisk->{$shortKey}={};
    };
    my $indeks= $student->indeks();
    my $nr=$student->numerOsoby();
#print "Added  $shortKey, $indeks, $student, $nr\n";
    $listaNazwisk->{$shortKey}->{$indeks}=$student;
  }
  print "Na liscie osob znaleziono $#names studentow\n";
}

##################
#
# Konstruktor
#

sub new{
  my $class = shift;
  if ( ref($_[0])){
# print "Sending to new in Record with @_ ($r)\n";
    return $class->SUPER::new(@_);
  }else{
    my $self = {};
    my $imie=shift;
    my $nazwisko=shift;
    my $indeks=shift;
    bless($self,$class);
    $self->addFieldsFromList('imie,nazwisko,indeks');
    $self->imie($imie);
    $self->nazwisko($nazwisko);
    $self->indeks($indeks);
    return $self;
  }
}

my %nonidentifiedPersons=();

##################
#
# sub key
# Wersja uzupeniajca brakujcy numerOsoby na podstawie danych
# wczytanych z pliku listaOsob.csv
#

sub key{
  my ($self)=@_;
  my $nazwiskoLoc=$self->nazwisko;
  my $imieLoc=$self->imie;
  my $numerOsobyLoc=$self->numerOsoby;
  my $keyLoc='null';
  my $indeksLoc=$self->indeks;
  my $found=1;
  # W przypadku WSB do klucza wchodzi unikalny numer osoby, ktry czsto jest pomijany
  # w plikach innych ni oficjalne protokoy, bo mao znany, Dlatego prbujemy go odtworzy

  if($wczytanoListeOsob && $starterEgzaminatora::wariant eq 'WSB'){

    # Jeli nie podano numeru osoby, sprbujemy go odtworzy z listy osb
    if( $numerOsobyLoc !~ /\d/ ){
      my $shortKey="$self->{'nazwisko'}+$self->{'imie'}";
      my @indeksyDlaNazwiska=keys(%{$listaNazwisk->{$shortKey}});
      my $iloscIndeksowDlaNazwiska =1+$#indeksyDlaNazwiska;
      if($iloscIndeksowDlaNazwiska == 1){
        $numerOsobyLoc=$listaNazwisk->{$shortKey}->{$indeksyDlaNazwiska[0]}->{numerOsoby};
      }elsif($iloscIndeksowDlaNazwiska > 1){
        $numerOsobyLoc=$listaNazwisk->{$shortKey}->{$indeksLoc}->{numerOsoby};
        if($numerOsobyLoc){
        }else{
          $found=0;
        }
      }else{
        $found=0;
      }
    # Jeli podano numer osoby sprawdzamy jedynie czy zgadza si nazwisko i imi i ewentualnie ostrzegamy
    }else{
      if(!$listaNumerowOsob->{$numerOsobyLoc}){
#        Wykomentowane, bo jest problem z uaktualnianiem listy osb, a przy egzaminie poprawkowym
#        przy czytaniu punktacji z cwiczen nie wystarcza tez polegac na protokole, bo na liscie cwiczen
#        sa osoby, ktore nie zdaja egzaminu poprawkowego
#        $egzaminator::biezacyRaport->wymaluj("Osoby $nazwiskoLoc, $imieLoc o numerze $numerOsobyLoc brak w bazie\n");
      }else{
        my $nazwisko=$listaNumerowOsob->{$numerOsobyLoc}->{'nazwisko'};
        my $imie=$listaNumerowOsob->{$numerOsobyLoc}->{'imie'};
        if(!($nazwisko eq $nazwiskoLoc || $imie eq $imieLoc)){
          $egzaminator::biezacyRaport->wymalujError("Osoba $nazwiskoLoc, $imieLoc o numerze $numerOsobyLoc \nfiguruje w bazie jako $nazwisko, $imie\n");
        }
        # Ufamy bardziej danym z bazy, daje to wiksz jednolito
        $nazwiskoLoc=$nazwisko;
        $imieLoc=$imie;
      }
    }
    if(!$found && $nazwiskoLoc ne 'test' && $imieLoc ne 'kontrolny' ){
      $keyLoc="$nazwiskoLoc+$imieLoc+$numerOsobyLoc";
      if(!defined($nonidentifiedPersons{$keyLoc})){
        $nonidentifiedPersons{$keyLoc}=1;
        $egzaminator::biezacyRaport->wymalujError("Niezidentyfikowana osoba: nazwisko=$nazwiskoLoc=, imie=$imieLoc=, indeks=$indeksLoc=\n");
      }
    }
  }elsif($numerOsobyLoc !~ /\d/){
    $numerOsobyLoc=$indeksLoc;
  }

  $keyLoc="$nazwiskoLoc+$imieLoc+$numerOsobyLoc";
  return $keyLoc;
}

##################
#
# sub czyZalega
# miao uatwi sprawdzanie czy student zalega od razu
# na podstawie pliku listaOsob.csv, ale nie chce dziaa
#

sub czyZalegaRemove{
  my ($self)=@_;
    my $s=$self;
    bless($s,'studentWithIndex');
    return ($listaOsob{$s->key()}->{czyZalega} eq 'T');
}

##################
#
# sub keyOld
#
#

sub keyOldOld{
  my ($self)=@_;
#    return $self->nazwisko.'+'.$self->imie.'+'.$self->indeks;
    return $self->nazwisko.'+'.$self->imie.'+'.$self->numerOsoby;
}

##################
#
# sub fields
#
#

sub fields{
  my ($self)=@_;
  return \@Fields;
}

##################
#
# sub length
#
#

sub length{
  my ($self)=@_;
  return 1+$#Fields;
}

################################
#
# Dolacza do pustych pol rekordu dane z drugiego rekordu
# Zglasza bd, jesli niepuste dane sa rozne
# UWAGA: wersja dla klasy student metody z klasy Record
# potrzebna ze wzgldu na szczeglne mergowanie punktw wiczeniowych
#
sub merge{
  my ($self,$merged_record) = @_;
  my $length=$self->length;
  for(my $i=0;$i<$length;$i++){
    my $field=$self->{fieldNames}->[$i];
# print "Merging field=$field\n";
# $egzaminator::biezacyRaport->wymaluj("Merging field=$field\n");
    my $merged_record_value=$merged_record->{$field};
    my $key=$self->key;

    # Korekta liczb floating point: przecinek na kropk, usunicie ewentualnego znaku procenta
# print   "    adding for $key: $field=$merged_record_value=\n" if($field eq 'punktyCwiczeniowe');
    $merged_record_value =~ s/^\s*(\d*),(\d+)\s*$/$1.$2/;
    $merged_record_value =~ s/^\s*(\d*)%\s*$/$1/;
# print   "    adding for $key: $field=$merged_record_value=\n" if($field eq 'punktyCwiczeniowe');
    if($field eq 'punktyCwiczeniowe'){
       # ostrzegamy, jeli punkty z wicze si powtarzaj
       if($self->{$field} =~ /\d/ && $merged_record_value =~/\d/ && $merged_record_value != $self->{$field}){
         print "UWAGA $key: Podwjna punktacja z wicze: $self->{$field} i $merged_record_value\n";
         $egzaminator::biezacyRaport->wymaluj("UWAGA $key: Podwjna punktacja z wicze: $self->{$field} i $merged_record_value\nPrzyjumj maksimum\n");
         # Ale przyjmujemy jako warto maksimum
         $self->{$field}=( $merged_record_value>$self->{$field} ? $merged_record_value : $self->{$field} );
       }else{
         if(defined($merged_record_value) && $merged_record_value =~ /\d/){
            $self->{$field}=$merged_record_value;
         }
       }
    }else{
      if(defined($self->{$field}) && $self->{$field} ne "" ){
         if(defined($merged_record_value) && !($merged_record_value eq "" || $merged_record_value==0) ){
           if(($self->{$field} ne $merged_record_value) && $field ne 'liczbaPorzadkowa'){
              print "Merging field $field for key =$key= with unequal nontrivial values: $self->{$field} and $merged_record_value\n";
              $error=1;
           }
         }
      }else{
         if(defined($merged_record_value) && $merged_record_value ne ''){
            $self->{$field}=$merged_record_value;
         }
      }
    }
  }
}

################################

1;