###############################
#
# Klasa wystawiaczOcen
#

package wystawiaczOcen;

use strict;
use vars qw($Bin $pokazZaliczenia);
use FindBin qw($Bin);
use utilities;
use textUtil;
use polChar;
use StudentRecordBase;
use grader;
use graderKR;
use graderMTC;
use graderMTC2;
use student;
use raport;                      # klasa do robienia raportu.
use oceniaczProjektow;
use korelacje;

$pokazZaliczenia=0;    # Jeli w pliku z ocenami z wicze pojawi si
                       # pozycja zaliczenie, zostan one wywietlone
                       # w pliku HTML

####################################################
#
# opisy
#
sub ustawOpisy{
  my ($self)=@_;

  $self->{naglowekOpisuZadania}="Wystawienie ocen";
  $self->{tekstOpisuZadania}=<<END
  Do wystawienia ostatecznych ocen obok punktacji
z egzaminu potrzebna jest te punktacja z wicze.
Odpowiednie pliki przygotowane przez asystentw
naley umieci w katalogu gwnym, nadajc im
nazw postaci
   nazwaBazowa-cwiczenia-nazwiskoAsystenta.csv
HTMLowe pliki z wynikami umieszczone zostan w katalogu
"oceny"
END
  ;
  if($self->{par}->{wariant} eq 'WSB'){
    $self->{tekstOpisuZadania}.=<<END
By przygotowa protokoy w Excelu naley
zaznaczy opcj "generuj protokoy w Excelu".
Pliki z protokoami zostan umieszczone w katalogu
"protokoly".
END
  ;
    $self->{naglowekOpisuZadania}.=" i przygotowanie protokow";

  }
  $self->{dopuscEdycje}=0;
}

################################
#
# Konstruktor
#
sub new{
  my $class = shift;
  my $self = {};
  bless($self,$class);

  $self->ustawOpisy();
  return $self;
}

####################################################
#   Inicjalizacja zmiennych
#
sub init{
  my ($self)=@_;

  # Zamiast czyta plik konfiguracyjny conf, przejmujemy go od egzekutora
  my $par;
   if(defined($self->{par})){
    $par=$self->{par};
  }elsif(-r 'conf'){
    $par=$self->{par}=readConfiguration('.',4,'','',1);
  }else{
    $self->{raport}->zakoncz("wystawiaczOcen: brak konfiguracji\n");
  }

  if($self->{par}->{nazwaBazowaTestu} =~ /^([-\w]+)\.([-\w]+)$/){
    $self->{par}->{nazwaBazowaKursu}=$self->{par}->{nazwaBazowaTestu};
    $self->{par}->{nazwaSkroconaTestu}=$2;
  }else{
    $self->{par}->{nazwaBazowaKursu}=$self->{par}->{nazwaBazowaTestu};
    $self->{par}->{nazwaSkroconaTestu}='egzamin';
  }
  $self->{baseName}=$par->{nazwaBazowaKursu};

  # Korekta zaszoci
  if(defined($self->{par}->{midtermSystem})){
    $self->{par}->{typZajec}='K+R';
  }


  my $class=ref($self);

  # Przygotowujemy raport
  $self->{raport}=new raportOkienkowy("raport.txt",$self->{oknoRaportu},$self->{mainWindow});
  $egzaminator::biezacyRaport=$self->{raport};
  $self->{raport}->wypisz("Uruchomiono: $class\nHaso: $self->{'par'}->{'pwd'}\n");

  if(!defined($par)){
      $self->{raport}->zakoncz("Nie znaleziono pliku konfiguracyjnego conf\n");
  }


  # Analiza linii komend

  package main;
  use Getopt::Long;
  my @optl=("h|help!","p|protokol!","d|details!","b|bez_poprawk!","v|verbose!","w|tylko_wyklad!","r|rozpisz_egzaminy!","c|listaCwiczeniowa!");
  my $ret = GetOptions (@optl);

  package wystawiaczOcen;
  if(!$par->{nazwaBazowaTestu} || $main::opt_h){
    print <<END
Sposob uzycia:\nwystawOceny [-p -d -w -v -r -c]
   gdzie:
     -p przygotuj kocowe protokoly w formacie *.xls
     -d buduj linki do szczegowych wynikw indywidualnych studentw
END
    ;
    exit(0);
  };

  # W celach kontrolnych czytamy
  # list osb z numerami osb
  # Pozwala ona czasami zidentyfikowa studenta przy
  # brakujcych danych
  student::wczytajListeOsob();

  $self->{limitPunktowCwiczeniowych}=(defined($par->{'max_cwicz'}) ? $par->{'max_cwicz'} : 100);
  print "Grny limit punktw dla wicze wynosi $self->{limitPunktowCwiczeniowych}\n" if($main::opt_v);


  # Nanosimy informacj czy wykad jest z wiczeniami
  $self->{wyklad_i_cwiczenia}=($main::opt_w?0:1);

  $self->{par}->{przesunieciePunktacji}=0 if(!defined($self->{par}->{przesunieciePunktacji}) );
  $self->{par}->{mnoznikPunktacji}=1 if(!defined($self->{par}->{mnoznikPunktacji}) );


  print "SysOp=$par->{sysop}\n" if($main::opt_v);
  my $wd=pwd();
  print "wd=$wd\n" if($main::opt_v);


  # Okrelamy nazwy i szablony nazw  plikw
  $self->{szablonPlikuCwiczeniaWyniki} = "\[-.\]cwiczenia\[-.\]\\w+\\.csv\$";
  $self->{szablonPlikuEgzaminWyniki} = "^\[-.\\w\]+\[-.\]wyniki\\.csv\$";
  $self->{szablonPlikuMidtermWyniki} = "^\[-.\\w\]+\[-.\]midterm\\d-wyniki\\.csv\$";

  if($self->{par}->{rozdzielonePliki}){
    mkdir('protokoly',0660) if (!(-d 'protokoly'));
#    mkdir('raporty',0660) if (!(-d 'raporty'));
    mkdir('oceny',0660) if (!(-d 'oceny'));
  }

}


##########################################
#
# Funkcja pomocnicza dodajca prowadzce zera przed liczb
#
sub addLeadingZeros{
  my ($arg)=@_;
  if($arg =~ /^\s*(\d+)*(.*)$/){
    my ($number,$remainder)=($1,$2);
    my $l=length($number);
    my $i=9 - $l;
    return substr("000000000",0,$i) . $number . $remainder;
  }else{
    return $arg;
  }
}

##########################################
# Dolacz dane z list egzaminacyjnych i wyznacz punkty za egazmin
# i egzamin poprawkowy
#
sub dolaczPunktyCwiczenioweZPliku{
  my ($self,$file,$studentRB,$parbis,$masterRecord)=@_;
  if($file =~ $self->{szablonPlikuCwiczeniaWyniki}){
    $self->{raport}->wymaluj( "====> Dodaj punkty wiczeniowe z pliku $file\n");
    my $konwerter={};
    if($file =~ /cwiczenia-sem(\d).csv$/){
      $konwerter->{punktyCwiczeniowe}="punktyCwiczeniowe$1";
      $konwerter->{zaliczenie}="zaliczenie$1";
      $studentRB->merge("$file",$parbis,'student',$masterRecord,'',$konwerter);
    }else{
      $studentRB->merge("$file",$parbis,'student',$masterRecord);
    }
  }
}

##########################################
# Dolacz dane z list egzaminacyjnych i wyznacz punkty za egazmin
# i egzamin poprawkowy
#
sub dolaczPunktyCwiczeniowe{
  my ($self,$studentRB,$basename,$parbis)=@_;

  my $masterRecord={nazwisko => 1, imie => 1, numerOsoby => 1, zaliczenie => 1, adresStrony => 1, punktyCwiczeniowe => 1, punktyKonwersatorium => 1, knieob => 1, rnieob => 1, pHTML => 1, pSSI => 1, pCSS => 1, pJS => 1, pXML => 1, pWML => 1, pForms => 1, pCGI => 1, pMulti => 1, pEst => 1, pAktywnosc => 1, akceptacjaPunktowCwiczeniowych => 1, zaliczonyKonkurs => 1};

  # Najpierw dodajemy punkty wiczeniowe z biecego katalogu (zaszo)
  opendir(DIR,".");
  my @filelist=readdir(DIR);
  closedir(DIR);

  $RecordBase::warnOnFindingNewRecords=0;
  foreach my $file (@filelist){
    $self->dolaczPunktyCwiczenioweZPliku($file,$studentRB,$parbis,$masterRecord);
#    if($file =~ $self->{szablonPlikuCwiczeniaWyniki}){
#      $self->{raport}->wymaluj( "====> Dodaj punkty wiczeniowe z pliku $file\n");
#      $studentRB->merge("$file",$parbis,'student',$masterRecord);
#    }
  }

  # Nastpnie dodajemy punkty wiczeniowe z nadkatalogu
  opendir(DIR,"..");
  my @filelist=readdir(DIR);
  closedir(DIR);

#  $RecordBase::warnOnFindingNewRecords=0;
  foreach my $file (@filelist){
    $self->dolaczPunktyCwiczenioweZPliku("../$file",$studentRB,$parbis,$masterRecord);
#    if($file =~ $self->{szablonPlikuCwiczeniaWyniki}){
#      $self->{raport}->wymaluj( "====> Dodaj punkty wiczeniowe z pliku ../$file\n");
#      $studentRB->merge("../$file",$parbis,'student',$masterRecord);
#    }
  }
  $RecordBase::warnOnFindingNewRecords=1;

}

##########################################
# Dolacz dane z list egzaminacyjnych i wyznacz punkty za egzamin
# i egzamin poprawkowy
#
sub dolaczPunktyMidterm{
  my ($self,$studentRB,$parbis)=@_;

  my $fieldsToRemove={indeks => 1};
  my $katalog="..";
  opendir(DIR,$katalog);
  my @filelist=readdir(DIR);
  closedir(DIR);
  # doczamy dane wycznie z plikw, ktre pasuj do wzorca
  foreach my $file (@filelist){
    if($file =~ $self->{szablonPlikuMidtermWyniki}){
      $file = $katalog."/".$file;
      $self->{raport}->wymaluj( "====> Dodaj punkty midterm z pliku $file\n");
      $RecordBase::warnOnFindingNewRecords=0;
      my $konwerter={};
      if($file =~ /midterm(\d)-wyniki.csv$/){
        $konwerter->{punktyEgzaminoweBezwzgledne}="punktyEgzaminoweBezwzgledne$1";
        $studentRB->merge("$file",$parbis,'student','',$fieldsToRemove,$konwerter);
      }
#      $studentRB->merge("$file",$parbis,'student','',$fieldsToRemove);
      $RecordBase::warnOnFindingNewRecords=1;
    }
  }
}

##########################################
# Dolacz dane z list egzaminacyjnych i wyznacz punkty za egzamin
# i egzamin poprawkowy - stara wersja, nowa rozbita jest na
# dwie metody poniej
#
sub dolaczPunktyEgzaminoweOld{
  my ($self,$studentRB,$parbis)=@_;

  my $fieldsToRemove={indeks => 1};
  opendir(DIR,".");
  my @filelist=readdir(DIR);
  closedir(DIR);
  # doczamy dane wycznie z plikw, ktre pasuj do wzorca
  foreach my $file (@filelist){
    if($file =~ $self->{szablonPlikuEgzaminWyniki}){
      $self->{raport}->wymaluj( "====> Dodaj punkty egzaminowe z pliku $file\n");
      $RecordBase::warnOnFindingNewRecords=0;
      $studentRB->merge("$file",$parbis,'student','',$fieldsToRemove);
      $RecordBase::warnOnFindingNewRecords=1;
    }
  }
}

##########################################
# Dolacz dane z list egzaminacyjnych i wyznacz punkty za egzamin
# i egzamin poprawkowy
#
sub dolaczPunktyEgzaminoweZ_Katalogu{
  my ($self,$studentRB,$parbis,$katalog)=@_;

  my $fieldsToRemove={indeks => 1};
  opendir(DIR,$katalog);
  my @filelist=readdir(DIR);
  closedir(DIR);
  # doczamy dane wycznie z plikw, ktre pasuj do wzorca
  foreach my $file (@filelist){
    if($file =~ $self->{szablonPlikuEgzaminWyniki}){
      $file = $katalog."/".$file;
      $self->{raport}->wymaluj( "====> Dodaj punkty egzaminowe z pliku $file\n");
      $RecordBase::warnOnFindingNewRecords=0;
      $studentRB->merge("$file",$parbis,'student','',$fieldsToRemove);
      $RecordBase::warnOnFindingNewRecords=1;
    }
  }
}

##########################################
# Dolacz dane z list egzaminacyjnych i wyznacz punkty za egzamin
# i egzamin poprawkowy
#
sub dolaczPunktyEgzaminowe{
  my ($self,$studentRB,$parbis)=@_;

  # Jeli by egzamin zerowy doczamy najpierw wyniki egzaminu zerowego
  if($self->{par}->{dolaczWynikiTerminuZerowego}){
    if(-d "../zerowy"){
      $self->dolaczPunktyEgzaminoweZ_Katalogu($studentRB,$parbis,"../zerowy");
    }else{
      $self->{raport}->wymaluj( "Nie mog wczyta wynikw terminu zerowego,\n bo brak katalogu zerowy!!\n");
    }
  }
  # A nastpnie wyniki egzaminu waciwego
  $self->dolaczPunktyEgzaminoweZ_Katalogu($studentRB,$parbis,".");
}

##########################################
# Wylicz oceny
#
sub computeGrades{
  my ($self,$studentRB,$term)=@_;



  while(my($studKey,$studentRef)=each(%$studentRB)){

    if(lc($studentRef->{'numerProtokolu'}) eq 'ihs'){
       $studentRef->{'ihs'}=1;
    }

    my ($grade,$result,$grade_level,$punktyEgzaminowe,$punktyCwiczeniowe,$punktyRazemBezUwzglednieniaNieobecnosci);

    # Mamy dwie referencje do studenta.
    # Pierwsza ($studentRef) pokazuje na studenta z listy do protokou
    # Druga ($gradesStudentRef) pokazuje na rekord tego samego studenta
    # gdzie zgromadzono jego dane o punktach wiczeniowych i egzaminowych
    my $gradesStudentRef=$self->{studentRB}->{$studKey};

    # Najpierw analizujemy system konwersatorium-repetytorium
#    if($self->{par}->{midtermSystem}){
    if($self->{par}->{typZajec} eq 'K+R'){
# print "$studKey knieob=$gradesStudentRef->{'knieob'}= rnieob=$gradesStudentRef->{'rnieob'}=\n";

      ($grade,$result,$grade_level,$punktyRazemBezUwzglednieniaNieobecnosci)=
         $self->{graderKR}->wyznaczOcene(
           $gradesStudentRef->{'punktyCwiczeniowe'},
           $gradesStudentRef->{'punktyKonwersatorium'},
           $gradesStudentRef->{'midTerm1'},
           $gradesStudentRef->{'midTerm2'},
           $gradesStudentRef->{'midTerm3'},
           $gradesStudentRef->{'knieob'}+$gradesStudentRef->{'rnieob'}
         );
       # Trzeba jeszcze przerzuci do drugiej bazy
       $studentRef->{'punktyC'}=$gradesStudentRef->{'punktyCwiczeniowe'};
       $studentRef->{'punktyKonwersatorium'}=$gradesStudentRef->{'punktyKonwersatorium'};
       $studentRef->{'midTerm1'}=$gradesStudentRef->{'midTerm1'};
       $studentRef->{'midTerm2'}=$gradesStudentRef->{'midTerm2'};
       $studentRef->{'midTerm3'}=$gradesStudentRef->{'midTerm3'};
       $studentRef->{'knieob'}=$gradesStudentRef->{'knieob'};
       $studentRef->{'rnieob'}=$gradesStudentRef->{'rnieob'};
       $studentRef->{'punktyRazemBezUwzglednieniaNieobecnosci'}=$punktyRazemBezUwzglednieniaNieobecnosci;
    # Z kolei system wyklad z midtermami plus cwiczenia
    }elsif($self->{par}->{typZajec} eq 'MTW+C'){
      # print "$studKey $gradesStudentRef->{'midTerm1'} $gradesStudentRef->{'midTerm2'} $gradesStudentRef->{'midTerm3'}\n";
      ($grade,$result,$grade_level,$punktyRazemBezUwzglednieniaNieobecnosci)=
         $self->{graderMTC}->wyznaczOcene(
           $gradesStudentRef->{'punktyCwiczeniowe'},
           $gradesStudentRef->{'midTerm1'},
           $gradesStudentRef->{'midTerm2'},
           $gradesStudentRef->{'midTerm3'},
         );
       # Trzeba jeszcze przerzuci do drugiej bazy
       $studentRef->{'punktyC'}=$gradesStudentRef->{'punktyCwiczeniowe'};
       $studentRef->{'zaliczenie'}=$gradesStudentRef->{'zaliczenie'};
       $studentRef->{'midTerm1'}=$gradesStudentRef->{'midTerm1'};
       $studentRef->{'midTerm2'}=$gradesStudentRef->{'midTerm2'};
       $studentRef->{'midTerm3'}=$gradesStudentRef->{'midTerm3'};
       $studentRef->{'punktyRazemBezUwzglednieniaNieobecnosci'}=$punktyRazemBezUwzglednieniaNieobecnosci;
    # Z kolei system wyklad z midtermami plus cwiczenia dwusemestralne
    }elsif($self->{par}->{typZajec} eq 'MTW+C2'){
      # print "$studKey $gradesStudentRef->{'midTerm1'} $gradesStudentRef->{'midTerm2'} $gradesStudentRef->{'midTerm3'}\n";
      ($grade,$result,$grade_level,$punktyRazemBezUwzglednieniaNieobecnosci)=
         $self->{graderMTC2}->wyznaczOcene(
           $gradesStudentRef->{'punktyCwiczeniowe1'},
           $gradesStudentRef->{'punktyCwiczeniowe2'},
           $gradesStudentRef->{'midTerm1'},
           $gradesStudentRef->{'midTerm2'},
           $gradesStudentRef->{'midTerm3'},
         );
       # Trzeba jeszcze przerzuci do drugiej bazy
       $studentRef->{'punktyC1'}=$gradesStudentRef->{'punktyCwiczeniowe1'};
       $studentRef->{'punktyC2'}=$gradesStudentRef->{'punktyCwiczeniowe2'};
       $studentRef->{'zaliczenie1'}=$gradesStudentRef->{'zaliczenie1'};
       $studentRef->{'zaliczenie2'}=$gradesStudentRef->{'zaliczenie2'};
       $studentRef->{'midTerm1'}=$gradesStudentRef->{'midTerm1'};
       $studentRef->{'midTerm2'}=$gradesStudentRef->{'midTerm2'};
       $studentRef->{'midTerm3'}=$gradesStudentRef->{'midTerm3'};
       $studentRef->{'punktyRazemBezUwzglednieniaNieobecnosci'}=$punktyRazemBezUwzglednieniaNieobecnosci;
    # A nastpnie system bez midtermw
    }else{
      $punktyEgzaminowe=$gradesStudentRef->{"punktyEgzaminowe-$term"};
      if( (!$punktyEgzaminowe || $punktyEgzaminowe eq 'nieobecny') && $self->{par}->{dolaczWynikiTerminuZerowego} && ($gradesStudentRef->{"punktyEgzaminowe-zerowy"} =~ /\d/) ){
         $punktyEgzaminowe=$gradesStudentRef->{"punktyEgzaminowe-zerowy"};
         $studentRef->{"komentarz"}.=" termin zerowy";
      }

      # przeliczamy punkty, pod warunkiem, e jest to rzeczywicie liczba,
      # t.zn pomijamy nieobecnych
      if($punktyEgzaminowe =~ /^\s*\d*\.?\d*\s*$/){
        $punktyEgzaminowe=
                 (
                   $punktyEgzaminowe
                   -
                   $self->{par}->{przesunieciePunktacji}
                 )
                 *
                 $self->{par}->{mnoznikPunktacji};
        # Nastpnie zaokrglamy
        $punktyEgzaminowe=int(0.5+$punktyEgzaminowe);
      }elsif($punktyEgzaminowe =~ /nieobecny/){
        $punktyEgzaminowe='-';
        $studentRef->{'nieobecny'}='nieobecny';
      }elsif($punktyEgzaminowe =~ /\*/){
        $punktyEgzaminowe="0";
        $studentRef->{'brakNrTestu'}=1;
      }else{
        $punktyEgzaminowe='#';
      }

      # Zapamitujemy posta bezwzgldn punktw egzaminowych
      $studentRef->{'punktyEgzaminoweBezwzgledne'}=$gradesStudentRef->{'punktyEgzaminoweBezwzgledne'};

      $punktyCwiczeniowe=$gradesStudentRef->{'punktyCwiczeniowe'};
      $punktyCwiczeniowe="-" if ($punktyCwiczeniowe !~ /\d/);

      # Jeli student uczestniczy w konkursie, jego punkty egzaminowe to maksimum z punktw egzaminowych
      # uzyskanych i punktw wiczeniowych
      if($self->{par}->{'uwzglednijKonkurs'} && $gradesStudentRef->{'zaliczonyKonkurs'} eq 'T' && $punktyEgzaminowe < $punktyCwiczeniowe){
        $punktyEgzaminowe = $punktyCwiczeniowe;
      }

      # Wyznaczamy ostateczn ocen stosujc stosowny grader
      # Jeli studenta nie byo na egzaminie zamiast oceny dostaje znak -
      # troszczy sie o to metoda wyznaczOcene w grader.pm
      if($studentRef->{'ihs'}){
        ($grade,$result,$grade_level)=
           $self->{graderIHS}->wyznaczOcene($punktyCwiczeniowe,$punktyEgzaminowe,$self->{par}->{wynikProcentowy},$self->{par}->{wagaEgzaminu});
      }else{
        ($grade,$result,$grade_level)=
           $self->{grader}->wyznaczOcene($punktyCwiczeniowe,$punktyEgzaminowe,$self->{par}->{wynikProcentowy},$self->{par}->{wagaEgzaminu});
      }
    }

    $studentRef->{'ocena'}=$grade;
    $studentRef->{'pkttot'}=$result;
    $studentRef->{'grade_level'}=$grade_level;

    # Przepisujemy punkty cwiczeniowe i egzaminowe z globalnej bazy
    $studentRef->{'punktyCwiczeniowe'}=$punktyCwiczeniowe;
    $studentRef->{'punktyEgzaminowe'}=$punktyEgzaminowe;

    # Odnotowywujemy czy byo podane zaliczenie z wicze (UJ)
    # i jeli tak, to przenosimy je do drugiej bazy
    if($self->{par}->{wariant} eq 'UJ'){
      if($gradesStudentRef->{'zaliczenie'}){
        $studentRef->{'zaliczenie'}=$gradesStudentRef->{'zaliczenie'};
        $pokazZaliczenia=1;
#print "Zapisuj oceny zaliczeniowe\n";
      }else{
        if($punktyCwiczeniowe>=90){
          $studentRef->{'zaliczenie'}='bdb';
        }elsif($punktyCwiczeniowe>=80){
          $studentRef->{'zaliczenie'}='+db';
        }elsif($punktyCwiczeniowe>=70){
          $studentRef->{'zaliczenie'}='db';
        }elsif($punktyCwiczeniowe>=60){
          $studentRef->{'zaliczenie'}='+dst';
        }elsif($punktyCwiczeniowe>=50){
          $studentRef->{'zaliczenie'}='dst';
        }else{
          $studentRef->{'zaliczenie'}='ndst';
        }
      }
    }

    print "Wyliczono ocene dla: $studKey,[poziom oceny=$grade_level] punkty=(cwicz=$studentRef->{'punktyCwiczeniowe'},egz=$studentRef->{'punktyEgzaminowe'}, result=$result, ocena=$grade \n" if $main::opt_v;
  };
}

##########################################
# Funkcja przygotowuje list poprawkow
#
sub przygotujListePoprawkowa{
  my ($self,$studentRB) = @_;


  print "Przygotowuj list poprawkow\n";
  my $studentPoprawkowaRB=new StudentRecordBase();

  while(my($studKey,$studentRef)=each(%$studentRB)){
    my $ocena=$studentRef->{'ocena'};
    if($ocena =~ /ndst/ || $ocena =~ '-' || $ocena =~ /^\s*$/){
      print "Dopisuje  $studentRef->{nazwisko} $studentRef->{imie} do listy poprawkowej\n" if($main::opt_v);
      $studentPoprawkowaRB->{$studKey}=$studentRef;
    }
  }
  return $studentPoprawkowaRB;
}

##########################################
#
# Funkcja pomocnicza zaokrglajca do dwch miejsc po przecinku
# Potrzebna przy statystykach
#
sub round{
  return int(100 * @_[0])/100;
}

##########################################
# Zrb statystyk
#
sub doStatistics{
  my ($self,$studentRB)=@_;

  my (@grade_counter) = (   0,   0,   0,   0,   0,   0,   0,  0,  0 );

  my ($i,$n1,$n2,$n3,$tot1,$tot2,$tot3,$tot);
  $i=$n1=$n2=$n3=$tot1=$tot2=$tot3=$tot=0;

  while(my($studKey,$studentRef)=each(%$studentRB)){
    if($studentRef->{'punktyCwiczeniowe'} =~ /\d/){$n1++;$tot1+=$studentRef->{'punktyCwiczeniowe'};};
    if($studentRef->{'punktyEgzaminowe'} =~ /\d/){$n2++;$tot2+=$studentRef->{'punktyEgzaminowe'};};
    if($studentRef->{'pkttot'} =~ /\d/){$n3++;$tot3+=$studentRef->{'pkttot'};};
    $grade_counter[$studentRef->{'grade_level'}]++;
    $i++;
  };

  if($n1!=0){$self->{average1}=round($tot1/$n1);};
  if($n2!=0){$self->{average2}=round($tot2/$n2);};
  if($n3!=0){$self->{average3}=round($tot3/$n3);};

  @{$self->{grade_counter}}=@grade_counter;
}

##########################################
# Zamienia punktacj w link do szczegw wyniku z egzaminu
#
sub pointsAndLink{
  my ($self,$points,$student,$czyPoprawkowe) = @_;
#  my $corename=text2filename($student->{indeks});
  my $corename=text2filename($student->key());
  my $filename="skaner/ans-$corename.html";
  $filename="skaner/ans-$corename.html" if($czyPoprawkowe);
  my $text=(-e $filename ? "<a href=\"$filename\">$points</a>" : $points);
  return $text;
}

##########################################
# Wydrukuj oceny w formacie HTML
#
sub printResults{
  my ($self,$list_type,$grupa,$par,$studentRB,$nazwaSkroconaTestu) = @_;

  my @sorted;
  my @to_sort;
  my $html_file;
  if($list_type eq 'name'){
    $html_file="$self->{baseName}.$grupa.wg-nazwiska.html";
  }elsif($list_type eq 'score'){
    $html_file="$self->{baseName}.$grupa.wg-wyniku.html";
  }else{
#    $html_file="$self->{baseName}.$grupa.wg-indeksu.html";
    $html_file="wyniki_egzaminu-0.html";
  }

  my $kurs=($par->{'Kurs'}?$par->{'Kurs'}:$self->{par}->{'kurs'});
  my $kierunek=($par->{'Kierunek'}?$par->{'Kierunek'}:$self->{par}->{'kierunek'});
  my $rok=($par->{'Rok'}?$par->{'Rok'}:$self->{par}->{'rok'});
  my $studia=($par->{'Studia'}?$par->{'Studia'}:$self->{par}->{'studia'});

  $studia=($par->{'RodzajStudiow'}?$par->{'RodzajStudiow'}:$studia);
  $studia.= " $par->{'FormaStudiow'}";

  open(HTML,">$html_file") || $self->{raport}->zakoncz("Failed to open $html_file\n");
  print HTML "<HTML>\n";
  print HTML "<HEAD>\n";
  print HTML "  <META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=windows-1250\">\n";
  print HTML "   <TITLE> $kurs </TITLE>\n";
  print HTML "</HEAD>\n";
  print HTML "<CENTER><H2> $kurs </H2>\n";
  print HTML "<P><B>Kierunek:</B> $kierunek \n" if($kierunek =~ /\S/);
  print HTML "<P><B>Studia:</B> $studia \n" if($studia =~ /\S/);
  print HTML "<P><B>Rok:</B> $rok \n" if($rok =~ /\S/);
  print HTML "<P><B>Egzamin:</B> $nazwaSkroconaTestu \n";
  print HTML "<P><B>Data:</B> $self->{par}->{'data'} \n";
  print HTML "<H3> Wyniki </H3>\n";
  print HTML "<TABLE BORDER=2 CELLSPACING=2 CELLPADDING=3>\n";
  print HTML "<tr>";
#  if($self->{par}->{midtermSystem}){
  if($self->{par}->{typZajec} eq 'K+R'){
    if($list_type eq "score"){
      print HTML "<th colspan=3>";
    }else{
      print HTML "<th colspan=2>";
    }
    print HTML "<th align=center> Rep. ";
    print HTML "<th colspan=3 align=center> Testy ";
    print HTML "<th> Konw.";
    print HTML "<th> Nieob.";
    print HTML "<th colspan=2> Ocena";
    print HTML "<th colspan=2> Prot";
  }elsif($self->{par}->{typZajec} eq 'MTW+C'){
    if($list_type eq "score"){
      print HTML "<th colspan=3>";
    }else{
      print HTML "<th colspan=2>";
    }
    print HTML "<th colspan=2 align=center> wicz ";
    print HTML "<th colspan=3 align=center> Testy ";
    print HTML "<th colspan=2> Ocena";
    print HTML "<th colspan=2> Prot";
  }elsif($self->{par}->{typZajec} eq 'MTW+C2'){
    if($list_type eq "score"){
      print HTML "<th colspan=3>";
    }else{
      print HTML "<th colspan=2>";
    }
    print HTML "<th colspan=2 align=center> wicz 1 ";
    print HTML "<th colspan=2 align=center> wicz 2 ";
    print HTML "<th colspan=3 align=center> Testy ";
    print HTML "<th colspan=2> Ocena";
    print HTML "<th colspan=2> Prot";
  }else{
    if($list_type eq "score"){
      print HTML "<th colspan=3>";
    }else{
      print HTML "<th colspan=2>";
    }
    if($pokazZaliczenia){
      print HTML "<th colspan=2 align=center> wicz ";
    }else{
      print HTML "<th align=center> wicz ";
    }
    if($self->{wyklad_i_cwiczenia}){
      if($self->{par}->{wynikProcentowy}){
        print HTML "<th colspan=2 align=center> Test ";
      }else{
        print HTML "<th align=center> Test ";
      }
    }
    print HTML "<th colspan=2>Egz";
  }

#  if($self->{par}->{midtermSystem}){
  if($self->{par}->{typZajec} eq 'K+R'){
    print HTML "<tr>";
    print HTML "<TH>L.p.</TH>" if($list_type ne "name");
    print HTML "<TH>Indeks</TH>";
    print HTML "<TH>Nazwisko</TH>" if($list_type ne "index");
    print HTML "<TH ALIGN=CENTER>Pkt</TH>";
    print HTML "<TH ALIGN=CENTER>MT1</TH><TH ALIGN=CENTER>MT2</TH><TH ALIGN=CENTER>MT3</TH>";
    print HTML "<TH ALIGN=CENTER>Pkt</TH>";
    print HTML "<TH ALIGN=CENTER></TH>";
    print HTML "<TH ALIGN=CENTER>Pkt</TH><TH ALIGN=CENTER>Sownie</TH>\n";
    print HTML "<TH ALIGN=CENTER></TH>\n";
    print HTML "\n";
  }elsif($self->{par}->{typZajec} eq 'MTW+C'){
    print HTML "<tr>";
    print HTML "<TH>L.p.</TH>" if($list_type ne "name");
    print HTML "<TH>Indeks</TH>";
    print HTML "<TH>Nazwisko</TH>" if($list_type ne "index");
    print HTML "<TH ALIGN=CENTER>Pkt</TH>";
    print HTML "<TH ALIGN=CENTER>Zal</TH>";
    print HTML "<TH ALIGN=CENTER>MT1</TH><TH ALIGN=CENTER>MT2</TH><TH ALIGN=CENTER>MT3</TH>";
    print HTML "<TH ALIGN=CENTER>Pkt</TH><TH ALIGN=CENTER>Sownie</TH>\n";
    print HTML "<TH ALIGN=CENTER></TH>\n";
    print HTML "\n";
  }elsif($self->{par}->{typZajec} eq 'MTW+C2'){
    print HTML "<tr>";
    print HTML "<TH>L.p.</TH>" if($list_type ne "name");
    print HTML "<TH>Indeks</TH>";
    print HTML "<TH>Nazwisko</TH>" if($list_type ne "index");
    print HTML "<TH ALIGN=CENTER>Pkt</TH>";
    print HTML "<TH ALIGN=CENTER>Zal</TH>";
    print HTML "<TH ALIGN=CENTER>Pkt</TH>";
    print HTML "<TH ALIGN=CENTER>Zal</TH>";
    print HTML "<TH ALIGN=CENTER>MT1</TH><TH ALIGN=CENTER>MT2</TH><TH ALIGN=CENTER>MT3</TH>";
    print HTML "<TH ALIGN=CENTER>Pkt</TH><TH ALIGN=CENTER>Sownie</TH>\n";
    print HTML "<TH ALIGN=CENTER></TH>\n";
    print HTML "\n";
  }else{
    print HTML "<tr>";
    print HTML "<TH>L.p.</TH>" if($list_type ne "name");
    print HTML "<TH>Indeks</TH>";
    print HTML "<TH>Nazwisko</TH>" if($list_type ne "index");
    print HTML "<TH ALIGN=CENTER>Pkt</TH>";
    print HTML "<TH ALIGN=CENTER>Zal</TH>" if($pokazZaliczenia);
    print HTML "<TH ALIGN=CENTER>Pkt</TH>" if($self->{wyklad_i_cwiczenia} && $self->{par}->{wynikProcentowy});
    print HTML "<TH ALIGN=CENTER>(%)</TH>" if($self->{wyklad_i_cwiczenia});
    print HTML "<TH ALIGN=CENTER>Wyn</TH><TH ALIGN=CENTER>Oc</TH>\n";
    print HTML "<TH ALIGN=CENTER>Prot</TH>\n";
    print HTML "<TH ALIGN=CENTER></TH>\n";
    print HTML "\n";
}


  my @studentKeys=keys %$studentRB;
  my $nstud=$#studentKeys+1;
  my $j;

  # Stosownie do zyczenia sortujemy
  for($j=0;$j<$nstud;$j++){
    my $studentRef=$studentRB->{$studentKeys[$j]};
    my $key;
    if($list_type eq 'name'){
#      $key=pol2ascii($studentRef->{'nazwisko'} .' '.$studentRef->{'imie'});
      $key=pol2code($studentRef->{'nazwisko'} .' '.$studentRef->{'imie'});
    }elsif($list_type eq 'score'){
      $key=addLeadingZeros($studentRef->{'pkttot'});
    }else{
      $key=addLeadingZeros($studentRef->{indeks});
    }
#    $to_sort[$j]=$key.":".$j;
# Poprawka do pary z nastpn ma na celu uniknicie problemw
# gdy w numerach indeksw s dwukropki
    $to_sort[$j]=$key.":\t:".$j;
  }
  @sorted = sort @to_sort;

  my $jestZalegajacy=0;
  for(my $j=0;$j<$nstud;$j++){
    # Z posortowanej tablicy wydobywamy indeks
#    my($key,$i)=split(/:/,$sorted[$j]);
    my($key,$i)=split(/:\t:/,$sorted[$j]);
    # i odczytujemy hash z damymi studenta
    my $studentRef=$studentRB->{$studentKeys[$i]};
    my $lp=$j+1;
    if($studentRef->{'alternatywnaOcena'} =~ /\S+/){
      $studentRef->{'punktyEgzaminowe'}='***';
      $studentRef->{'punktyCwiczeniowe'}='***';
      $studentRef->{'pkttot'}='***';
    }
    if($studentRef->{'ihs'}){
      $studentRef->{'punktyCwiczeniowe'}='***';
      $studentRef->{'pkttot'}='IHS';
    }
    if($studentRef->{'brakNrTestu'}){
      $studentRef->{'komentarz'}='Brak kodu testu';
    }
#    if($self->{par}->{midtermSystem}){
    if($self->{par}->{typZajec} eq 'K+R'){
      if(($studentRef->{indeks} !~ /\*/ || $list_type ne 'index') ){
        print HTML  "<TR>";
        print HTML  "<TD>$lp</TD>" if($list_type ne "name");
  #      print HTML  "<TD align=center>$studentRef->{'rokStudiow'}</TD>" if($list_type ne "index");
        print HTML  "<TD align=center>$studentRef->{'indeks'}</TD>";
        print HTML  "<TD>$studentRef->{'nazwisko'} $studentRef->{'imie'}</TD>" if($list_type ne "index");
        print HTML  "<TD align=center>$studentRef->{'punktyC'}</TD>";
        print HTML  "<TD align=center>$studentRef->{'midTerm1'}</TD>";
        print HTML  "<TD align=center>$studentRef->{'midTerm2'}</TD>";
        print HTML  "<TD align=center>$studentRef->{'midTerm3'}</TD>";
        print HTML  "<TD align=center>$studentRef->{'punktyKonwersatorium'}</TD>";
        my $nieobecnosci=$studentRef->{'knieob'}+$studentRef->{'rnieob'};
        print HTML  "<TD align=center>$nieobecnosci</TD>";
        my $pkttot=$studentRef->{'pkttot'};
        my $ocena=$studentRef->{'ocena'};
#        print HTML  "<TD align=center>$pkttot</TD>";
        print HTML  "<TD align=center>$studentRef->{'punktyRazemBezUwzglednieniaNieobecnosci'}</TD>";
        print HTML  "<TD align=center><b>$ocena</b></TD>";
        print HTML  "<TD align=center>$studentRef->{'numerProtokolu'}</TD>";
        print HTML  "<TD>$studentRef->{'komentarz'}</TD>" if($studentRef->{'komentarz'} =~ /\S+/);
        print HTML  "</TR>\n";
      }
    }elsif($self->{par}->{typZajec} eq 'MTW+C'){
      if(($studentRef->{indeks} !~ /\*/ || $list_type ne 'index') ){
        print HTML  "<TR>";
        print HTML  "<TD>$lp</TD>" if($list_type ne "name");
  #      print HTML  "<TD align=center>$studentRef->{'rokStudiow'}</TD>" if($list_type ne "index");
        print HTML  "<TD align=center>$studentRef->{'indeks'}</TD>";
        print HTML  "<TD>$studentRef->{'nazwisko'} $studentRef->{'imie'}</TD>" if($list_type ne "index");
        print HTML  "<TD align=center>$studentRef->{'punktyC'}</TD>";
        print HTML  "<TD align=center>$studentRef->{'zaliczenie'}</TD>";
        print HTML  "<TD align=center>$studentRef->{'midTerm1'}</TD>";
        print HTML  "<TD align=center>$studentRef->{'midTerm2'}</TD>";
        print HTML  "<TD align=center>$studentRef->{'midTerm3'}</TD>";
        my $pkttot=$studentRef->{'pkttot'};
        my $ocena=$studentRef->{'ocena'};
#        print HTML  "<TD align=center>$pkttot</TD>";
        print HTML  "<TD align=center>$studentRef->{'punktyRazemBezUwzglednieniaNieobecnosci'}</TD>";
        print HTML  "<TD align=center><b>$ocena</b></TD>";
        print HTML  "<TD align=center>$studentRef->{'numerProtokolu'}</TD>";
        print HTML  "<TD>$studentRef->{'komentarz'}</TD>" if($studentRef->{'komentarz'} =~ /\S+/);
        print HTML  "</TR>\n";
      }
    }elsif($self->{par}->{typZajec} eq 'MTW+C2'){
      if(($studentRef->{indeks} !~ /\*/ || $list_type ne 'index') ){
        print HTML  "<TR>";
        print HTML  "<TD>$lp</TD>" if($list_type ne "name");
  #      print HTML  "<TD align=center>$studentRef->{'rokStudiow'}</TD>" if($list_type ne "index");
        print HTML  "<TD align=center>$studentRef->{'indeks'}</TD>";
        print HTML  "<TD>$studentRef->{'nazwisko'} $studentRef->{'imie'}</TD>" if($list_type ne "index");
        print HTML  "<TD align=center>$studentRef->{'punktyC1'}</TD>";
        print HTML  "<TD align=center>$studentRef->{'zaliczenie1'}</TD>";
        print HTML  "<TD align=center>$studentRef->{'punktyC2'}</TD>";
        print HTML  "<TD align=center>$studentRef->{'zaliczenie2'}</TD>";
        print HTML  "<TD align=center>$studentRef->{'midTerm1'}</TD>";
        print HTML  "<TD align=center>$studentRef->{'midTerm2'}</TD>";
        print HTML  "<TD align=center>$studentRef->{'midTerm3'}</TD>";
        my $pkttot=$studentRef->{'pkttot'};
        my $ocena=$studentRef->{'ocena'};
#        print HTML  "<TD align=center>$pkttot</TD>";
        print HTML  "<TD align=center>$studentRef->{'punktyRazemBezUwzglednieniaNieobecnosci'}</TD>";
        print HTML  "<TD align=center><b>$ocena</b></TD>";
        print HTML  "<TD align=center>$studentRef->{'numerProtokolu'}</TD>";
        print HTML  "<TD>$studentRef->{'komentarz'}</TD>" if($studentRef->{'komentarz'} =~ /\S+/);
        print HTML  "</TR>\n";
      }
    }else{
      if(($studentRef->{indeks} !~ /\*/ || $list_type ne 'index') ){
        print HTML  "<TR>";
        print HTML  "<TD>$lp</TD>" if($list_type ne "name");
  #      print HTML  "<TD align=center>$studentRef->{'rokStudiow'}</TD>" if($list_type ne "index");
        print HTML  "<TD align=center>$studentRef->{'indeks'}</TD>";
        print HTML  "<TD>$studentRef->{'nazwisko'} $studentRef->{'imie'}</TD>" if($list_type ne "index");
        print HTML  "<TD align=center>$studentRef->{'punktyCwiczeniowe'}</TD>";
        print HTML  "<TD align=center>$studentRef->{'zaliczenie'}</TD>" if($pokazZaliczenia);
        my $punktyEgzaminowe=$studentRef->{'punktyEgzaminowe'};
        $punktyEgzaminowe=$self->pointsAndLink($punktyEgzaminowe,$studentRef) if($main::opt_d);
        my $pkttot=$studentRef->{'pkttot'};
        my $ocena=$studentRef->{'ocena'};
        my $punktyEgzaminoweBezwzgledne=$studentRef->{punktyEgzaminoweBezwzgledne};
        if (
            $studentRef->{'czyZalega'} eq 'T' &&
            $list_type eq 'index'
        ){
          $ocena=$pkttot=$punktyEgzaminowe='dz<up>(*)</up>';
          $jestZalegajacy=1;
        }
        # Jeli wymagane jest zaliczenie, a nie ma go, na licie dla studentw anulujemy punkty egzaminowe
        if( $self->{par}->{wymagajZaliczenie} && ($studentRef->{zaliczenie} !~ /\w/ || $studentRef->{zaliczenie} eq 'ndst' || $studentRef->{zaliczenie}=~ /2/)){
          if($list_type eq 'index'){
            $punktyEgzaminowe='-';
            $pkttot='-';
            $ocena='-';
            $punktyEgzaminoweBezwzgledne='-';
          }else{
            $punktyEgzaminowe="[$punktyEgzaminowe]";
            $pkttot="[$pkttot]";
            $ocena="[$ocena]";
            $punktyEgzaminoweBezwzgledne="[$punktyEgzaminoweBezwzgledne]";
          }
        }
        if($self->{wyklad_i_cwiczenia}){
          print HTML  "<TD align=center>$punktyEgzaminoweBezwzgledne</TD>" if($self->{par}->{wynikProcentowy});
          print HTML  "<TD align=center>$punktyEgzaminowe</TD>";
        }
        print HTML  "<TD align=center>$pkttot</TD>";
        print HTML  "<TD align=center><b>$ocena</b></TD>";
        print HTML  "<TD align=center>$studentRef->{'numerProtokolu'}</TD>";
        print HTML  "<TD>$studentRef->{'komentarz'}</TD>" if($studentRef->{'komentarz'} =~ /\S+/);
        print HTML  "</TR>\n";
      }
    }
  }
  # Ponisze dwa warunkowe kawaki powinny by zastpione redni dla grupy,
  # ktra jest liczona dla wszystkich grup i od razu drukowana na standardowe
  # wyjcie, zamiast zosta przechowan do wydrukowania tutaj
#  if($grupa eq 'all' && !($self->{par}->{midtermSystem}) ){
  if($grupa eq 'all' && !($self->{par}->{typZajec} eq 'K+R') && !($self->{par}->{typZajec} eq 'MTW+C') && !($self->{par}->{typZajec} eq 'MTW+C2') ){
    print HTML "<TR><TD></TD><TD>rednia</TD>";
    print HTML "<TD></TD><TD></TD>" if($list_type ne "index");
    print HTML "<TD>$self->{average1}</TD>";
    print HTML "<TD></TD>" if($pokazZaliczenia);
    print HTML "<TD></TD>" if($self->{wyklad_i_cwiczenia} && $self->{par}->{wynikProcentowy});
    print HTML "<TD>$self->{average2}</TD>"  if($self->{wyklad_i_cwiczenia});
    print HTML "<TD>$self->{average3}</TD>";
    print HTML "</TR>\n";
  }
  print HTML "</TABLE></CENTER>\n";
  if($jestZalegajacy){
    print HTML "<P><B>(*)</B> Wynik zastrzeony do wiadomoci dziekanatu.<br>
    Prosz spraw wyjani i pyta o wynik w dziekanacie. \n";
  }
  print HTML "<P><B>Uwaga:</B> $par->{'Komentarz'} \n" if($par->{'Komentarz'} =~ /\S/) ;
#  if(!($self->{par}->{midtermSystem}) ){
  if(!($self->{par}->{typZajec} eq 'K+R') && !($self->{par}->{typZajec} eq 'MTW+C') && !($self->{par}->{typZajec} eq 'MTW+C2')){
    print HTML "<hr><center><table border=1>\n";
    print HTML "<tr><th><b>Oczekiwany wynik przypadkowy:</b><td> $par->{OczekiwanyWynikPrzypadkowy} \n";
    print HTML "<tr><th><b>Oczekiwany wynik przypadkowy dla strategii pojedynczych odpowiedzi:</b><td> $par->{OczekiwanyWynikPrzypadkowyDlaStrategiiPojedynczychOdpowiedzi} \n";
    print HTML "<tr><th><b>Maksymalny moliwy wynik:</b><td> $par->{MaxPoints} \n";
    print HTML "<tr><th><b>Maksymalny uzyskany wynik:</b><td> $par->{MaxStudentPoints} \n";
    print HTML "<tr><th><b>Wynik na 0%:</b><td> $par->{OstatecznaIloscPunktowNa0Procent} \n";
    print HTML "<tr><th><b>Wynik na 100%:</b><td> $par->{OstatecznaIloscPunktowNa100Procent} \n";
    print HTML "</table></center>\n";
  }

  if($grupa eq 'all'){
    print HTML "<HR><CENTER><B> Statystyka </B>\n";
    print HTML "<TABLE BORDER=2 CELLSPACING=2 CELLPADDING=3>\n";
    print HTML "<TR><TH>Ocena</TH>";
    print HTML "<TH>Limit</TH>";
    print HTML "<TH>Ilo</TH>\n";
    for(my $i=0;$i<=$#{$self->{grader}->{limityOcen}};$i++){
      print HTML "<TR><TD> $self->{grader}->{formaOcen}->[$i]";
      print HTML "<TD> $self->{grader}->{limityOcen}->[$i]";
      print HTML "<TD> $self->{grade_counter}->[$i]\n";
    }
    print HTML "</TABLE></CENTER>\n";
  }
  if($self->{par}->{komentarz}){
    print HTML <<END
    <hr>
    $self->{par}->{komentarz}
END
    ;
  }
  print HTML "</BODY>\n";
  print HTML "</HTML>\n";
  close(HTML);
}

################################
#
# Ustala typ egzaminu
# Dodane, by unikn bdw z cigym "gubieniem" typu egzaminu
#

my $typEgzaminu='';

sub setTypEgzaminu{
  my ($self,$newVal)=@_;
  if($newVal =~ /\S/){
    if(!$typEgzaminu){
      $typEgzaminu=$newVal;
    }else{
      if($typEgzaminu ne $newVal){
        $self->{raport}->wymalujError("Wczytano dwa rne typy egzaminu: $typEgzaminu oraz $newVal\n");
      }
    }
  }
}


################################
#
# Przygotowujemy protok w postaci *.csv
#
sub przygotujProtokol{
  my ($self)=@_;

  $typEgzaminu='';
  my @sortingFieldsArray=qw(nazwisko imie indeks);
  my @protokolHeaderFieldsArray=qw(TypListy Protokol KodowaniePolskichLiter StanListy Wykladowca Kurs TypEgzaminu Rok Semestr DataEgzaminu RodzajStudiow FormaStudiow DaneRekordu);
  my @protokolFieldsArray=     qw(nazwisko imie indeks      );
  my @protokolFieldsNamesArray=qw(nazwisko imie numerAlbumu );

  my $protokolStudentRB=new StudentRecordBase;
#  my $par={};
  my $par=$self->{par};

  my $nazwaSkroconaTestu=$self->{par}->{nazwaSkroconaTestu};
  my $wd=pwd();

  # W protokolStudentRB znajda sie tylko studenci z list dostarczonych przez dziekanat ...
  my $masterRecord={nazwisko => 1, imie => 1, indeks => 1, numerOsoby => 1, numerProtokolu => 1};
  print "Wyznaczam studentw do protokou\n";
  my $daneRekordu=$protokolStudentRB->wczytajStudentow($par,$self->{raport},'studenci');
  $self->setTypEgzaminu($par->{TypEgzaminu});
  # Nie wiem czy to jest dobry pomys: zapewne inaczej naley sprawdza, czy plik z wynikami zosta wczytany
  if(!$daneRekordu){
    $self->{raport}->wymalujError("przygotujProtokol: Nie odnaleziono pola DaneRekordu.\n".
                              "Sprawd pliki ze studentami, pamitajc, e pole DaneRekordu\n".
                              "w plikach aneks i suplement jest pomijane\n");
  }

  # Czasami niezbdna jest rczna korekta ocen poprzez zmian punktw egzaminowych
  # Punkty takie umieszcza si w pliku korekta.csv

  my $korektaStudentRB=new StudentRecordBase;
  my $dir='studenci';
  $dir="$dir-$self->{par}->{edycja}" if($self->{par}->{edycja});
  if(-r "$dir/korekta.csv"){
    my $par={};
    my $nazwaSkroconaTestu = ( $self->{par}->{nazwaBazowaTestu} =~ /^[^.]+.([^.]+$)/ ? $1 : 'egzamin');
    print "Czytam plik z korekt\n";
    my $punktyEgzaminowe="punktyEgzaminowe-$nazwaSkroconaTestu";
    $korektaStudentRB->read("$dir/korekta.csv",$par,'student');
    while(my($studKey,$studentRef)=each(%$korektaStudentRB)){
      $self->{studentRB}->{$studKey}->{$punktyEgzaminowe}=$korektaStudentRB->{$studKey}->{$punktyEgzaminowe} if($korektaStudentRB->{$studKey}->{$punktyEgzaminowe});
      $protokolStudentRB->{$studKey}->{$punktyEgzaminowe}=$korektaStudentRB->{$studKey}->{$punktyEgzaminowe} if($korektaStudentRB->{$studKey}->{$punktyEgzaminowe});
    }
  }

  $self->computeGrades($protokolStudentRB,$nazwaSkroconaTestu);
  $self->doStatistics($protokolStudentRB);

  # Plik korekta moe te zawiera gotowe oceny na przykad przepisane z innego indeksu

  while(my($studKey,$studentRef)=each(%$korektaStudentRB)){
    $self->{studentRB}->{$studKey}->{'ocena'}=$korektaStudentRB->{$studKey}->{ocena} if($korektaStudentRB->{$studKey}->{'ocena'});
    $protokolStudentRB->{$studKey}->{'ocena'}=$korektaStudentRB->{$studKey}->{ocena} if($korektaStudentRB->{$studKey}->{'ocena'});
  }

  # Na wszelki wypadek tworzymy list studentw do egzaminu poprawkowego
  # (czasem si przydaje)
  my $studenciPoprawkowiNazwaPliku="studenci-poprawka.csv";
  my $poprawkowaRB=$self->przygotujListePoprawkowa($protokolStudentRB);
  my @protokolHeaderFieldsArrayPop=qw(TypListy Protokol KodowaniePolskichLiter StanListy TypEgzaminu DataEgzaminu DaneRekordu);
  my @protokolFieldsArrayPop= qw(pesel indeks nazwisko imie);
  my @protokolFieldsNamesArrayPop=qw(pesel indeks nazwisko imie);
  my $temp=$par->{StanListy};
  $par->{'StanListy'}='poprawkowa';
  $poprawkowaRB->write($studenciPoprawkowiNazwaPliku,$par,\@protokolHeaderFieldsArrayPop,\@protokolFieldsArrayPop,\@sortingFieldsArray,\@protokolFieldsNamesArrayPop);
  $par->{'StanListy'}=$temp;

  # Przygotowujemy pliki htmlowe z wynikami
  $self->printResults('name', 'all',$par,$protokolStudentRB,$nazwaSkroconaTestu);
  $self->printResults('score','all',$par,$protokolStudentRB,$nazwaSkroconaTestu);
  $self->printResults('index','all',$par,$protokolStudentRB,$nazwaSkroconaTestu);

  # Przygotowujemy plik z wynikami do protokolu
  @protokolFieldsArray=split(';',$daneRekordu);
  push(@protokolFieldsArray,'ocena') if($daneRekordu !~ /ocena/i);
  @protokolFieldsNamesArray=@protokolFieldsArray;
  $protokolStudentRB->normalizujZmienKlucze(\@protokolFieldsArray);
  $par->{'StanListy'}='po egzaminie';
  my $dataDoProtokolu=($self->{par}->{dataDoProtokolu}?$self->{par}->{dataDoProtokolu}:$self->{par}->{data});
  if($dataDoProtokolu =~ /^\d\d\d\d-\d\d-\d\d$/){
    $par->{'DataEgzaminu'}=$dataDoProtokolu;
  }else{
    $self->{raport}->wymaluj( "W terminie $nazwaSkroconaTestu data do protokolu =$dataDoProtokolu= nie pasuje do wzorca rrrr-mm-dd\n");
  }
  my $nazwaProtokolu="$self->{par}->{nazwaBazowaTestu}.protokol.csv";
  $par->{TypEgzaminu}=$typEgzaminu;
  $self->{raport}->wymalujError("Nie ustalony typ egzaminu!!!\n") if(!$self->{par}->{wariant} eq 'UJ' && !$par->{TypEgzaminu});
  $protokolStudentRB->write($nazwaProtokolu,$par,\@protokolHeaderFieldsArray,\@protokolFieldsArray,\@sortingFieldsArray,\@protokolFieldsNamesArray);

  # Przygotowujemy protok w wersji dla USOS
  if($self->{par}->{wariant} eq 'UJ'){
    open(USOS,">$self->{par}->{nazwaBazowaTestu}.protokol-usos.csv") || $self->{raport}->zakoncz("Failed to open $self->{par}->{nazwaBazowaTestu}.protokol-usos.csv\n");
    print USOS "pesel;imie;nazwisko;ocena;\n";     # Tego w usos nie chc

    # Szykujemy posortowana liste studentow
    my @toSort=();
    while(my($recordKey,$recordRef)=each(%$protokolStudentRB)){
      my $sortkey='';
      foreach my $field (@sortingFieldsArray){
         $sortkey.="$recordRef->{$field} ";
      }
      push @toSort,"$sortkey***$recordKey";
    }

    # wypisujemy informacje o studentach wg kolejnosci ustalonej sortowaniem
    my @sorted=@{polSort \@toSort};
    my @oceny_usos=('2','3','3,5','4','4,5','5','');
    my $cnt=0;
    foreach my $elem (@sorted){
      my ($sortkey,$recordKey)=split(/\*\*\*/,$elem);
      my $recordRef=$protokolStudentRB->{$recordKey};
#print ++$cnt, " =$recordRef->{zaliczenie}=;=$recordRef->{'punktyC'}=;$recordRef->{pesel};$recordRef->{imie};$recordRef->{nazwisko};$oceny_usos[5-$recordRef->{'grade_level'}];\n";
      if(
        $recordRef->{'grade_level'}>=0  # Pomijamy wypisywanie osb nieklasyfikowanych
        && (!$self->{par}->{wymagajZaliczenie} ||
              !($recordRef->{zaliczenie} !~ /\w/ || $recordRef->{zaliczenie} eq 'ndst' || $recordRef->{zaliczenie} =~ /2/) # oraz z brakiem zaliczenia
           )
      ){
        print USOS "$recordRef->{pesel};$recordRef->{imie};$recordRef->{nazwisko};$oceny_usos[5-$recordRef->{'grade_level'}];\n";
      }
    }
    close(USOS);
  }

  # Przygotowujemy sam protok w formacie xls
  if($main::opt_p){
    my $command="$Bin\\protcsv $nazwaProtokolu";
    $self->{raport}->wymaluj("Przygotowuj protok dla terminu $nazwaSkroconaTestu.\n     $command \nTo moe potrwa kilka minut. Prosz czeka\n");
    my $out=`$command`;
    print "Odpowiedz protcsv:\n $out\n";
    unlink "prot_temp.txt";
  }

  # Robimy porzdki z plikami
  if($self->{par}->{rozdzielonePliki}){
    if(-d 'protokoly' && $main::opt_p){
      unlink <protokoly/*protokol*.xls>;
      print "Przenosz wygenerowane protokoly do katalogu protokoly\n";
      move("*protokol*.xls",'protokoly');
    }
    if(-d 'oceny'){
      unlink <oceny/*.all.wg-*.html> if();
      move("*.all.wg-*.html",'oceny');
    }
  }
}

####################################################
#   Wsplczynnik korelacji
#

sub wyliczKorelacjeDlaPliku{
  my ($self,$file)=@_;
  my $korelacjeStudentRB=new StudentRecordBase;
  my $par={};
  my @x=();
  my @y=();
  my $n=0;
  $korelacjeStudentRB->read($file,$par,'student');
  while(my($studKey,$studentRef)=each(%$korelacjeStudentRB)){
    my $pktCw=$korelacjeStudentRB->{$studKey}->{'punktyCwiczeniowe'};
    if($pktCw =~ /\d/){
      push(@x,$pktCw);
      push(@y,$self->{studentRB}->{$studKey}->{"punktyEgzaminowe-$self->{par}->{nazwaSkroconaTestu}"} );
      $n++;
    }
  }
  my $kor=wspolczynnikKorelacji(\@x,\@y,$n);
  my $sre=srednia(\@x,$n);
  return ($kor,$sre,$n);
}

####################################################
#   Wsplczynnik korelacji wzgldem asystentw
#

sub wyliczKorelacje{
  my ($self)=@_;
  opendir(DIR,"..");
  my @filelist=readdir(DIR);
  closedir(DIR);
  foreach my $file (@filelist){
    if($file =~ $self->{szablonPlikuCwiczeniaWyniki}){
      my ($kor,$sre,$n)=$self->wyliczKorelacjeDlaPliku("../$file");
      $kor=int($kor*1000)/1000;
      $sre=int($sre*10)/10;
      my $asystent;
      if($file =~ /-(\w+)\.csv$/){
        $asystent=$1;
      }
      $self->{raport}->wymaluj("Wspolczynnik korelacji dla $asystent wynosi $kor przy sredniej $sre i $n studentach\n");
    }
  }
}

####################################################
#   Podprogram wyznaczajcy oceny
#

sub wyznaczOceny{
  my ($self)=@_;

  $self->init();

  $self->{studentRB}=new StudentRecordBase;
  $self->{studentRB}->wczytajStudentow($self->{par},$self->{raport},'studenci');

  $self->{grader}=new grader($self->{par}->{'limity_ocen'},$self->{par}->{'oceny'});
  $self->{graderKR}=new graderKR($self->{par}->{'limity_ocen'},$self->{par}->{'oceny'});
  $self->{graderMTC}=new graderMTC($self->{par}->{'limity_ocen'},$self->{par}->{'oceny'});
  $self->{graderMTC2}=new graderMTC2($self->{par}->{'limity_ocen'},$self->{par}->{'oceny'});
  $self->{graderPopr}=new grader($self->{par}->{'limity_popr'},$self->{par}->{'oceny'});
  $self->{graderIHS}=new grader($self->{par}->{'limity_ihs'},$self->{par}->{'oceny'});

  my $par=$self->{par};
  my $studentRB=$self->{studentRB};

  my @sortingFieldsArray=qw(nazwisko imie indeks);
  my @protokolHeaderFieldsArray=qw(TypListy Protokol KodowaniePolskichLiter StanListy Wykladowca Kurs TypEgzaminu Rok Semestr DataEgzaminu RodzajStudiow FormaStudiow DaneRekordu);
  my @protokolFieldsArray=     qw(numerProtokolu indeks      nazwisko imie rokStudiow standard grupaCwiczeniowa       grupaWykladowa       potok       ocena);
  my @protokolFieldsNamesArray=qw(numerProtokolu numerAlbumu nazwisko imie rokStudiow standard nazwaGrupyCwiczeniowej nazwaGrupyWykladowej nazwaPotoku ocena);

  my @protokolFieldsArrayPoprawka=     qw(numerProtokolu indeks      nazwisko imie rokStudiow standard grupaCwiczeniowa       grupaWykladowa       potok       ocenaPoprawkowa);
  my @protokolFieldsNamesArrayPoprawka=qw(numerProtokolu numerAlbumu nazwisko imie rokStudiow standard nazwaGrupyCwiczeniowej nazwaGrupyWykladowej nazwaPotoku ocena);

  my $parbis={};
  my $basename=$self->{baseName};

  # Jeli jest ustawiona opcja ocenProjekty trzeba zmieni klas macierzyst
  if($self->{par}->{'ocenProjekty'}){
    bless($self,'oceniaczProjektow');
  }

  $self->dolaczPunktyCwiczeniowe($studentRB,$basename,$parbis);
#  if($self->{par}->{midtermSystem}){
  if($self->{par}->{typZajec} eq 'K+R' || $self->{par}->{typZajec} eq 'MTW+C' || $self->{par}->{typZajec} eq 'MTW+C2'){
    $self->dolaczPunktyMidterm($studentRB,$par);
  }else{
    $self->dolaczPunktyEgzaminowe($studentRB,$par);
  }
  $self->przygotujProtokol();
  $self->wyliczKorelacje();

  if($self->{par}->{mnoznikPunktacji} != 1 || $self->{par}->{przesunieciePunktacji} != 0 ){
    $self->{raport}->wymaluj("===> Punkty z egzaminu = $self->{par}->{przesunieciePunktacji} +  $self->{par}->{mnoznikPunktacji} * rzeczywiste punkty z egzaminu\n");
  }
  if(!$Record::error){
    $self->{raport}->wypisz("OK. Wyznaczono oceny i wypisano protokoy\n");
  }else{
    $self->{raport}->wypisz(" ***** Byy bdy przy czeniu danych rekordw ***** \n");
  }
  if($self->{raport}->{errorCounter}){
    $self->{raport}->wymaluj(' ');
    $self->{raport}->{textWidget}->insert('end',' ','errorSummary');
    $self->{raport}->{textWidget}->insert('end'," Wykonano, ale z bdami ",'error');
    $self->{raport}->{textWidget}->insert('end',' ','errorSummary');
    $self->{raport}->wymaluj("\n");
  }else{
    $self->{raport}->wymaluj(' ');
    $self->{raport}->{textWidget}->insert('end',' ','ok');
    $self->{raport}->wymaluj(" Wykonano \n");
  }
  $self->{raport}->zamknij_raport();
}

####################################################
#   Dla zgodnoci z egzaminatorem
#

sub wykonaj{
  my ($self)=@_;
  $main::opt_p=$self->{referencjaZadania}->{excel};
  $self->wyznaczOceny();
}

###########################################################################

1;