###############################
#
# modu wyznaczania wspczynnika korelacji
# (c) Marian Mrozek, Krakw - Nowy Scz 2003

package korelacje;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(srednia wspolczynnikKorelacji wspolczynnikKorelacjiAlt);

################################
#
# Funkcja oblicza redni z tablicy danych
# przekazanych przez referencj
#
sub srednia{
  my ($xRef,$n)=@_;

  return 0 if($n<=0);

  my $xSuma=0.;
  for (my $i=0;$i<$n;$i++){
    $xSuma+=$xRef->[$i];
  }
  return $xSuma/$n;
}

################################
#
# Funkcja oblicza wspczynnik korelacji z tablic danych
# przekazanych przez referencj
#
sub wspolczynnikKorelacji{
  my ($xRef,$yRef,$n)=@_;

  return 0 if($n==0);

  my ($xSuma,$ySuma)=(0.,0.);
  my ($xSuma2,$ySuma2,$xySuma)=(0.,0.,0.);

  my $i;
  for ($i=0;$i<$n;$i++){
    $xSuma+=$xRef->[$i];
    $ySuma+=$yRef->[$i];
    $xSuma2+=$xRef->[$i]*$xRef->[$i];
    $ySuma2+=$yRef->[$i]*$yRef->[$i];
    $xySuma+=$xRef->[$i]*$yRef->[$i];
  }
  my $aux=sqrt(($xSuma2-$xSuma*$xSuma/$n)*($ySuma2-$ySuma*$ySuma/$n));
  if($aux == 0){
    return 0;
  }else{
    return ($xySuma-$xSuma*$ySuma/$n)/$aux;
  }
}

################################
#
# Wersja funkcji obliczajcej wspczynnik korelacji z tablic danych
# przekazanych przez referencj, ktra pomija pary danych, gdzie
# jednej z danych brakuje
#
sub wspolczynnikKorelacjiAlt{
  my ($xRef,$yRef,$n)=@_;

  my (@x,@y,$m,$i);
  $m=0;
  for ($i=0;$i<$n;++$i){
    if( ($xRef->[$i] =~ /\d/) && ($yRef->[$i] =~ /\d/) ){
#    if( 1 ){
      $x[$m]=$xRef->[$i];
      $y[$m]=$yRef->[$i];
      ++$m;
    }else{
      print "Brak danych w linii $i: =$xRef->[$i]=  =$yRef->[$i]=\n";
    }
  }

  return (wspolczynnikKorelacji(\@x,\@y,$m),$m);
}

################################
