
###############################
#
# modu konwersji polskich plikw
# w szczeglnoci z metod sort sortujc po polsku
#
# (c) Marian Mrozek, Krakw - Nowy Scz 1996-2011
#  wersja 1.0 (2001.03.20)
#  wersja 1.1 (2011.06.20)

package polChar;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(polISO2win polDOS2win polUTF8_2win pol2ascii pol2esc esc2pol pol2code plConvertText2win plConvertFile2win polSort polSortHashOfArrays);

#                                                                    
# ISO-8859-2     A1  C6  CA  A3  D1  D3  A6  AC  AF  B1  E6  EA  B3  F1  F3  B6  BC  BF
# Windows-1250   A5  C6  CA  A3  D1  D3  8C  8F  AF  B9  E6  EA  B3  F1  F3  9C  9F  BF
# CP852          A4  8F  A8  9D  E3  E0  97  8D  BD  A5  86  A9  88  E4  A2  98  AB  BE

##########################################
#
# Konwertuje ISO do Win
#
sub polISO2win{
  my ($arg)=@_;

  $arg =~ s/\xA1//g;
  $arg =~ s/\xC6//g;
  $arg =~ s/\xCA//g;
  $arg =~ s/\xA3//g;
  $arg =~ s/\xD1//g;
  $arg =~ s/\xD3//g;
  $arg =~ s/\xA6//g;
  $arg =~ s/\xAC//g;
  $arg =~ s/\xAF//g;

  $arg =~ s/\xB1//g;
  $arg =~ s/\xE6//g;
  $arg =~ s/\xEA//g;
  $arg =~ s/\xB3//g;
  $arg =~ s/\xF1//g;
  $arg =~ s/\xF3//g;
  $arg =~ s/\xB6//g;
  $arg =~ s/\xBC//g;
  $arg =~ s/\xBF//g;

  return $arg
}

##########################################
#
# Konwertuje DOS do Win
#
sub polDOS2win{
  my ($arg)=@_;

  $arg =~ s/\xA4//g;
  $arg =~ s/\x8F//g;
  $arg =~ s/\xA8//g;
  $arg =~ s/\x9D//g;
  $arg =~ s/\xE3//g;
  $arg =~ s/\xE0//g;
  $arg =~ s/\x97//g;
  $arg =~ s/\x8D//g;
  $arg =~ s/\xBD//g;

  $arg =~ s/\xA5//g;
  $arg =~ s/\x86//g;
  $arg =~ s/\xA9//g;
  $arg =~ s/\x88//g;
  $arg =~ s/\xE4//g;
  $arg =~ s/\xA2//g;
  $arg =~ s/\x98//g;
  $arg =~ s/\xAB//g;
  $arg =~ s/\xBE//g;

  return $arg
}

##########################################
#
# Konwertuje UTF-8 do Win
#
sub polUTF8_2win{
  my ($arg)=@_;

  $arg =~ s/\xC4\x84//g;
  $arg =~ s/\xC4\x86//g;
  $arg =~ s/\xC4\x98//g;
  $arg =~ s/\xC5\x81//g;
  $arg =~ s/\xC5\x83//g;
  $arg =~ s/\xC3\x93//g;
  $arg =~ s/\xC5\x9A//g;
  $arg =~ s/\xC5\xB9//g;
  $arg =~ s/\xC5\xBB//g;

  $arg =~ s/\xC4\x85//g;
  $arg =~ s/\xC4\x87//g;
  $arg =~ s/\xC4\x99//g;
  $arg =~ s/\xC5\x82//g;
  $arg =~ s/\xC5\x84//g;
  $arg =~ s/\xC3\xB3//g;
  $arg =~ s/\xC5\x9B//g;
  $arg =~ s/\xC5\xBA//g;
  $arg =~ s/\xC5\xBC//g;

  return $arg
}

##########################################
#
# Usuwa kreseczki i ogonki
#
sub pol2ascii{
  my ($arg)=@_;

  $arg =~ s//a/g;
  $arg =~ s//c/g;
  $arg =~ s//e/g;
  $arg =~ s//l/g;
  $arg =~ s//n/g;
  $arg =~ s//o/g;
  $arg =~ s//s/g;
  $arg =~ s//z/g;
  $arg =~ s//z/g;
  $arg =~ s//A/g;
  $arg =~ s//C/g;
  $arg =~ s//E/g;
  $arg =~ s//L/g;
  $arg =~ s//N/g;
  $arg =~ s//O/g;
  $arg =~ s//S/g;
  $arg =~ s//Z/g;
  $arg =~ s//Z/g;
  return $arg
}

##########################################
#
# Konwersja kodujaca w ASCii
#
sub pol2esc{
  my ($arg)=@_;
  $arg =~ s//{{a}}/g;
  $arg =~ s//{{c}}/g;
  $arg =~ s//{{e}}/g;
  $arg =~ s//{{l}}/g;
  $arg =~ s//{{n}}/g;
  $arg =~ s//{{o}}/g;
  $arg =~ s//{{s}}/g;
  $arg =~ s//{{x}}/g;
  $arg =~ s//{{z}}/g;
  $arg =~ s//{{A}}/g;
  $arg =~ s//{{C}}/g;
  $arg =~ s//{{E}}/g;
  $arg =~ s//{{L}}/g;
  $arg =~ s//{{N}}/g;
  $arg =~ s//{{O}}/g;
  $arg =~ s//{{S}}/g;
  $arg =~ s//{{X}}/g;
  $arg =~ s//{{Z}}/g;
  return $arg;
}

##########################################
#
# Konwersja dekodujaca w ASCii
#
sub esc2pol{
  my ($arg)=@_;
  $arg =~ s/{{a}}//g;
  $arg =~ s/{{c}}//g;
  $arg =~ s/{{e}}//g;
  $arg =~ s/{{l}}//g;
  $arg =~ s/{{n}}//g;
  $arg =~ s/{{o}}//g;
  $arg =~ s/{{s}}//g;
  $arg =~ s/{{x}}//g;
  $arg =~ s/{{z}}//g;
  $arg =~ s/{{A}}//g;
  $arg =~ s/{{C}}//g;
  $arg =~ s/{{E}}//g;
  $arg =~ s/{{L}}//g;
  $arg =~ s/{{N}}//g;
  $arg =~ s/{{O}}//g;
  $arg =~ s/{{S}}//g;
  $arg =~ s/{{X}}//g;
  $arg =~ s/{{Z}}//g;
  return $arg;
}

##########################################
#
# Konwersja ma na celu poprawne sortowanie z polskimi literami
#
sub pol2code{
  my ($arg)=@_;
  $arg =~ s/a/a1/g;
  $arg =~ s/c/c1/g;
  $arg =~ s/e/e1/g;
  $arg =~ s/l/l1/g;
  $arg =~ s/n/n1/g;
  $arg =~ s/o/o1/g;
  $arg =~ s/s/s1/g;
  $arg =~ s/z/z1/g;
  $arg =~ s/A/A1/g;
  $arg =~ s/C/C1/g;
  $arg =~ s/E/E1/g;
  $arg =~ s/L/L1/g;
  $arg =~ s/N/N1/g;
  $arg =~ s/O/O1/g;
  $arg =~ s/S/S1/g;
  $arg =~ s/Z/Z1/g;

  $arg =~ s//a2/g;
  $arg =~ s//c2/g;
  $arg =~ s//e2/g;
  $arg =~ s//l2/g;
  $arg =~ s//n2/g;
  $arg =~ s//o2/g;
  $arg =~ s//s2/g;
  $arg =~ s//z2/g;
  $arg =~ s//z3/g;
  $arg =~ s//A2/g;
  $arg =~ s//C2/g;
  $arg =~ s//E2/g;
  $arg =~ s//L2/g;
  $arg =~ s//N2/g;
  $arg =~ s//O2/g;
  $arg =~ s//S2/g;
  $arg =~ s//Z2/g;
  $arg =~ s//Z3/g;
  return $arg
}

##########################################
#
# Konwertuje tekst w UTF-8 ISO lub DOS na Win
# Pozostawia Win bez zmian
#
sub plConvertText2win{
  my ($text,$encodingRef)=@_;
  my $encoding=0;
  $encodingRef=\$encoding if(!$encodingRef);
  if($text =~ /(\xC3|\xC4|\xC5)/){
    # definitely  UTF8 encoding
    $text=polUTF8_2win($text);
    $$encodingRef="UTF8";
  }elsif($text =~ /(\xA1|\xA6|\xAC|\xB1|\xB6|\xBC)/){
    # definitely  ISO encoding
    $text=polISO2win($text);
    $$encodingRef="ISO";
  }elsif($text =~ /(\xC6|\xCA|\xA3|\xD1|\xD3|\x8C|\xAF\xB9|\xE6|\xEA|\xB3|\xF1|\xF3|\x9C|\x9F|\xBF)/){
    # Win encoding if ISO excluded
    $$encodingRef="Win";
  }elsif($text =~ /(\xA4|\xA8|\x9D|\xE3|\xE0|\x97|\x8D|\xBD|\x86|\xA9|\x88|\xE4|\xA2|\x98|\xAB|\xBE)/){
    # definitely DOS encoding
    $text=polDOS2win($text);
    $$encodingRef="DOS";
  }else{
    $$encodingRef="";
  }
  return ($text);
}

##########################################
#
# Konwertuje plik w UTF-8 ISO lub DOS na Win
# Pozostawia Win bez zmian
#
sub plConvertFile2win{
  my ($fileName)=@_;
  open(IN,"<$fileName") || die("StudentRecordBase::polConv: Failed to open file $fileName\n");
  my $size = -s $fileName;
  my $text;
  read(IN,$text,$size);
  my $encoding="";
  $text=plConvertText2win($text,\$encoding);
  close(IN);
  if($encoding){
    open(OUT,">$fileName") || die("StudentRecordBase::polConv: Failed to open file $fileName\n");
    print OUT $text;
    close(OUT);
  }
  return $encoding;
}

##########################################
#
# Sortowanie z uwzgldnieniem polskich liter,
# akceptuje tak tablice jak i referencje do tablic
# Zwraca tablic(referencj) gdy argument jest tablic(referencj)
#
sub polSort{
  my $arrayToSortRef=(ref($_[0]) ? $_[0] : \@_); # referencja do tablicy, ktra ma by posortowana
  my $elementsToSort=@$arrayToSortRef;
  my @to_sort=();
  my ($i,$key,$index);
  for($i=0;$i<$elementsToSort;$i++){
    push(@to_sort,pol2code($arrayToSortRef->[$i]).":\t:".$i);
  }
  my @sorted=sort(@to_sort);
  my $resultArrayRef=[];
  for($i=0;$i<=$#sorted;$i++){
    ($key,$index)=split(":\t:",$sorted[$i]);
    push(@$resultArrayRef,$arrayToSortRef->[$index]);
  }
  return (ref($_[0]) ? $resultArrayRef : @$resultArrayRef);    #referencja do posortowanej tablicy
}




##########################################
#  sortowanie ( z uwzgldnieniem polskich liter)
#  kazdej tablicy w podanym hashu tablic
#
sub polSortHashOfArrays{
  my ($hashOfArraysRef)=@_;
  my $key;
  foreach $key (keys(%$hashOfArraysRef)){
    $hashOfArraysRef->{$key}=polSort($hashOfArraysRef->{$key});
  }
}

#########################################################################
