###############################
#
# modu programw pomocniczych
# (c) Marian Mrozek, Krakw - Nowy Scz 1996-2001
#  wersja 1.11 (2001.01.08)

package textUtil;

require Exporter;
@ISA = qw(Exporter);
@EXPORT = qw(normalizujKlucz kapitalizujKlucz kapitalizujNormalizujKlucz text2filename);

use polChar;

################################
#
# Funkcja normalizuje klucz wg nastepujacych zasad:
# 1) pierwsza litera maa
# 2) w miejsce cznika _ zmiana na du liter
# 3) litery ascii w miejsce polskich
#
sub normalizujKlucz{
  my ($klucz)=@_;
  if($klucz =~ /^(\w)(.*)$/){
    $klucz=lc($1).$2;
  }
  while($klucz =~ /^(.*)(_)(\w)(.*)$/){
    $klucz=$1.uc($3).$4;
  }
  $klucz = pol2ascii($klucz);
  return $klucz;
}

################################
#
# Funkcja normalizuje klucz wg nastepujacych zasad:
# 1) pierwsza litera dua
# 2) w miejsce cznika _ zmiana na du liter
# 3) litery ascii w miejsce polskich
#
sub kapitalizujNormalizujKlucz{
  my ($klucz)=@_;
  if($klucz =~ /^(\w)(.*)$/){
    $klucz=uc($1).$2;
  }
  while($klucz =~ /^(.*)(_)(\w)(.*)$/){
    $klucz=$1.uc($3).$4;
  }
  $klucz = pol2ascii($klucz);
  return $klucz;
}

################################
#
# Funkcja kapitalizuje klucz t.zn jeli pierwszy znak jest liter,
# zmienia go na duy
#
sub kapitalizujKlucz{
  my ($klucz)=@_;
  if($klucz =~ /^(\w)(.*)$/){
    $klucz=uc($1).$2;
  }
  return $klucz;
}

################################
#
# Funkcja zmienia tekst w co akceptowalnego
# jako nazwa pliku.
#
sub text2filename{
  my ($text)=@_;
  $text =~ s/ /+/g;
  $text =~ s/\//./g;
  $text =~ s//a/g;
  $text =~ s//c/g;
  $text =~ s//e/g;
  $text =~ s//l/g;
  $text =~ s//n/g;
  $text =~ s//o/g;
  $text =~ s//s/g;
  $text =~ s//z/g;
  $text =~ s//z/g;
  $text =~ s//A/g;
  $text =~ s//C/g;
  $text =~ s//E/g;
  $text =~ s//L/g;
  $text =~ s//N/g;
  $text =~ s//O/g;
  $text =~ s//S/g;
  $text =~ s//Z/g;
  $text =~ s//Z/g;
  return lc($text);
}
